package cn.haliaeetus.sendmessage;

import cn.haliaeetus.sendmessage.api.CustomRequestMappingHandlerMapping;
import cn.haliaeetus.sendmessage.interceptor.ApiInterceptor;
import org.springframework.boot.SpringBootConfiguration;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.servlet.config.annotation.InterceptorRegistry;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurationSupport;
import org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerMapping;

/**
 * @ClassName WebConfig
 * @Description 配置类，所有 bean 注入、配置、拦截器注入等都放在这个类里面
 * @Author kael
 * @Date 2019/6/24 0024 下午 15:36
 * @Version 1.0
 **/
@Configuration
@SpringBootConfiguration
public class WebConfig  extends WebMvcConfigurationSupport {

    @Bean
    public ApiInterceptor interceptor(){
        return new ApiInterceptor();
    }

    @Override
    protected void addInterceptors(InterceptorRegistry registry) {
        super.addInterceptors(registry);
        registry.addInterceptor(new ApiInterceptor());
    }

    @Override
    @Bean
    public RequestMappingHandlerMapping requestMappingHandlerMapping() {
        RequestMappingHandlerMapping handlerMapping = new CustomRequestMappingHandlerMapping();
        handlerMapping.setOrder(0);
        handlerMapping.setInterceptors(getInterceptors());
        return handlerMapping;
    }
}
