package cn.haliaeetus.sendmessage.bean;

import lombok.Data;

import java.io.Serializable;

/**
 * @ClassName ResultBean
 * @Description 统一管理bean，controller专用
 * @Author kael
 * @Date 2019/6/27 0027 上午 11:22
 * @Version 1.0
 **/
@Data
public class ResultBean<T> implements Serializable {

    private static final long serialVersionUID = 1L;

    public static final int NO_LOGIN = -1;

    public static final int SUCCESS = 0;

    public static final int FAIL = 1;

    public static final int NO_PERMISSION = 2;

    public static final int Existing = 3;

    private String msg = "请求成功";

    private int code = SUCCESS;

    private T data;

    public ResultBean() {
        super();
    }

    public ResultBean(T data) {
        super();
        this.data = data;
    }

    public ResultBean(Throwable e) {
        super();
        this.msg = e.toString();
        this.code = FAIL;
    }
}
