package cn.haliaeetus.sendmessage.bean.delivery;

import cn.haliaeetus.sendmessage.framework.entity.baseEntity.BaseEntity;
import cn.haliaeetus.sendmessage.framework.toolkit.Jsoned;
import cn.haliaeetus.sendmessage.framework.util.DateUtil;
import cn.haliaeetus.sendmessage.utils._;
import cn.haliaeetus.sendmessage.validate.constraints.UserPhonePattern;
import cn.haliaeetus.sendmessage.validate.groups.SendSms;
import com.google.gson.JsonObject;
import lombok.Data;

import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.util.Date;

@Data
public class Delivery extends BaseEntity implements Jsoned {
	private static final long serialVersionUID = 9203801284164491224L;

    @NotNull(message = "门店ID不能为空", groups = SendSms.class)
	private Integer storeId;

    @NotEmpty(message = "面单号不能为空", groups = SendSms.class)
    private String expcode;

    @NotNull(message = "快递公司ID不能为空", groups = SendSms.class)
    private Integer expId;

    private String shelfCode;

    private Integer shelfId;

    private String userName;

    @NotEmpty(message = "用户手机号不能为空", groups = SendSms.class)
    @UserPhonePattern
    private String userPhone;

    private String userpcas;

    private String userAddress;

    private Integer ischarge;

    private Integer chargeMoney;

    private Integer money;

    private Integer weight;

    private Integer payType;

    private String deliveryUid;

    private String deliveryUname;

    private String remark;

    private String oldOrderCode;

    private String odeliveryType;

    private Integer isdel;

    private Date createTime;

    @NotNull(message = "Status of delivery is null", groups = SendSms.class)
    private Integer status;

    private Date statusTime;

    private Integer problemType;

    private String problemCode;

    private Integer iswhite;

    private String revuserPhone;

    private String revexpCode;

    private String revshelfCode;

    private Integer fillType;

	private Integer signStatus;

	private Date signDtm;


	private Integer uploadStatus;

	private Date uploadDtm;

	private Integer returnSignStatus;

	private String signPhoneNumber;

	private String sendBackReason;

	/**
	 * 短信发送状态；// 状态 0:已发送, 1:成功, 2:失败
	 */
	private Integer smsStatus;
	/**
	 * 1.短信发送通道 2.微信发送通道 3.短信,微信都发送通道
	 */
	private Integer sendSuccessType;
	/**
	 * 短信发送失败原因
	 */
	private String resultInfo;
	/**
	 * 平台
	 */
	private String platform;

    public String picurl;

	@Override
	public JsonObject toJson() {
        JsonObject jsonObject = new JsonObject();

        jsonObject.addProperty("expcode", expcode);
        jsonObject.addProperty("expId", expId);
        jsonObject.addProperty("id", id);
        jsonObject.addProperty("money", _.parseMoney(money));
        jsonObject.addProperty("chargeMoney", _.parseMoney(chargeMoney));
        //jsonObject.addProperty("isModify", isModify);
        jsonObject.addProperty("odeliveryType", odeliveryType);
        /*try {
            if(expName==null && expId!=0){
                ExpressType expressType = ExpressType.expressIdMap.get(expId);
                expName = expressType == null?"":expressType.expName;
            }
            jsonObject.addProperty("expName", trimToEmpty(expName));
        } catch (Exception e) {
            e.printStackTrace();
        }*/
        jsonObject.addProperty("shelfCode", shelfCode);
        jsonObject.addProperty("shelfId", shelfId);

       /* try {
            if(shelfName==null && shelfId!=0){
                StoreShelf shelf = StoreShelf.getById(shelfId);
                shelfName = shelf == null ? "" : shelf.shelfName;
            }
            jsonObject.addProperty("shelfName", isEmpty(shelfName)?"":shelfName);
        } catch (Exception e) {
            e.printStackTrace();
        }*/
        jsonObject.addProperty("deliveryUid", deliveryUid);
        jsonObject.addProperty("deliveryUname", _.trimToEmpty(deliveryUname));
        jsonObject.addProperty("userName", _.trimToEmpty(userName));
        jsonObject.addProperty("userPhone", _.trimToEmpty(userPhone));
        jsonObject.addProperty("createTime", DateUtil.timestampFormat(createTime));
        jsonObject.addProperty("statusTime", DateUtil.timestampFormat(statusTime));
        jsonObject.addProperty("status", status);
		jsonObject.addProperty("picurl", picurl);
        return jsonObject;
	}
}