package cn.haliaeetus.sendmessage.bean.delivery;

import cn.haliaeetus.sendmessage.bean.basedata.Store;
import cn.haliaeetus.sendmessage.bean.basedata.StoreStaff;
import cn.haliaeetus.sendmessage.validate.groups.SendSms;

import javax.validation.Valid;
import javax.validation.constraints.NotNull;
import java.util.Date;


public class DeliveryInfo {
    @NotNull(message = "Delivery is null.", groups = SendSms.class)
    @Valid
    private Delivery delivery;

    private Date instoreDate;

    @NotNull(message = "DeliveryStatus is null.", groups = SendSms.class)
    private DeliveryStatus deliveryStatus;

    private Delivery oldDelivery;

    @NotNull(message = "StoreInfo is null.", groups = SendSms.class)
    private Store store;
    
    private StoreStaff storeStaff;

    public DeliveryInfo(Delivery delivery, DeliveryStatus deliveryStatus, Delivery oldDelivery) {
        this(delivery, deliveryStatus);
        this.oldDelivery = oldDelivery;
    }

    public DeliveryInfo(Delivery delivery, DeliveryStatus deliveryStatus) {
        this.delivery = delivery;
        this.deliveryStatus = deliveryStatus;
    }

    public DeliveryInfo(Delivery delivery, DeliveryStatus deliveryStatus, Store store, StoreStaff storeStaff) {
        this.delivery = delivery;
        this.deliveryStatus = deliveryStatus;
        this.store = store;
        this.storeStaff = storeStaff;
    }


    public Delivery getDelivery() {
        return delivery;
    }

    public void setDelivery(Delivery delivery) {
        this.delivery = delivery;
    }

    public Date getInstoreDate() {
        return instoreDate;
    }

    public void setInstoreDate(Date instoreDate) {
        this.instoreDate = instoreDate;
    }

    public DeliveryStatus getDeliveryStatus() {
        return deliveryStatus;
    }

    public void setDeliveryStatus(DeliveryStatus deliveryStatus) {
        this.deliveryStatus = deliveryStatus;
    }

    public Delivery getOldDelivery() {
        return oldDelivery;
    }

    public void setOldDelivery(Delivery oldDelivery) {
        this.oldDelivery = oldDelivery;
    }

    public Store getStore() {
        return store;
    }

    public void setStore(Store store) {
        this.store = store;
    }

    public StoreStaff getStoreStaff() {
		return storeStaff;
	}

	public void setStoreStaff(StoreStaff storeStaff) {
		this.storeStaff = storeStaff;
	}

	@Override
    public String toString() {
        return "DeliveryInfo{" +
                "delivery=" + delivery +
                ", instoreDate=" + instoreDate +
                ", deliveryStatus=" + deliveryStatus +
                ", oldDelivery=" + oldDelivery +
                ", store=" + store +
                ", storeStaff=" + storeStaff +
                '}';
    }
}