package cn.haliaeetus.sendmessage.bean.delivery;

import cn.haliaeetus.sendmessage.framework.log.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import javax.annotation.PostConstruct;
import java.util.ArrayList;
import java.util.List;

@Component
public class DeliveryMsgFilterChain {
    private static final Logger LOG = Logger.getInstance(DeliveryMsgFilterChain.class);

    @Autowired
    private DeliveryMsgShelfChangeFilter shelfChangeFilter;

    @Autowired
    private DeliveryMsgWhiteListFilter whiteListFilter;

    private List<DeliveryMsgFilter> filters = new ArrayList<>();

    @PostConstruct
    public void initFilters() {
        //是否允许营业时间外发送短信
        //filters.add(shelfChangeFilter);
        //是否允许白名单用户发送短信
        //filters.add(whiteListFilter);
        LOG.record("Initialize delivery msg filters finish.");
    }

    /**
     * 根据派件信息过滤是否需要发送短信
     * @param deliveryInfo 派件信息
     * @return true：需要发送，false：不需要发送
     */
    public boolean doFilters(DeliveryInfo deliveryInfo) {
        if (filters.size() > 0){
            for (DeliveryMsgFilter filter : filters) {
                if (!filter.doFilter(deliveryInfo)) {
                    return false;
                }
            }
        }
        return true;
    }
}