package cn.haliaeetus.sendmessage.bean.delivery;

import cn.haliaeetus.sendmessage.framework.log.Logger;
import cn.haliaeetus.sendmessage.service.WhiteListService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

@Component
class DeliveryMsgWhiteListFilter implements DeliveryMsgFilter {
    private static final Logger LOG = Logger.getInstance(DeliveryMsgWhiteListFilter.class);

    @Autowired
    private WhiteListService whiteListService;

    /**
     * 若派件信息中收件人手机号命中白名单，不需要发送短信
     * @param deliveryInfo 派件信息
     * @return true：需要发送，false：不需要发送
     */
    @Override
    public boolean doFilter(DeliveryInfo deliveryInfo) {
        //现在允许手机号白名单发送短信，下面代码逻辑为白名单不需要发短信
        return true;
        /*if (!DeliveryInfoUtil.isValidDeliveryInfo(deliveryInfo)) {
            return false;
        }

        List<WhiteList> whiteList = whiteListService.getByPhoneStoreId(deliveryInfo.getDelivery().getUserPhone(),
                deliveryInfo.getDelivery().getStoreId());
        if (_.isNotEmpty(whiteList)) {
            LOG.record(String.format("Msg send filtered by DeliveryMsgWhiteListFilter, %s, %s.", whiteList, deliveryInfo));
            return false;
        }*/
    }
}