package cn.haliaeetus.sendmessage.bean.express;

import lombok.Data;

/**
 * @ClassName YuantongReturnBean
 * @Description 通知回执接口
 * @Author kael
 * @Date 2019/7/5 0005 下午 17:04
 * @Version 1.0
 **/
@Data
public class YuantongReturnBean {

    /**
     *  运单号
     */
    private String waybillNo;
    /**
     * 驿站编号
     */
    private String stationCode;
    /**
     * 客户渠道编码
     */
    private String customerCode;
    /**
     * 上一网点编号
     */
    private String previousOrgCode = "999999";

    /**
     * 所属网点编号
     */
    private String orgCode = "999999";
    /**
     * 快递公司编号：BLC00001
     */
    private String logisticsCode = "BLC00001";
    /**
     * 回执方式：DX（短信）/YY（语音）/（WX）微信，通知
     * 方式只能是三种中的一种
     */
    private String receiptType = "DX";

    /**
     * 回执结果：1：失败，0：成功
     */
    private String receiptResult = "0";

    /**
     * 当回执结果为1(失败)时，失败原因必填
     */
    private String receiptFailReason = "";
    /**
     * 操作时间
     */
    private String opTime;
    /**
     * 回执时间
     */
    private String receiptTime;
    /**
     * 备用字段
     */
    private String reserve1 = "reserve1";
    /**
     * 备用字段
     */
    private String reserve2 = "reserve2";
    /**
     * 备用字段
     */
    private String Reserve3 = "reserve3";

}
