package cn.haliaeetus.sendmessage.bean.express.jitu;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @author liujs
 * @desc 极兔快递扫描实体类
 */
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class JiTuDeliveryCabinetDTO {
    /**
     * 运单编号
     */
    private String waybillId;
    /**
     * 扫描时间
     * 格式(yyyy-MM-dd HH:mm:ss)
     */
    private String scanTime;
    /**
     * 扫描PDA编号（15位，测试联调时用：CS0000000001001，正式待联调发放）
     */
    private String scanPda;
    /**
     * 签收人（非必填）
     */
    private String signer;
    /**
     * 签收图片url（非必填）
     */
    private String sigPicUrl;
    /**
     * 扫描类型编码:  5:驿站/6:柜机
     */
    private String scanSourceCode;
    /**
     * 扫描类型名称, 驿站/柜机
     */
    private String scanSourceName;
    /**
     * 收派员id （非必填）
     */
    private Integer deliveryBy;
    /**
     * 收派员编码（非必填）
     */
    private String deliveryCode;
    /**
     * 收派员姓名（柜机时必填）（非必填）
     */
    private String deliveryName;
    /**
     * 收派员电话（手机号/固话）,柜机时必填（非必填）
     */
    private String deliveryPhone;
    /**
     * 驿站联系方式（手机号/固话）,驿站是必填（非必填）
     */
    private String stationContact;
    /**
     * 自提柜合作公司品牌名，如“丰巢”（合作伙伴名称）
     */
    private String partnerName;
    /**
     * 当前城市（二级地址，如：杭州市）
     */
    private String city;
    /**
     * 快递柜站点:【地址】+【XXX驿站/柜】
     * 如：顶琇国际城A区1栋2单元架空层丰巢快递柜
     */
    private String expressCabinet;
    /**
     * 操作来源
     */
    private Integer operationSource;
}
