package cn.haliaeetus.sendmessage.bean.express.shentong;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @author liujs
 * @desc 申通注册和修改门店信息接口
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class ShenTongBean {
    /**
     * 网点编号
     * 100--驿站；200--快递柜
     */
    private int type;
    /**
     * 驿站/快递柜编号
     */
    private String code;
    /**
     * 驿站/快递柜名称
     */
    private String name;
    /**
     * 国家标准省编号
     */
    private String provinceCode;
    /**
     * 国家标准市编号
     */
    private String cityCode;
    /**
     * 国家标准区/县编号
     */
    private String areaCode;
    /**
     * 详细地址
     */
    private String address;
    /**
     * 高德坐标经度
     */
    private String longitude;
    /**
     * 高德坐标纬度
     */
    private String latitude;
    /**
     * 联系人
     */
    private String contactName;
    /**
     * 联系方式
     */
    private String contactPhone;
    /**
     * 办公电话
     */
    private String officePhone;
    /**
     * 备注
     */
    private String remark;
    /**
     * 状态
     * 100--启用，200--停用
     */
    private int status;
    /**
     * 菜鸟品牌编号
     */
    private String brandCode;
}
