package cn.haliaeetus.sendmessage.bean.express.shentong;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @author liujs
 * @desc 申通末端信息实体类
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class ShenTongEndpointInfoBean {
    /**
     * 网点编号：100-驿站，200-快递柜(必填)
     * 示例：100
     */
    private Integer type;
    /**
     * 驿站/快递柜编号(必填)
     * 示例：10001
     */
    private String code;
    /**
     * 驿站/快递柜名称(必填)
     * 示例：xx小区xx驿站
     */
    private String name;
    /**
     * 国家标准省编号(必填)
     * 示例：110000
     */
    private String provinceCode;
    /**
     * 国家标准市编号(必填)
     * 示例：110100
     */
    private String cityCode;
    /**
     * 国家标准区/县编号(必填)
     * 示例：110101
     */
    private String areaCode;
    /**
     * 详细地址(必填)
     * 示例：xx镇xx路xx小区
     */
    private String address;
    /**
     * 高德坐标经度(必填)
     * 示例：121.292743
     */
    private String longitude;
    /**
     * 高德坐标纬度(必填)
     * 示例：31.436394
     */
    private String latitude;
    /**
     * 联系人(非必填)
     * 示例：张xx
     */
    private String contactName;
    /**
     * 联系方式(非必填)
     * 示例：18111111111
     */
    private String contactPhone;
    /**
     * 办公电话(非必填)
     * 示例：18111111111
     */
    private String officePhone;
    /**
     * 备注(非必填)
     * 示例：xx备注
     */
    private String remark;
    /**
     * 状态：100-启用，2-停用(必填)
     * 示例：100
     */
    private Integer status;
    /**
     * 菜鸟品牌编号(必填)
     * 示例：TONGDIYIYOU
     */
    private String brandCode;
}
