package cn.haliaeetus.sendmessage.bean.express.shentong;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @author liujs
 * @desc 申通请求实体类
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class ShenTongRequestBean {
    /**
     * 订阅方/请求发起方的应用key
     */
    private String from_appkey;
    /**
     * 订阅方/请求发起方的应用资源code
     */
    private String from_code;
    /**
     * 注册方应用key
     */
    private String to_appkey;
    /**
     * 注册方应用key
     */
    private String to_code;
    /**
     * 报文加密密钥
     */
    private String secretKey;
    /**
     * 报文签名
     */
    private String data_digest;
    /**
     * API名称
     */
    private String api_name;
    /**
     * 业务报文内容
     */
    private String content;
    /**
     * 调用第三方API地址
     */
    private String url;
}
