package cn.haliaeetus.sendmessage.bean.express.shentong;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @author liujs
 * @desc 申通注册和修改门店信息接口
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class ShenTongScanRecordDtoBean {
    /**
     * 运单号
     * 示例： STO018972963
     */
    private String waybillNo;
    /**
     * 固定值：793
     * 示例： 793
     */
    private String opCode;
    /**
     * 驿站订单号 (非必填)
     * 示例： 777007148239937
     */
    private String cnOrderCode;
    /**
     * 驿站描述信息：标准展示信息（请按此格式展示）:
     * 门店代收：快件已被【XX】迎春街六中旁边迎春街站点代收，请及时取件。有问题请联系XXXXXXXXXX
     * 客户签收：已签收，签收人凭取货码签收 第三方代派：【第三方名称】小件员【姓名】正在为您派件，如有疑问请联系小件员，联系电话【（手机、座机XXX-XXXXXXX）】
     * 示例： 快递已被【丰巢智能柜】上海市金山区电力公司大门口左侧1号丰巢快递柜代收，请及时取件。有问题请联系19145528513
     */
    private String desc;
    /**
     * 驿站数据类型，STA_INBOUND：入库 ;STA_SIGN：客户签收 ; STA_BUYER_REJECT：客户拒收 ;STA_STATION_REJECT：驿站拒收  STA_MOVE_PACK：移库 STA_STATION_RETURN：驿站退回
     *              STA_INBOUND_CANCEL：取消入库 ; STA_DILIVERY：黑土共配的派件;STA_MAILMAN_PICKUP：快递员取出;  STA_COMMUNICATE：联系客户;STA_DELIVERY：第三方代派;STA_ADMIN_PICKUP：管理员取出
     * 示例： STA_INBOUND
     */
    private String action;
    /**
     * 驿站当前城市
     * 示例： 上海市
     */
    private String city;
    /**
     * 驿站门店/自提柜名称
     * 示例： 上海市金山区电力公司大门口左侧1号丰巢快递柜
     */
    private String stationName;
    /**
     * 驿站门店/自提柜联系方式
     * 示例： 4000633333
     */
    private String stationContact;
    /**
     * 驿站门店/自提柜站点ID
     * 示例： FC0217633
     */
    private String stationId;
    /**
     * 驿站门店/自提柜站点类型，这里统一传1
     * 示例： 1
     */
    private String stationSource;
    /**
     * 驿站门店/自提柜合作公司品牌名，如“速递易”（合作伙伴名称）
     * 示例： 丰巢智能柜
     */
    private String partnerName;
    /**
     * 驿站接收人人电话(非必填)
     * 示例： 13112345678
     */
    private String receiverPhone;
    /**
     * 驿站时间（格式：yyyy-mm-dd hh:mm:ss）
     * 示例： 2019-12-19 10:31:12
     */
    private String time;
    /**
     * 代收点取件码。Action为STA_INBOUND,STA_MOVE_PACK必填
     * 示例： 345678
     */
    private String authCode;
}
