package cn.haliaeetus.sendmessage.bean.express.station;

import lombok.Data;
import lombok.experimental.SuperBuilder;

/**
 * @PackageName: cn.haliaeetus.sendmessage.bean.express.station
 * @ClassName: ExpressStationBean
 * @Author: LiuJS
 * @Description: 快递站点实体类
 * @Date: 2020/8/13 10:02
 * @Version: 1.0
 */
@Data
@SuperBuilder
public class ExpressAgentsBean {
    /**
     * 目的码
     */
    protected String toCode;
    /**
     * 代理点编号
     */
    protected String agentCode;
    /**
     * 说明：代理点在圆通快递的驿站编号
     */
    protected String ytStationCode;
    /**
     * 代理点名称
     */
    protected String agentName;
    /**
     * 代理点类型：station（驿站），cabinet（快递柜）,other（其他）
     */
    protected String agentType;
    /**
     * 代理点负责人
     */
    protected String agentOwner;
    /**
     * 代理点负责人电话
     */
    protected String agentOwnerPhone;
    /**
     * 代理点办公电话
     */
    protected String agentOfficePhone;
    /**
     * 代理点营业时间 09:00-21:00
     */
    protected String agentBusinessTime;
    /**
     * 代理点状态:open（使用中）,close(已停用)
     */
    protected String agentState;
    /**
     * 代理点所在省编号（按国家标准行政名称）
     */
    protected String provinceCode;
    /**
     * 代理点所在省名称（按国家标准行政名称）
     */
    protected String provinceName;
    /**
     * 代理点所在市编号（按国家标准行政名称）
     */
    protected String cityCode;
    /**
     * 代理点所在市名称（按国家标准行政名称）
     */
    protected String cityName;
    /**
     * 代理点所在区/县编号（按国家标准行政名称）
     */
    protected String areaCode;
    /**
     * 代理点所在区/县名称（按国家标准行政名称）
     */
    protected String areaName;
    /**
     * 代理点详细地址
     */
    protected String agentAddress;
    /**
     * 经度 最大值：135.050000 最小值：73.330000
     */
    protected String longitude;
    /**
     * 纬度 最大值：53.330000 最小值：3.510000
     */
    protected String latitude;

}
