package cn.haliaeetus.sendmessage.bean.express.trace;

import cn.haliaeetus.sendmessage.bean.express.station.ExpressAgentsBean;
import lombok.Data;
import lombok.experimental.SuperBuilder;

/**
 * @PackageName: cn.haliaeetus.sendmessage.bean.express.trace
 * @ClassName: ExpressTracePushBean
 * @Author: LiuJS
 * @Description: 快递物流信息推送实体类
 * @Date: 2020/8/13 18:00
 * @Version: 1.0
 */
@Data
@SuperBuilder
public class ExpressTracePushBean extends ExpressAgentsBean {
    /**
     * 快递单号
     */
    private String expressCode;
    /**
     * 快递操作类型
     * STA_INBOUND   STA_SIGN     STA_BUYER_REJECT
     */
    private String operationType;
    /**
     * 快递签收失败原因编号
     */
    private String deliveryFallReasonCode;
    /**
     * 快递签收失败原因
     */
    private String deliveryFallReason;
    /**
     * 快递入库或者签收时间
     */
    private String expressTime;
    /**
     * 快递所在货架号
     */
    private String shelfCode;
    /**
     * 快递取件码
     */
    private String takeCode;
    /**
     * 收件人姓名
     */
    private String receiverName;
    /**
     * 收件人电话
     */
    private String receiverPhone;
    /**
     * 备注
     */
    private String remark;
}
