package cn.haliaeetus.sendmessage.bean.express.yuantong;

import lombok.Data;

/**
 * @ClassName YTOOperData
 * @Description
 * @Author SunJJ
 * @Date 2021/3/9 16:35
 * @Version V1.0
 **/
@Data
public class YTOOperData {

    /**
     * 18
     * 是
     * 单号
     */
    private String waybillNo;
    /**
     * 20
     * 是
     * 圆通终端编码
     */
    private String stationCode;
    /**
     * 11  是终端品牌编码(提供
     * )
     */
    private String customerCode;
    /**
     * 20
     * 是
     * 操作时间
     * 格式：yyyy-MM-dd HH:mm:ss
     */
    private String opTime;

    /**
     * 20
     * 是
     * 操作类型
     * 入库入柜/STA_INBOUND
     * 用户签收/STA_SIGN
     * 异常出库出柜/STA_MAILMAN_PICKUP
     */
    private String action;


    /**
     * 20
     * 否
     * 取货码
     * 入库入柜操作时必填
     */
    private String takeCode;

    /**
     * 15
     * 否
     * 收件人手机
     * 入柜库操作时必填
     * 收件人手机格式：
     * 1、座机号：0或8开头的3-4位区号，有-没-都行，后面跟上7-8位的电话号码，如021-11223344 、02111223344 、0527-1234567 、8234-12345678
     * 2、手机号：+86或86开头或没86开头，后面接1拼上10位任意数字组合。如+8613812345678 、13812345678 、8613812345678。
     * 3.脱敏手机格式：*******1234,135****3456
     */
    private String recipientPhone;

    /**
     * 20
     * 否
     * 通知方式
     * 微信/WX
     * 短信/DX
     * 语音/YY
     * 入库入柜操作时必填
     */
    private String noticeType;

    /**
     * 150
     * 否
     * 通知内容
     * 入库入柜操作时必填
     */
    private String noticeContent;

    /**
     * 20  否异常原因编码(参考1.4.2）
     * )
     */
    private String failCode;
    /**
     * 150  否异常原因(参考1.4.2）
     * )
     */
    private String failReason;
    /**
     * 150
     * 否
     * 备注
     */
    private String desc;
}
