package cn.haliaeetus.sendmessage.bean.jhy;

import cn.haliaeetus.sendmessage.framework.entity.baseEntity.BaseEntity;
import lombok.Data;

import java.util.Date;

/**
 * 居欢颜电话号码
 * @author kael
 */
@Data
public class JhyPhone extends BaseEntity {

    private Integer storeId;

    private String phone;

    private Date createTime;

    private Date updateTime;

    private Integer isEnable;

    public JhyPhone(){

    }
    public JhyPhone(Builder builder) {
        this.phone = builder.phone;
        this.storeId = builder.storeId;
        this.isEnable = builder.isEnable;
        this.createTime = builder.createTime;
        this.updateTime = builder.updateTime;
    }

    public static class Builder{
        private Integer storeId;

        private String phone;

        private Date createTime;

        private Date updateTime;

        private Integer isEnable;

        public Builder() {
        }

        public Builder setStoreId(Integer storeId) {
            this.storeId = storeId;
            return this;
        }

        public Builder setPhone(String phone) {
            this.phone = phone;
            return this;
        }

        public Builder setCreateTime(Date createTime) {
            this.createTime = createTime;
            return this;
        }

        public Builder setUpdateTime(Date updateTime) {
            this.updateTime = updateTime;
            return this;
        }

        public Builder setIsEnable(Integer isEnable) {
            this.isEnable = isEnable;
            return this;
        }

        /**
         * 最终构建方法，返回一个 PersonTree 对象，参数是当前 Builder 对象
         * @return
         */
        public JhyPhone build(){
            return new JhyPhone(this);
        }
    }
}