package cn.haliaeetus.sendmessage.bean.jhy;

import lombok.Data;

/**
 * @ClassName JhyPhonePushRequest
 * @Description TODO
 * @Author kael
 * @Date 2019/8/6 0006 上午 10:18
 * @Version 1.0
 **/
@Data
public class JhyPhonePushRequest {

    /**
     * 取件码
     */
    private String pickup_code;
    /**
     * 快递公司id
     */
    private String express_id;
    /**
     * 快递公司名称
     */
    private String express_name;
    /**
     * 运单号码
     */
    private String waybill_num;
    /**
     * 快递员手机号码
     */
    private String delivery_phone;
    /**
     * 蜂站站点Id
     */
    private String fz_site_id;
    /**
     * 蜂站站点名称
     */
    private String fz_site_name;
    /**
     * 取件地址
     */
    private String pickup_address;
    /**
     * 取件人手机号码
     */
    private String pickup_phone;


    public static final class Builder {
        private String pickup_code;
        private String express_id;
        private String express_name;
        private String waybill_num;
        private String delivery_phone;
        private String fz_site_id;
        private String fz_site_name;
        private String pickup_address;
        private String pickup_phone;

        public Builder() {
        }

        public static Builder aJhyPhonePushRequest() {
            return new Builder();
        }

        public Builder withPickup_code(String pickup_code) {
            this.pickup_code = pickup_code;
            return this;
        }

        public Builder withExpress_id(String express_id) {
            this.express_id = express_id;
            return this;
        }

        public Builder withExpress_name(String express_name) {
            this.express_name = express_name;
            return this;
        }

        public Builder withWaybill_num(String waybill_num) {
            this.waybill_num = waybill_num;
            return this;
        }

        public Builder withDelivery_phone(String delivery_phone) {
            this.delivery_phone = delivery_phone;
            return this;
        }

        public Builder withFz_site_id(String fz_site_id) {
            this.fz_site_id = fz_site_id;
            return this;
        }

        public Builder withFz_site_name(String fz_site_name) {
            this.fz_site_name = fz_site_name;
            return this;
        }

        public Builder withPickup_address(String pickup_address) {
            this.pickup_address = pickup_address;
            return this;
        }

        public Builder withPickup_phone(String pickup_phone) {
            this.pickup_phone = pickup_phone;
            return this;
        }

        public JhyPhonePushRequest build() {
            JhyPhonePushRequest jhyPhonePushRequest = new JhyPhonePushRequest();
            jhyPhonePushRequest.setPickup_code(pickup_code);
            jhyPhonePushRequest.setExpress_id(express_id);
            jhyPhonePushRequest.setExpress_name(express_name);
            jhyPhonePushRequest.setWaybill_num(waybill_num);
            jhyPhonePushRequest.setDelivery_phone(delivery_phone);
            jhyPhonePushRequest.setFz_site_id(fz_site_id);
            jhyPhonePushRequest.setFz_site_name(fz_site_name);
            jhyPhonePushRequest.setPickup_address(pickup_address);
            jhyPhonePushRequest.setPickup_phone(pickup_phone);
            return jhyPhonePushRequest;
        }
    }
}
