package cn.haliaeetus.sendmessage.bean.jhy.filter;

import cn.haliaeetus.sendmessage.framework.base.digt.Md5Util;
import lombok.Data;

/**
 * @ClassName JhyPhoneFilter
 * @Description 过滤
 * @Author kael
 * @Date 2019/8/5 0005 上午 10:19
 * @Version 1.0
 **/
@Data
public class JhyPhoneFilter {
    private String phone;
    private Integer storeId;
    private Integer isEnable = 0;

    public JhyPhoneFilter(Builder builder) {
        this.phone = builder.phone;
        this.storeId = builder.storeId;
        this.isEnable = builder.isEnable;
    }

    public static class Builder{
        private String phone;
        private Integer storeId;
        private Integer isEnable = 0;

        public Builder(String phone) {
            this.phone = phone;
        }
        public Builder setStoreId(Integer storeId) {
            this.storeId = storeId;
            return this;
        }
        public Builder setIsEnable(Integer isEnable) {
            this.isEnable = isEnable;
            return this;
        }

        /**
         * 最终构建方法，返回一个 PersonTree 对象，参数是当前 Builder 对象
         * @return
         */
        public JhyPhoneFilter build(){
            return new JhyPhoneFilter(this);
        }
    }
}
