package cn.haliaeetus.sendmessage.bean.mengwang;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @PackageName: com.bs.logisticslnfoapi.bean.smsplatform.mengwang
 * @ClassName: MengWangSendSmsBean
 * @Description: 梦网发送短信实体类
 * @Author: liujs
 * @Date: 2020/05/20 下午 14:53
 * @Version: 1.0
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class MengWangSendSmsBean {
    /**
     * 用户账号：长度最大6个字符
     * 示例：J10003
     */
    private String userid;
    /**
     * 用户密码：定长小写32位字符
     * 示例：密码明文模式：111111   密码加密模式：26dad7f364507df18f3841cc9c4ff94d
     */
    private String pwd;
    /**
     * 短信接收的手机号：只能填一个手机号
     * 示例：138xxxxxxxx
     */
    private String mobile;
    /**
     * 时间戳：24小时制格式：MMDDHHMMSS,即月日时分秒，定长10位,月、日、时、分、秒每段不足2位时左补0，密码选择MD5加密方式时必填该参数
     * 示例：0803192020
     */
    private String timestamp;
    /**
     * 短信内容：最大支持1000个字(含签名)，发送时请预留至少10个字符的签名长度，一个字母或一个汉字都视为一个字符
     * 编码方式：urlencode（GBK明文）
     * 示例：短信内容：“验证码：6666，打死都不要告诉别人哦！”
     * 短信内容进行urlencode编码后：%d1%e9%d6%a4%c2%eb%a3%ba6666%a3%ac%b4%f2%cb%c0%b6%bc%b2%bb%d2%aa%b8%e6%cb%df%b1%f0%c8%cb%c5%b6%a3%a1
     */
    private String content;
    /**
     * 业务类型：最大可支持10个长度的英文字母、数字组合的字符串
     * 示例：SMS001
     */
    private String svrtype;
    /**
     * 扩展号：长度不能超过6位，注意通道号+扩展号的总长度不能超过20位，若超出则exno无效
     * 示例：0006
     */
    private String exno;
    /**
     * 用户自定义流水号：该条短信在您业务系统内的ID，比如订单号或者短信发送记录的流水号。填写后发送状态返回值内将包含用户自定义流水号。
     * 最大可支持64位的ASCII字符串：字母、数字、下划线、减号
     * 示例：b3d0a2783d31b21b8573
     */
    private String custid;
    /**
     * 自定义扩展数据：额外提供的最大64个长度的ASCII字符串：字母、数字、下划线、减号，作为自定义扩展数据，填写后，状态报告返回时将会包含这部分数据
     */
    private String exdata;
}
