package cn.haliaeetus.sendmessage.constants;

import java.util.HashMap;
import java.util.Locale;
import java.util.Map;
import java.util.ResourceBundle;


/**
 * <p>
 * 常量类
 * </p>
 *
 * @author sqj
 * @version 1.0
 * @since 1.0
 */
public class Constants {
    /**
     * 是
     */
    public static final int YES = 1;
    /**
     * 否
     */
    public static final int NO = 0;
    
    // ------门店状态------
    /**
     * 未开
     */
    public static final int STORE_STATUS_NOT_OPEN = 0;
    /**
     * 已开
     */
    public static final int STORE_STATUS_OPENED = 1;
    /**
     * 废弃
     */
    public static final int STORE_STATUS_ABANDONED = 2;

    // ------业务类型------
    /**
     * 揽件
     */
    public static final int BUSINESS_TYPE_RECEIVED = 1;
    /**
     * 派件
     */
    public static final int BUSINESS_TYPE_DELIVERY = 2;

    // ----派件订单信息完善类型类型----
    /**
     * 快递
     */
    public static final int ORDER_FILL_TYPE_EXPRESS = 1;
    /**
     * 门店
     */
    public static final int ORDER_FILL_TYPE_STORE = 2;
    /**
     * 菜鸟
     */
    public static final int ORDER_FILL_TYPE_CAI_NIAO = 3;
    /**
     * P2P Access
     */
    public static final int ORDER_FILL_TYPE_P2PA = 4;

    // ----派件订单派送类型----
    /**
     * 自提
     */
    public static final String ORDER_SEND_TYPE_ZT = "ZI";
    /**
     * 配送
     */
    public static final String ORDER_SEND_TYPE_PS = "PS";
    /**
     * P2P
     */
    public static final String ORDER_SEND_TYPE_P2P = "P2P";

    // ----派件订单状态----
    /**
     * 未到货
     */
    public static final int ORDER_STATUS_AFLOAT = 120;
    /**
     * 待入库
     */
    public static final int ORDER_STATUS_WAIT_IN_STORE = 245;
    /**
     * 已入库
     */
    public static final int ORDER_STATUS_STORED = 122;
    /**
     * 外出配送已分配
     */
    public static final int ORDER_STATUS_DISPATCHING = 124;
    /**
     * 麦客配送中
     */
    public static final int ORDER_STATUS_MAIKE_DISPATCHING = 125;
    /**
     * 已完成
     */
    public static final int ORDER_STATUS_COMPLETE = 126;
    /**
     * 离库
     */
    public static final int ORDER_STATUS_LEAVE_STORE = 246;
    /**
     * 拒收离库
     */
    public static final int ORDER_STATUS_REJECT_LEAVE_STORE = 130;
    /**
     * 拒收在库
     */
    public static final int ORDER_STATUS_REJECT_PICK_UP = 128;

    /**
     *   滞留状态
     */
    public static final int ORDER_STATUS_REJECT_RETENTION = 225;

    // ----客户端类型----
    /**
     * 门店
     */
    public static final int CLIENT_TYPE_STORE = 1;
    /**
     * 巴枪
     */
    public static final int CLIENT_TYPE_BA_QIANG = 2;
    /**
     * App
     */
    public static final int CLIENT_TYPE_APP = 3;
    /**
     * BS
     */
    public static final int CLIENT_TYPE_BS = 4;
    /**
     * 门店精简版
     */
    public static final int CLIENT_TYPE_STORE_LITE = 5;
    /**
     * BS2.0
     */
    public static final int CLIENT_TYPE_BS_2 = 6;
    /**
     * 门店精简版2.0
     */
    public static final int CLIENT_TYPE_STORE_LITE_2 = 7;

    // ----客户支付类型----
    /**
     * 在线支付
     */
    public static final int CUST_PAY_TYPE_ONLINE = 169;
    /**
     * 货到付款
     */
    public static final int CUST_PAY_TYPE_DELIVERY = 170;
    /**
     * 银行电汇
     */
    public static final int CUST_PAY_TYPE_BANK = 171;
    /**
     * 现金支付
     */
    public static final int CUST_PAY_TYPE_CASH = 212;
    /**
     * 支付宝支付
     */
    public static final int CUST_PAY_TYPE_ZFB = 213;
    /**
     * 微信支付
     */
    public static final int CUST_PAY_TYPE_WX = 214;

    // ----支付类型----
    /**
     * 未支付
     */
    public static final int PAY_TYPE_NOT_PAY = 129;
    /**
     * 在线支付
     */
    public static final int PAY_TYPE_ONLINE = 130;
    /**
     * 现金支付
     */
    public static final int PAY_TYPE_CASH = 131;
    /**
     * POS刷卡支付
     */
    public static final int PAY_TYPE_POS = 132;

    // ----快递类型----
    /**
     * 韵达
     */
    public static final int EXPRESS_TYPE_YD = 17;
    /**
     * 顺丰
     */
    public static final int EXPRESS_TYPE_SF = 18;
    /**
     * 联邦
     */
    public static final int EXPRESS_TYPE_FEDEX = 19;
    /**
     * 易讯
     */
    public static final int EXPRESS_TYPE_YX = 67;
    /**
     * 当当
     */
    public static final int EXPRESS_TYPE_DD = 186;
    /**
     * 中通
     */
    public static final int EXPRESS_TYPE_ZT = 187;
    /**
     * 圆通
     */
    public static final int EXPRESS_TYPE_YT = 202;
    /**
     * 蘑菇街
     */
    public static final int EXPRESS_TYPE_MGJ = 204;
    /**
     * 汇通
     */
    public static final int EXPRESS_TYPE_HTKY = 223;
    /**
     * 一米鲜
     */
    public static final int EXPRESS_TYPE_XIAN = 256;
    /**
     * 佰颂物联商城
     */
    public static final int EXPRESS_TYPE_RETA = 260;
    /**
     * 苏宁
     */
    public static final int EXPRESS_TYPE_SUNING = 203;
    /**
     * 如风达
     */
    public static final int EXPRESS_TYPE_RUFENGDA = 271;
    /**
     * 邮政特快专递
     */
    public static final int EXPRESS_TYPE_YOUZHENG_EMS = 243;
    /**
     * 邮政小包
     */
    public static final int EXPRESS_TYPE_YOUZHENG_PSP = 244;

    // ----派件出库类型----
    /**
     * 自提出库
     */
    public static final int OUTSTORE_TYPE_SELF = 189;
    /**
     * 外出配送
     */
    public static final int OUTSTORE_TYPE_DISPATCH = 190;

    // ----派件信息模板类型----
    /**
     * 短信
     */
    public static final int MSG_TYPE_SMS = 1;
    /**
     * 微信
     */
    public static final int MSG_TYPE_WEIXIN = 2;
    /**
     * app
     */
    public static final int MSG_TYPE_APP = 3;

    /**
     * 门店默认最早营业时间
     */
    public static final String STORE_DEFAULT_START_BUSINESS_TIME = "09:00";
    /**
     * 门店默认最晚营业时间
     */
    public static final String STORE_DEFAULT_END_BUSINESS_TIME = "19:00";

    // ----派件业务代码----
    /**
     * 派件入库
     */
    public static final String BUSS_CODE_DELIVERY_IN_STORE = "DELIVERY_IN_STORE";
    /**
     * 派件外出配送
     */
    public static final String BUSS_CODE_DELIVERY_DISPATCHING = "DELIVERY_DISPATCHING";
    /**
     * 派件返库
     */
    public static final String BUSS_CODE_DELIVERY_RETURN = "DELIVERY_RETURN";
    /**
     * 派件取件完成
     */
    public static final String BUSS_CODE_DELIVERY_TAKE_COMPLETE = "DELIVERY_TAKE_COMPLETE";
    /**
     * 派件货架转移
     */
    public static final String BUSS_CODE_DELIVERY_SHELF_CHANGE = "DELIVERY_SHELF_CHANGE";
    /**
     * 派件滞留
     */
    public static final String BUSS_CODE_DELIVERY_DETAIN = "DELIVERY_DETAIN";

    // ----未妥投原因----
    /**
     * 收方客户要求自取
     */
    public static final int REJECT_REASON_OUTRETRUN_1 = 1;
    /**
     * 电话关机|无法接通|不接
     */
    public static final int REJECT_REASON_OUTRETRUN_2 = 2;
    /**
     * 电话异常(停机|空号|暂停服务)
     */
    public static final int REJECT_REASON_OUTRETRUN_3 = 3;
    /**
     * 单标地址无人
     */
    public static final int REJECT_REASON_OUTRETRUN_4 = 4;
    /**
     * 客户要求更改派送时间
     */
    public static final int REJECT_REASON_OUTRETRUN_5 = 5;
    /**
     * 单标地址超范围
     */
    public static final int REJECT_REASON_OUTRETRUN_6 = 6;
    /**
     * 电话与联系人不符
     */
    public static final int REJECT_REASON_OUTRETRUN_7 = 7;
    /**
     * 包裹的件数未全部到齐，无法派送
     */
    public static final int REJECT_REASON_OUTRETRUN_8 = 8;
    /**
     * 其他原因（备注：需要手动输入原因）
     */
    public static final int REJECT_REASON_OUTRETRUN_9 = 99;

    /**
     * 客户拒收
     */
    public static final int REJECT_REASON_OUTREJECTION_1 = 10;
    /**
     * 包裹已破损
     */
    public static final int REJECT_REASON_OUTREJECTION_2 = 11;
    /**
     * 客户拒付运费
     */
    public static final int REJECT_REASON_OUTREJECTION_3 = 12;
    /**
     * 客户拒付代收货款
     */
    public static final int REJECT_REASON_OUTREJECTION_4 = 13;
    
    // ------短信发送方式
    /**
     * 自动发送
     */
    public static final int SMS_SEND_TYPE_AUTO = 1;
    
    /**
     * 手动发送
     */
    public static final int SMS_SEND_TYPE_HAND = 2;

    // ------短信发送状态------
    /**
     * 已发送
     */
    public static final int SMS_SEND_STATUS_SEND = 0;
    /**
     * 成功
     */
    public static final int SMS_SEND_STATUS_SUCCESS = 1;
    /**
     * 失败
     */
    public static final int SMS_SEND_STATUS_FAIL = 2;
    /**
     * 无结果
     */
    public static final int SMS_SEND_STATUS_UNKNOWN = 3;

    // ------问题类型-------
    /**
     * 无问题
     */
    public static final int PROBLEM_TYPE_DEFUAL = 0;
    /**
     * 拒收
     */
    public static final int PROBLEM_TYPE_REFUSE = 1;
    /**
     * 问题件
     */
    public static final int PROBLEM_TYPE_PROBLEM = 2;
    
    // ------揽件类型------
    /**
     * 门店揽件
     */
    public static final int RECEIVED_TYPE_SELF = 147;
    /**
     * 外出揽件
     */
    public static final int RECEIVED_TYPE_OUT = 148;

    // ------揽件包裹类型------
    /**
     * 国内件
     */
    public static final int RECEIVED_PACKAGE_TYPE_DOMESTIC = 1;
    /**
     * 国际件
     */
    public static final int RECEIVED_PACKAGE_TYPE_INTERNATIONAL = 2;
    /**
     * 电商退货
     */
    public static final int RECEIVED_PACKAGE_TYPE_RETURN_GOOD = 3;


    // ------揽件状态------
    /**
     * 待揽件
     */
    public static final int RECEIVED_STATUS_WAIT_RECEIVE = 141;
    /**
     * 已取消
     */
    public static final int RECEIVED_STATUS_CANCELED = 142;
    /**
     * 未处理
     */
    public static final int RECEIVED_STATUS_NO_PRINT = 144;
    /**
     * 已处理
     */
    public static final int RECEIVED_STATUS_PRINTED = 145;
    /**
     * 已作废
     */
    public static final int RECEIVED_STATUS_INVALID = 146;

    // ------揽件微信支付状态------
    /**
     * 未支付
     */
    public static final int RECEIVED_WECHAT_UNPAY = -1;
    /**
     * 支付失败
     */
    public static final int RECEIVED_WECHAT_PAYFAIL = 0;
    /**
     * 支付成功
     */
    public static final int RECEIVED_WECHAT_PAYSUCC = 1;

    // ----第三方推送状态----
    /**
     * 待推送
     */
    public static final int THIRD_PROPELL_STATUS_1 = 141;
    /**
     * 推送中
     */
    public static final int THIRD_PROPELL_STATUS_2 = 142;
    /**
     * 推送失败
     */
    public static final int THIRD_PROPELL_STATUS_3 = 143;
    /**
     * 推送成功
     */
    public static final int THIRD_PROPELL_STATUS_4 = 144;

    // ----揽件包装类型----
    /**
     * 一号箱
     */
    public static final int RECEIVED_PACK_TYPE_1_BOX = 149;
    /**
     * 二号箱
     */
    public static final int RECEIVED_PACK_TYPE_2_BOX = 150;
    /**
     * 三号箱
     */
    public static final int RECEIVED_PACK_TYPE_3_BOX = 151;
    /**
     * 四号箱
     */
    public static final int RECEIVED_PACK_TYPE_4_BOX = 152;
    /**
     * 五号箱
     */
    public static final int RECEIVED_PACK_TYPE_5_BOX = 153;
    /**
     * 六号箱
     */
    public static final int RECEIVED_PACK_TYPE_6_BOX = 154;
    /**
     * 信封
     */
    public static final int RECEIVED_PACK_TYPE_ENVELOPE = 166;
    /**
     * 防水袋
     */
    public static final int RECEIVED_PACK_TYPE_PACKAGE = 167;
    /**
     * 信封（联邦）
     */
    public static final int RECEIVED_PACK_TYPE_FEDEX_ENVELOPE = 155;
    /**
     * 自带包装（联邦）
     */
    public static final int RECEIVED_PACK_TYPE_FEDEX_YOUR_PACKAGE = 156;
    /**
     * 防水袋（联邦）
     */
    public static final int RECEIVED_PACK_TYPE_FEDEX_PACK_ENVELOPE = 185;
    /**
     * 汇通塑料袋
     */
    public static final int RECEIVED_PACK_TYPE_HTKYPLASTICBAG = 227;
    /**
     * 汇通文件袋
     */
    public static final int RECEIVED_PACK_TYPE_HTKYFOLDER = 228;
    /**
     * 汇通蛇皮袋
     */
    public static final int RECEIVED_PACK_TYPE_HTKYNYLONPOLYBAG = 239;
    /**
     * 圆通塑料袋
     */
    public static final int RECEIVED_PACK_TYPE_YTPLASTICBAG = 229;
    /**
     * 圆通文件袋
     */
    public static final int RECEIVED_PACK_TYPE_YTFOLDER = 230;
    /**
     * 圆通蛇皮袋
     */
    public static final int RECEIVED_PACK_TYPE_YTNYLONPOLYBAG = 240;
    /**
     * 中通塑料袋
     */
    public static final int RECEIVED_PACK_TYPE_ZTPLASTICBAG = 231;
    /**
     * 中通文件袋
     */
    public static final int RECEIVED_PACK_TYPE_ZTFOLDER = 232;
    /**
     * 中通蛇皮袋
     */
    public static final int RECEIVED_PACK_TYPE_ZTNYLONPOLYBAG = 241;

    // ----揽件支付类型----
    /**
     * 寄方付
     */
    public static final int RECEIVED_PAY_TYPE_SENDER = 161;
    /**
     * 收方付
     */
    public static final int RECEIVED_PAY_TYPE_RECIPIENT = 162;
    /**
     * 第三方付
     */
    public static final int RECEIVED_PAY_TYPE_THIRD_PARTY = 163;
    /**
     * 寄方付月结
     */
    public static final int RECEIVED_PAY_TYPE_SENDER_SSTATEMENT = 164;
    /**
     * 汇通现金支付
     */
    public static final int RECEIVED_PAY_TYPE_HTKYCASH = 233;
    /**
     * 汇通到付
     */
    public static final int RECEIVED_PAY_TYPE_HTKYRECIPIENT = 234;
    /**
     * 圆通现金支付
     */
    public static final int RECEIVED_PAY_TYPE_YTCASH = 235;
    /**
     * 圆通到付
     */
    public static final int RECEIVED_PAY_TYPE_YTRECIPIENT = 236;
    /**
     * 中通现金支付
     */
    public static final int RECEIVED_PAY_TYPE_ZTCASH = 237;
    /**
     * 中通到付
     */
    public static final int RECEIVED_PAY_TYPE_ZTRECIPIENT = 238;
    
    public static final String EXPRESS_LOGO_URL = "http://7xngb1.com2.z0.glb.qiniucdn.com/express%.png";
    
    /**
     * 短信服务，1表示“快鸽”
     */
    public static final int SMS_SERVICE_KUAIGE = 1;
    /**
     * 短信服务，2表示“大汉三通”
     */
    public static final int SMS_SERVICE_DAHAN = 2;
    /**
     * 短信服务，3表示“尚通科技”
     */
    public static final int SMS_SERVICE_SHANGTONG = 3;
    /**
     * 短信服务，4表示“云信”
     */
    public static final int SMS_SERVICE_YUNXIN = 4;
    
    /**
     * 短信服务，5表示“流驿”
     */
    public static final int SMS_SERVICE_LIUYI = 5;
    
    /**
     * 短信服务，6表示“奇点云”
     */
    public static final int SMS_SERVICE_QIDIAN = 6;

    /**
     * 短信服务，7表示“无锡”
     */
    public static final int SMS_SERVICE_WUXI = 7;

    public static final int SMS_SERVICE_CMPP = 8;
    
    /**
     * 淘宝订单无需完善手机号，数据库中写的默认手机号
     */
    public static final String DEFAULT_MOBILE_KB = "99999999999";
    
    /**
     * SEND_SMS_OF_KB(快宝发送短信编码)
     */
    public static final String SEND_SMS_OF_KB = "SEND_SMS_OF_KB";
    
    /**
     * SEND_SMS_OF_DH(大汉三通发送短信编码)
     */
    public static final String SEND_SMS_OF_DH = "SEND_SMS_OF_DH";
    
    // ----支付相关----
    /**
     * 支付参数:标题
     */
    public static final String PAY_PARAM_SUBJECT = "熊猫驿站-充值";
    
    /**
     * 支付参数:商品描述
     */
    public static final String PAY_PARAM_BODY = "熊猫驿站-充值";
    
    /**
	 * 支付宝订单状态
	 */
    public static final String ALIPAY_TRADE_WAIT_CREATE = "TRADE_WAIT_CREATE"; // 交易未创建
	public static final String ALIPAY_WAIT_BUYER_PAY = "WAIT_BUYER_PAY"; // 交易创建
	public static final String ALIPAY_TRADE_SUCCESS = "TRADE_SUCCESS"; // 支付成功
    public static final String ALIPAY_TRADE_FINISHED = "TRADE_FINISHED"; // 交易成功
    public static final String ALIPAY_TRADE_CLOSED = "TRADE_CLOSED"; // 交易关闭
	public static final Map<String, Integer> ALIPAY_TRADE_STATUS_MAP = new HashMap<String, Integer>();
    static {
    	ALIPAY_TRADE_STATUS_MAP.put(ALIPAY_TRADE_WAIT_CREATE, 0);
    	ALIPAY_TRADE_STATUS_MAP.put(ALIPAY_WAIT_BUYER_PAY, 1);
    	ALIPAY_TRADE_STATUS_MAP.put(ALIPAY_TRADE_SUCCESS, 2);
    	ALIPAY_TRADE_STATUS_MAP.put(ALIPAY_TRADE_FINISHED, 3);
    	ALIPAY_TRADE_STATUS_MAP.put(ALIPAY_TRADE_CLOSED, 4);
    }
    /**
	 * 支付宝订订单退款状态
	 */
    public static final String ALIPAY_TRADE_REFUND_SUCCESS = "REFUND_SUCCESS"; // 交易未创建
    
	/**
	 * 消费短信的业务(10:自提入库)
	 */
	public static final int SMS_CONSUME_BUSINESS_INSTORE = 10;
	/**
	 * 消费短信的业务(10:直接入库)
	 */
	public static final int SMS_CONSUME_BUSINESS_DISPATCH = 20;

	/**
	 * 消费短信的业务(30:包裹转移)
	 */
	public static final int SMS_CONSUME_BUSINESS_PACKAGE = 30;

	/**
	 * 消费短信的业务(40:货架转移)
	 */
	public static final int SMS_CONSUME_BUSINESS_SHELF = 40;

	/**
	 * 消费短信的业务(50:滞留件催取)
	 */
	public static final int SMS_CONSUME_BUSINESS_REMIND = 50;

	/**
	 * 消费短信的业务(60:完善散单)
	 */
	public static final int SMS_CONSUME_BUSINESS_COMPLETE = 60;
	/**
	 * 消费短信的业务(70:重发入库信息)
	 */
	public static final int SMS_CONSUME_BUSINESS_RESEND_INSTORE = 70;
	/**
	 * 消费短信的业务(80:失败短信负消费)
	 */
	public static final int SMS_CONSUME_BUSINESS_FAIL_SMS =80;
    /**
     *   文件地址
     */
    public static final String  FASTDFS_CLIENT_SERVER = ResourceBundle.getBundle("fastdfs-client", Locale.CHINA).getString("fastdfs.tracker_http");

    public static final String PLATFORM_MENGWANG = "MengWang";

    public static final String PLATFORM_DEFAULT = "ALBB";

    public static final String PLATFORM_WECHAT = "WeChat";

    public static final String PLATFORM_ALBB = "ALBB";

    public static final String PLATFORM_HAIDIAO = "HaiDiao";
	
    public static final String PLATFORM_WUXI = "WUXI";
}