package cn.haliaeetus.sendmessage.constants;

import java.util.HashMap;
import java.util.Map;

import static cn.haliaeetus.sendmessage.constants.Constants.*;

public class MapConstants {
    public static Map<String, Integer> receivedPackTypeFedexRevMap = new HashMap<>();
    public static Map<String, Integer> receivedPackTypeRevMap = new HashMap<>();
    public static Map<String, Integer> receivedPayTypeRevMap = new HashMap<>();
    public static Map<String, String> LYSMSErrorCodeMsg = new HashMap<>();
    public static Map<String, String> QDSMSErrorCodeMsg = new HashMap<>();
    public static Map<String, String> WXSMSErrorCodeMsg = new HashMap<>();

    static {
        receivedPackTypeFedexRevMap.put("ENVELOPE", RECEIVED_PACK_TYPE_FEDEX_ENVELOPE);
        receivedPackTypeFedexRevMap.put("YOUR_PACKAGE", RECEIVED_PACK_TYPE_FEDEX_YOUR_PACKAGE);
        receivedPackTypeFedexRevMap.put("PACK_ENVELOPE", RECEIVED_PACK_TYPE_FEDEX_PACK_ENVELOPE);

        receivedPackTypeRevMap.put("1_BOX", RECEIVED_PACK_TYPE_1_BOX);
        receivedPackTypeRevMap.put("2_BOX", RECEIVED_PACK_TYPE_2_BOX);
        receivedPackTypeRevMap.put("3_BOX", RECEIVED_PACK_TYPE_3_BOX);
        receivedPackTypeRevMap.put("4_BOX", RECEIVED_PACK_TYPE_4_BOX);
        receivedPackTypeRevMap.put("5_BOX", RECEIVED_PACK_TYPE_5_BOX);
        receivedPackTypeRevMap.put("6_BOX", RECEIVED_PACK_TYPE_6_BOX);
        receivedPackTypeRevMap.put("ENVELOPE", RECEIVED_PACK_TYPE_ENVELOPE);
        receivedPackTypeRevMap.put("PACKAGE", RECEIVED_PACK_TYPE_PACKAGE);
        receivedPackTypeRevMap.put("HTKYPLASTICBAG", RECEIVED_PACK_TYPE_HTKYPLASTICBAG);
        receivedPackTypeRevMap.put("HTKYFOLDER", RECEIVED_PACK_TYPE_HTKYFOLDER);
        receivedPackTypeRevMap.put("HTKYNYLONPOLYBAG", RECEIVED_PACK_TYPE_HTKYNYLONPOLYBAG);
        receivedPackTypeRevMap.put("YTPLASTICBAG", RECEIVED_PACK_TYPE_YTPLASTICBAG);
        receivedPackTypeRevMap.put("YTFOLDER", RECEIVED_PACK_TYPE_YTFOLDER);
        receivedPackTypeRevMap.put("YTNYLONPOLYBAG", RECEIVED_PACK_TYPE_YTNYLONPOLYBAG);
        receivedPackTypeRevMap.put("ZTPLASTICBAG", RECEIVED_PACK_TYPE_ZTPLASTICBAG);
        receivedPackTypeRevMap.put("ZTFOLDER", RECEIVED_PACK_TYPE_ZTFOLDER);
        receivedPackTypeRevMap.put("ZTNYLONPOLYBAG", RECEIVED_PACK_TYPE_ZTNYLONPOLYBAG);

        receivedPayTypeRevMap.put("SENDER", RECEIVED_PAY_TYPE_SENDER);
        receivedPayTypeRevMap.put("RECIPIENT", RECEIVED_PAY_TYPE_RECIPIENT);
        receivedPayTypeRevMap.put("THIRD_PARTY", RECEIVED_PAY_TYPE_THIRD_PARTY);
        receivedPayTypeRevMap.put("SENDER_SSTATEMENT", RECEIVED_PAY_TYPE_SENDER_SSTATEMENT);
        receivedPayTypeRevMap.put("HTKYCASH", RECEIVED_PAY_TYPE_HTKYCASH);
        receivedPayTypeRevMap.put("HTKYRECIPIENT", RECEIVED_PAY_TYPE_HTKYRECIPIENT);
        receivedPayTypeRevMap.put("YTCASH", RECEIVED_PAY_TYPE_YTCASH);
        receivedPayTypeRevMap.put("YTRECIPIENT", RECEIVED_PAY_TYPE_YTRECIPIENT);
        receivedPayTypeRevMap.put("ZTCASH", RECEIVED_PAY_TYPE_ZTCASH);
        receivedPayTypeRevMap.put("ZTRECIPIENT", RECEIVED_PAY_TYPE_ZTRECIPIENT);
        
        LYSMSErrorCodeMsg.put("9002","未知命令");
        LYSMSErrorCodeMsg.put("9012","短信消息内容错误");
        LYSMSErrorCodeMsg.put("9013","目标地址错误");
        LYSMSErrorCodeMsg.put("9014","短信内容太长");
        LYSMSErrorCodeMsg.put("9015","路由错误");
        LYSMSErrorCodeMsg.put("9016","没有下发网关");
        LYSMSErrorCodeMsg.put("9017","定时时间错误");
        LYSMSErrorCodeMsg.put("9018","有效时间错误");
        LYSMSErrorCodeMsg.put("9019","无法拆分或者拆分错误");
        LYSMSErrorCodeMsg.put("9020","号码段错误");
        LYSMSErrorCodeMsg.put("9021","消息编号错误，这个和PacketIndex参数有关");
        LYSMSErrorCodeMsg.put("9022","用户不能发长短信(EsmClass错误)");
        LYSMSErrorCodeMsg.put("9023","ProtocolID错误");
        LYSMSErrorCodeMsg.put("9024","结构错误，一般是指长短信");
        LYSMSErrorCodeMsg.put("9025","短信编码错误");
        LYSMSErrorCodeMsg.put("9026","内容不是长短信");
        LYSMSErrorCodeMsg.put("9027","签名不对");
        LYSMSErrorCodeMsg.put("9028","目标网关不支持长短信");
        LYSMSErrorCodeMsg.put("9029","路由拦截");
        LYSMSErrorCodeMsg.put("9030","目标地址(手机号)太多");
        LYSMSErrorCodeMsg.put("9031","目标地址(手机号)太少");
        LYSMSErrorCodeMsg.put("9032","发送速度太快");
        LYSMSErrorCodeMsg.put("9101","验证失败，一般和用户名/密码/IP地址相关");
        LYSMSErrorCodeMsg.put("9102","没有填写用户名");
        LYSMSErrorCodeMsg.put("9103","名字没找到");
        LYSMSErrorCodeMsg.put("9104","IP地址不对");
        LYSMSErrorCodeMsg.put("9105","超过最大连接数，就是tcp连接数，http也是一样的");
        LYSMSErrorCodeMsg.put("9106","协议版本错误");
        LYSMSErrorCodeMsg.put("9107","帐号无效，比如过期/禁用");
        LYSMSErrorCodeMsg.put("9902","网关无此能力");
        LYSMSErrorCodeMsg.put("9903","二进制数据太长了；如网关没有特别说明，一般不能超过140，");
        LYSMSErrorCodeMsg.put("9904","网关不支持EsmClass字段，或等同字段");
        LYSMSErrorCodeMsg.put("9905","网关不支持ProtocolID字段，或等同字段");
        LYSMSErrorCodeMsg.put("9906","网关不支持UDHI字段，或等同字段");
        LYSMSErrorCodeMsg.put("9907","网关支持Letter字段发送，但短信记录没有letter");
        LYSMSErrorCodeMsg.put("9908","网关不存在");
        LYSMSErrorCodeMsg.put("9909","网关没有应答");
        LYSMSErrorCodeMsg.put("9910","网关不支持该短信编码");
        LYSMSErrorCodeMsg.put("9911","区域错误");
        LYSMSErrorCodeMsg.put("9401","计费错误");
        LYSMSErrorCodeMsg.put("9402","非法内容");
        LYSMSErrorCodeMsg.put("9403","黑名单");
        LYSMSErrorCodeMsg.put("9405","Api帐号丢失");
        LYSMSErrorCodeMsg.put("9406","配置拒绝，就是帐号设置了拒绝标记");
        LYSMSErrorCodeMsg.put("9407","帐号没有生成时间,这个属于非法帐号");
        LYSMSErrorCodeMsg.put("9408","消息超时，超过短信或帐号或系统设置的生存时间");
        LYSMSErrorCodeMsg.put("9409","由约束规则拒绝");
        LYSMSErrorCodeMsg.put("9410","状态报告超时");
        LYSMSErrorCodeMsg.put("9412","帐号无效");
        LYSMSErrorCodeMsg.put("9413","重发拦截");
        LYSMSErrorCodeMsg.put("9414","转发时丢弃，比如该通道已经废弃");
        LYSMSErrorCodeMsg.put("9415","人工审核失败");
        LYSMSErrorCodeMsg.put("9416","可能是诈骗信息");
        LYSMSErrorCodeMsg.put("9417","不匹配模板");
        LYSMSErrorCodeMsg.put("9418","拒绝审核（审核功能可能关闭）");
        LYSMSErrorCodeMsg.put("9419","超过该手机号码的日发送次数限制");
        LYSMSErrorCodeMsg.put("9501","非法目标地址，即手机号");
        LYSMSErrorCodeMsg.put("9502","消息无法投入队列");


        
        QDSMSErrorCodeMsg.put("9002","未知命令");
        QDSMSErrorCodeMsg.put("9012","短信消息内容错误");
        QDSMSErrorCodeMsg.put("9013","目标地址错误");
        QDSMSErrorCodeMsg.put("9014","短信内容太长");
        QDSMSErrorCodeMsg.put("9015","路由错误");
        QDSMSErrorCodeMsg.put("9016","没有下发网关");
        QDSMSErrorCodeMsg.put("9017","定时时间错误");
        QDSMSErrorCodeMsg.put("9018","有效时间错误");
        QDSMSErrorCodeMsg.put("9019","无法拆分或者拆分错误");
        QDSMSErrorCodeMsg.put("9020","号码段错误");
        QDSMSErrorCodeMsg.put("9021","消息编号错误，这个和PacketIndex参数有关");
        QDSMSErrorCodeMsg.put("9022","用户不能发长短信(EsmClass错误)");
        QDSMSErrorCodeMsg.put("9023","ProtocolID错误");
        QDSMSErrorCodeMsg.put("9024","结构错误，一般是指长短信");
        QDSMSErrorCodeMsg.put("9025","短信编码错误");
        QDSMSErrorCodeMsg.put("9026","内容不是长短信");
        QDSMSErrorCodeMsg.put("9027","签名不对");
        QDSMSErrorCodeMsg.put("9028","目标网关不支持长短信");
        QDSMSErrorCodeMsg.put("9029","路由拦截");
        QDSMSErrorCodeMsg.put("9030","目标地址(手机号)太多");
        QDSMSErrorCodeMsg.put("9031","目标地址(手机号)太少");
        QDSMSErrorCodeMsg.put("9032","发送速度太快");
        QDSMSErrorCodeMsg.put("9101","验证失败，一般和用户名/密码/IP地址相关");
        QDSMSErrorCodeMsg.put("9102","没有填写用户名");
        QDSMSErrorCodeMsg.put("9103","名字没找到");
        QDSMSErrorCodeMsg.put("9104","IP地址不对");
        QDSMSErrorCodeMsg.put("9105","超过最大连接数，就是tcp连接数，http也是一样的");
        QDSMSErrorCodeMsg.put("9106","协议版本错误");
        QDSMSErrorCodeMsg.put("9107","帐号无效，比如过期/禁用");
        QDSMSErrorCodeMsg.put("9902","网关无此能力");
        QDSMSErrorCodeMsg.put("9903","二进制数据太长了；如网关没有特别说明，一般不能超过140，");
        QDSMSErrorCodeMsg.put("9904","网关不支持EsmClass字段，或等同字段");
        QDSMSErrorCodeMsg.put("9905","网关不支持ProtocolID字段，或等同字段");
        QDSMSErrorCodeMsg.put("9906","网关不支持UDHI字段，或等同字段");
        QDSMSErrorCodeMsg.put("9907","网关支持Letter字段发送，但短信记录没有letter");
        QDSMSErrorCodeMsg.put("9908","网关不存在");
        QDSMSErrorCodeMsg.put("9909","网关没有应答");
        QDSMSErrorCodeMsg.put("9910","网关不支持该短信编码");
        QDSMSErrorCodeMsg.put("9911","区域错误");
        QDSMSErrorCodeMsg.put("9401","计费错误");
        QDSMSErrorCodeMsg.put("9402","非法内容");
        QDSMSErrorCodeMsg.put("9403","黑名单");
        QDSMSErrorCodeMsg.put("9405","Api帐号丢失");
        QDSMSErrorCodeMsg.put("9406","配置拒绝，就是帐号设置了拒绝标记");
        QDSMSErrorCodeMsg.put("9407","帐号没有生成时间,这个属于非法帐号");
        QDSMSErrorCodeMsg.put("9408","消息超时，超过短信或帐号或系统设置的生存时间");
        QDSMSErrorCodeMsg.put("9409","由约束规则拒绝");
        QDSMSErrorCodeMsg.put("9410","状态报告超时");
        QDSMSErrorCodeMsg.put("9412","帐号无效");
        QDSMSErrorCodeMsg.put("9413","重发拦截");
        QDSMSErrorCodeMsg.put("9414","转发时丢弃，比如该通道已经废弃");
        QDSMSErrorCodeMsg.put("9415","人工审核失败");
        QDSMSErrorCodeMsg.put("9416","可能是诈骗信息");
        QDSMSErrorCodeMsg.put("9417","不匹配模板");
        QDSMSErrorCodeMsg.put("9418","拒绝审核（审核功能可能关闭）");
        QDSMSErrorCodeMsg.put("9419","超过该手机号码的日发送次数限制");
        QDSMSErrorCodeMsg.put("9501","非法目标地址，即手机号");
        QDSMSErrorCodeMsg.put("9502","消息无法投入队列");


        WXSMSErrorCodeMsg.put("0","成功");
        WXSMSErrorCodeMsg.put("1001","userId不能为空");
        WXSMSErrorCodeMsg.put("1002","用户不合法");
        WXSMSErrorCodeMsg.put("1003","ip不能为空");
        WXSMSErrorCodeMsg.put("1004","ip校验失败");
        WXSMSErrorCodeMsg.put("1005","md5password不能为空");
        WXSMSErrorCodeMsg.put("1006","md5password错误");
        WXSMSErrorCodeMsg.put("1007","action不能为空");
        WXSMSErrorCodeMsg.put("1008","手机号码不能为空或者手机号码位数不正确");
        WXSMSErrorCodeMsg.put("1009","扩展必须为数字");
        WXSMSErrorCodeMsg.put("10010","自带msgid不是长整形或者超过长整型的表数范围");
        WXSMSErrorCodeMsg.put("10011","内容为空");
        WXSMSErrorCodeMsg.put("10012","内容含关键字");
        WXSMSErrorCodeMsg.put("10013","内容超过最大长度670");
        WXSMSErrorCodeMsg.put("10014","签名超长或为空，签名最长为16, 内容以【 开头");
        WXSMSErrorCodeMsg.put("10015","action参数错误");
        WXSMSErrorCodeMsg.put("10016","余额不足");
        WXSMSErrorCodeMsg.put("10017","账号已禁用");
        WXSMSErrorCodeMsg.put("10018","该用户此时间段禁止提交");
        WXSMSErrorCodeMsg.put("10019","不允许主动获取和主动推送同时调用");
        WXSMSErrorCodeMsg.put("10020","短信格式错误（JSON解析错误或手机号都不合法）");
        WXSMSErrorCodeMsg.put("10021","短信打包超过500条");
    }
}
