package cn.haliaeetus.sendmessage.constants;

import java.util.Locale;
import java.util.ResourceBundle;

/**
 * 短信配置工具类
 * @author sqj
 *
 */
public class SMSConfig {
	private static final ResourceBundle RESOURCE_BUNDLE = ResourceBundle.getBundle("sms", Locale.CHINA);
	
	public static String getBSSendSmsUrl(){
		return RESOURCE_BUNDLE.getString("bs.delivery.smsConfig.sendSmsUrl");
	}
	
	// 新版门店系统回写短信状态URL
	public static String getLpDeliverySmsConfigRptStatusUrl(){
		return RESOURCE_BUNDLE.getString("lp.delivery.smsConfig.rptStautUrl");
	}
	
	// 麦客信系统回写短信状态URL
	public static String getMkxDeliverySmsConfigRptStatusUrl(){
		return RESOURCE_BUNDLE.getString("mkx.delivery.smsConfig.rptStautUrl");
	}
	
	// 云信短信对接
	public static String getYunXinSmsSendUrl() {
		return RESOURCE_BUNDLE.getString("yunxin.sms.send.url");
	}
	public static String getYunXinSmsReportUrl() {
		return RESOURCE_BUNDLE.getString("yunxin.sms.report.url");
	}
	public static String getYunXinSmsBalanceUrl() {
		return RESOURCE_BUNDLE.getString("yunxin.sms.balance.url");
	}
	public static String getYunXinSmsUserCode() {
		return RESOURCE_BUNDLE.getString("yunxin.sms.userCode");
	}
	public static String getYunXinSmsUserPass() {
		return RESOURCE_BUNDLE.getString("yunxin.sms.userPass");
	}
	public static String getYunXinSmsStoreid() {
		return RESOURCE_BUNDLE.getString("yunxin.sms.storeid");
	}
	
	// 快鸽短信对接
	public static String getKuaigeSmsSendUrl() {
		return RESOURCE_BUNDLE.getString("kuaige.sms.send.url");
	}
	public static String getKuaigeSmsReportUrl() {
		return RESOURCE_BUNDLE.getString("kuaige.sms.report.url");
	}
	public static String getKuaigeSmsUserid() {
		return RESOURCE_BUNDLE.getString("kuaige.sms.userid");
	}
	public static String getKuaigeSmsAccount() {
		return RESOURCE_BUNDLE.getString("kuaige.sms.account");
	}
	public static String getKuaigeSmsPassword() {
		return RESOURCE_BUNDLE.getString("kuaige.sms.password");
	}
	public static String getKuaigeSmsStoreid() {
		return RESOURCE_BUNDLE.getString("kuaige.sms.storeid");
	}
	
	// 快宝短信对接
	public static String getKuaibaoApiUrl() {
		return RESOURCE_BUNDLE.getString("kuaibao.api.url");
	}
	public static String getKuaibaoApiAppId() {
		return RESOURCE_BUNDLE.getString("kuaibao.api.app.id");
	}
	public static String getKuaibaoApiNameCheck() {
		return RESOURCE_BUNDLE.getString("kuaibao.api.name.check");
	}
	public static String getKuaibaoApiNameSend() {
		return RESOURCE_BUNDLE.getString("kuaibao.api.name.send");
	}
	public static String getKuaibaoApiAppKey() {
		return RESOURCE_BUNDLE.getString("kuaibao.api.app.key");
	}
	
	// 大汉三通短信对接
	public static String getDahanSmsSendUrl() {
		return RESOURCE_BUNDLE.getString("dahan.sms.send.url");
	}
	public static String getDahanSmsReportUrl() {
		return RESOURCE_BUNDLE.getString("dahan.sms.report.url");
	}
	public static String getDahanSmsBalanceUrl() {
		return RESOURCE_BUNDLE.getString("dahan.sms.balance.url");
	}
	public static String getDahanSmsAccount() {
		return RESOURCE_BUNDLE.getString("dahan.sms.account");
	}
	public static String getDahanSmsPassword() {
		return RESOURCE_BUNDLE.getString("dahan.sms.password");
	}
	public static String getDahanSmsSign() {
		return RESOURCE_BUNDLE.getString("dahan.sms.sign");
	}
	public static String getDahanSmsSubcode() {
		return RESOURCE_BUNDLE.getString("dahan.sms.subcode");
	}
	
	//流驿短信平台
	public static String getLiuyiSmsSendUrl(){
		return RESOURCE_BUNDLE.getString("liuyi.sms.send.url");
	}
	
	public static String getLiuyiSmsUserName(){
		return RESOURCE_BUNDLE.getString("liuyi.sms.username");
	}
	
	public static String getLiuyiSmsPassword(){
		return RESOURCE_BUNDLE.getString("liuyi.sms.password");
	}
	
	public static String getLiuyiSmsSign(){
		return RESOURCE_BUNDLE.getString("liuyi.sms.sign");
	}
	
	//奇点云短信平台
	public static String getQiDianSmsSendUrl(){
		return RESOURCE_BUNDLE.getString("qidian.sms.send.url");
	}
	
	public static String getQiDianSmsPrivateKey(){
		return RESOURCE_BUNDLE.getString("qidian.sms.privateKey");
	}
	
	public static String getQiDianSmsServerKey(){
		return RESOURCE_BUNDLE.getString("qidian.sms.serverKey");
	}
	
	public static String getQiDianSmsSign(){
		return RESOURCE_BUNDLE.getString("qidian.sms.sign");
	}
	public static String getQiDianTempCode(){
		return RESOURCE_BUNDLE.getString("qidian.sms.tempCode");
	}



	//无锡短信平台
	public static String getWuXiSmsSendUrl(){
		return RESOURCE_BUNDLE.getString("wuxi.sms.send.url");
	}

	public static String getWuXiSmsSendKey(){
		return RESOURCE_BUNDLE.getString("wuxi.sms.send.key");
	}

	public static String getWuXiSmsUserName(){
		return RESOURCE_BUNDLE.getString("wuxi.sms.username");
	}

	public static String getWuXiSmsPassword(){
		return RESOURCE_BUNDLE.getString("wuxi.sms.password");
	}

	public static String getWuXiSmsSign(){
		return RESOURCE_BUNDLE.getString("wuxi.sms.sign");
	}


	public static String getCmppSmsSendUrl(){
		return RESOURCE_BUNDLE.getString("cmpp.sms.send.url");
	}

	public static String getCmppSmsUserName(){
		return RESOURCE_BUNDLE.getString("cmpp.sms.username");
	}

	public static String getCmppSmsPassword(){
		return RESOURCE_BUNDLE.getString("cmpp.sms.password");
	}
}