package cn.haliaeetus.sendmessage.controller.util;

import java.util.Locale;
import java.util.ResourceBundle;

/**
 * 接口配置文件工具类
 * @author sqj
 *
 */
public class APIConfig {
	private static final ResourceBundle RESOURCE_BUNDLE = ResourceBundle.getBundle("api", Locale.CHINA);
	
	private static final ResourceBundle URL_BUNDLE = ResourceBundle.getBundle("url", Locale.CHINA);
	
	private static final ResourceBundle JDBC_BUNDLE = ResourceBundle.getBundle("jdbc", Locale.CHINA);
	

	// ------当当------
	/**
	 * 当当接口API的Key
	 */
	public static String getDangdangAPIKey() {
		return RESOURCE_BUNDLE.getString("dangdang.api.key");
	}
	
	/**
	 * 当当总站入库URL
	 */
	public static String getDangdangInStorageUrl() {
		return RESOURCE_BUNDLE.getString("dangdang.api.inStorage.url");
	}
	
	/**
	 * 当当总站出库URL
	 */
	public static String getDangdangOutStorageUrl() {
		return RESOURCE_BUNDLE.getString("dangdang.api.outStorage.url");
	}
	
	/**
	 * 当当状态反馈URL
	 */
	public static String getDangdangStatusFeekbackUrl() {
		return RESOURCE_BUNDLE.getString("dangdang.api.statusFeedback.url");
	}
	/**
	 * 当当日志反馈URL
	 */
	public static String getDangdangLogFeekBackUrl() {
		return RESOURCE_BUNDLE.getString("dangdang.api.logFeedback.url");
	}
	
	// ------汇通------
	/**
	 * 汇通状态反馈URL
	 */
	public static String getHtkyStatusFeekbackUrl() {
		return RESOURCE_BUNDLE.getString("htky.api.url");
	}
	
	/**
	 * 汇通PartnerId
	 */
	public static String getHtkyPartnerId() {
		return RESOURCE_BUNDLE.getString("htky.api.partnerId");
	}
	
	/**
	 * 汇通PartnerKey
	 */
	public static String getHtkyPartnerKey() {
		return RESOURCE_BUNDLE.getString("htky.api.partnerKey");
	}
	
	/**
	 * 汇通ServiceProviderCode
	 */
	public static String getHtkyServiceProviderCode() {
		return RESOURCE_BUNDLE.getString("htky.api.serviceProviderCode");
	}
	
	// ------顺丰------
	/**
	 * 顺丰API链接
	 */
	public static String getSfAPIUrl() {
		return RESOURCE_BUNDLE.getString("sf.api.url");
	}
	
	/**
	 * 顺丰分配的合作伙伴ID，调用顺丰接口时使用
	 */
	public static String getSfPartnerId() {
		return RESOURCE_BUNDLE.getString("sf.api.partnerId");
	}
	
	// ------易讯------
	/**
	 * 易讯分配的APIKey，调用接口时使用
	 */
	public static String getYixunAPIKey() {
		return RESOURCE_BUNDLE.getString("yixun.api.key");
	}
	
	/**
	 * 易讯分配的安全码，调用接口时使用
	 */
	public static String getYixunSecretCode() {
		return RESOURCE_BUNDLE.getString("yixun.api.secret");
	}
	
	// ------蘑菇街------
	/**
	 * 蘑菇街接口URL
	 */
	public static String getMgjAPIUrl() {
		return RESOURCE_BUNDLE.getString("mgj.api.url");
	}
	
	//-------中通-------
	/**
	 * 获取中通对应的合作商ID
	 * @return
	 */
	public static String getZtoCompanyId(){
		return RESOURCE_BUNDLE.getString("zto.api.company_id");
	}
	
	/**
	 * 获取中通分配給的key
	 * @return
	 */
	public static String getZtoKey(){
		return RESOURCE_BUNDLE.getString("zto.api.key");
	}
	
	/**
	 * 获取中通分配的公司名称
	 * @return
	 */
	public static String getZtoCompanyName(){
		return RESOURCE_BUNDLE.getString("zto.api.comName");
	}
	
	/**
	 * 获取中通派件-查询派件单接口
	 * @return
	 */
	public static String getZTOInterfaceForGET_DISP_ORDER(){
		return RESOURCE_BUNDLE.getString("zto.api.GET_DISP_ORDER");
	}
	
	/**
	 * 获取中通派件-查询派件单接口url
	 * @return
	 */
	public static String getZTOInterfGET_DISP_ORDERUrl(){
		return RESOURCE_BUNDLE.getString("zto.api.GET_DISP_ORDER.url");
	}
	
	/**
	 * 获取中通派件-反馈派件接口
	 * @return
	 */
	public static String getZTOInterfaceForDISP_INFO_FEEDBACK(){
		return RESOURCE_BUNDLE.getString("zto.api.DISP_INFO_FEEDBACK");
	}
	
	/**
	 * 获取中通派件-反馈派件信息url
	 * @return
	 */
	public static String getZTOInterfDISP_INFO_FEEDBACKUrl(){
		return RESOURCE_BUNDLE.getString("zto.api.DISP_INFO_FEEDBACK.url");
	}

	//-------韵达-------
	public static String getYundaAPIUrl() {
		return RESOURCE_BUNDLE.getString("yunda.api.url");
	}
	public static String getYundaAPIVersion() {
		return RESOURCE_BUNDLE.getString("yunda.api.version");
	}
	
	//-------圆通-------
//	public static String getYTOAPIUrl() {
//		return RESOURCE_BUNDLE.getString("yto.api.url");
//	}
//	public static String getYTOAPICustomerCode() {
//		return RESOURCE_BUNDLE.getString("yto.api.customerCode");
//	}
//	public static String getYTOAPIKey() {
//		return RESOURCE_BUNDLE.getString("yto.api.key");
//	}


	// ------微信推送------
	public static String getWeixinPushDispatchUrl() {
		return RESOURCE_BUNDLE.getString("weixin.api.pushDispatch");
	}
	public static String getWeixinPushSelfGetUrl() {
		return RESOURCE_BUNDLE.getString("weixin.api.pushSelfGet");
	}

	// ------BS2.0------
	public static String getPrintUrl() {
		return URL_BUNDLE.getString("bs2.config.printerurl");
	}

	// ------UserCenter-------
	public static String getUserCenterUrl() {
		return URL_BUNDLE.getString("uc.url");
	}

	// ------p2p-------
	public static String getP2PGetUrl() {
		return URL_BUNDLE.getString("p2p.get.url");
	}
	public static String getP2PPostUrl() {
		return URL_BUNDLE.getString("p2p.post.url");
	}
	public static String getP2PPushUrl() {
		return URL_BUNDLE.getString("p2p.push.url");
	}
	public static String getP2PMallPushUrl() {
		return URL_BUNDLE.getString("p2p.mall.push.url");
	}
	public static String getP2POrderTraceUrl() {
		return URL_BUNDLE.getString("p2p.order.trace.url");
	}
	public static String getTinyurlCreateUrl() {
		return URL_BUNDLE.getString("baidu.tinyurl.create.url");
	}
	
	public static String getUcCreditUrl() {
		return URL_BUNDLE.getString("uc.credit.url");
	}
	
	public static String getImageUploadQingniu() {
		return URL_BUNDLE.getString("image.upload.qingniu");
	}
	// ------商城------
	public static String getMallOrderGetUrl() {
		return RESOURCE_BUNDLE.getString("mall.api.order.get");
	}

	// ------微信支付------
	public static String getWechatPayRequestUrl() {
		return RESOURCE_BUNDLE.getString("wechat.pay.request.url");
	}
	public static String getWechatPayCallbackUrl() {
		return RESOURCE_BUNDLE.getString("wechat.pay.callback.url");
	}
	public static String getWechatPayCallbackUrlOfGraduate() {
		return RESOURCE_BUNDLE.getString("wechat.pay.graduate.callback.url");
	}
	public static String getWechatPayShareUrlOfGraduate() {
		return RESOURCE_BUNDLE.getString("wechat.pay.graduate.share.url");
	}
	public static String getWechatJSAPIConfigUrl() {
		return RESOURCE_BUNDLE.getString("wechat.jsapi.config.url");
	}
	
	//-------一米鲜-------
	public static String getYmxAPIUrl() {
		return RESOURCE_BUNDLE.getString("ymx.api.url");
	}
	public static String getYmxAPIUserKey() {
		return RESOURCE_BUNDLE.getString("ymx.api.userKey");
	}
	public static String getYmxAPIToken() {
		return RESOURCE_BUNDLE.getString("ymx.api.token");
	}
	
	//-------预发布环境配置-------
	public static String getPreReleaseUrl() {
		return RESOURCE_BUNDLE.getString("pre.release.url");
	}
	public static String getPreReleaseUser() {
		return RESOURCE_BUNDLE.getString("pre.release.user");
	}
	
	public static String getWxTemplateId() {
		return RESOURCE_BUNDLE.getString("wx.template.id");
	}
	public static String getWxDeliveryServiceUrl() {
		return RESOURCE_BUNDLE.getString("wx.delivery.service.url");
	}
	
	public static String getWxHaliaeetusTgUrl() {
		return RESOURCE_BUNDLE.getString("wx.haliaeetus.tegong");
	}
	
	// ------快递100查询服务------
	public static String getExp100QueryDeliveryUrl() {
		return RESOURCE_BUNDLE.getString("exp100.query.delivery.url");
	}
	public static String getExp100QueryDeliverySource() {
		return RESOURCE_BUNDLE.getString("exp100.query.delivery.source");
	}
	public static String getExp100QueryDeliveryPrefix() {
		return RESOURCE_BUNDLE.getString("exp100.query.delivery.prefix");
	}
	
	// 揽件成功微信模板
	public static String getWxReceivedServiceUrl() {
		return RESOURCE_BUNDLE.getString("wx.received.service.url");
	}
	public static String getWxReceivedContent() {
		return RESOURCE_BUNDLE.getString("wx.received.content");
	}
	
	
	public static String getAppPushMsgUrl() {
		return RESOURCE_BUNDLE.getString("app.push.msg.url");
	}
	
	public static String getAppPushMsgTitle() {
		return RESOURCE_BUNDLE.getString("app.push.msg.title");
	}

	public static String getSuningAPIUrl() {
		// TODO Auto-generated method stub
		return RESOURCE_BUNDLE.getString("suning.api.url");
	}
	
	public static String getSuningApiSpCode() {
		return RESOURCE_BUNDLE.getString("suning.api.spCode");
	}
	
	public static String getSuningApiSpKey() {
		return RESOURCE_BUNDLE.getString("suning.api.spKey");
	}

	public static String getPrintExpIds() {
		// TODO Auto-generated method stub
		return RESOURCE_BUNDLE.getString("print.exp.ids");
	}

	public static String getPrintExpNames() {
		// TODO Auto-generated method stub
		return RESOURCE_BUNDLE.getString("print.exp.names");
	}
	
	public static String getJPushAppkey() {
		// TODO Auto-generated method stub
		return RESOURCE_BUNDLE.getString("jpush.appkey");
	}

	public static String getJPushSecret() {
		// TODO Auto-generated method stub
		return RESOURCE_BUNDLE.getString("jpush.secret");
	}
	
	// ------如风达对接------
	public static String getRufengdaLcid() {
		return RESOURCE_BUNDLE.getString("rufengda.lcid");
	}
	public static String getRufengdaUrl() {
		return RESOURCE_BUNDLE.getString("rufengda.url");
	}
	public static String getRufengdaDesKey() {
		return RESOURCE_BUNDLE.getString("rufengda.des.key");
	}
	public static String getRufengdaRsaSignModulePuk() {
		return RESOURCE_BUNDLE.getString("rufengda.rsa.sign.module.puk");
	}
	public static String getRufengdaRsaSignExponentPublic() {
		return RESOURCE_BUNDLE.getString("rufengda.rsa.sign.exponent.public");
	}
	public static String getRufengdaRsaSignModulePrk() {
		return RESOURCE_BUNDLE.getString("rufengda.rsa.sign.module.prk");
	}
	public static String getRufengdaRsaSignExponetPrivate() {
		return RESOURCE_BUNDLE.getString("rufengda.rsa.sign.exponet.private");
	}
	
	// ------1药网对接------
	public static String get1YaoRequestUrl() {
		return RESOURCE_BUNDLE.getString("1yao.request.url");
	}
	public static String get1YaoRequestToken() {
		return RESOURCE_BUNDLE.getString("1yao.request.token");
	}
	
	//主库
	public static String getJDBCURL(){
		return JDBC_BUNDLE.getString("jdbcUrl");
	}
	
	public static String getJDBCUserName(){
		return JDBC_BUNDLE.getString("username");
	}
	
	public static String getJDBCPassword(){
		return JDBC_BUNDLE.getString("password");
	}
	
	//gaia库
	public static String getSTATJDBCURL(){
		return JDBC_BUNDLE.getString("stat_jdbcUrl");
	}
	
	public static String getSTATJDBCUserName(){
		return JDBC_BUNDLE.getString("stat_username");
	}
	
	public static String getSTATJDBCPassword(){
		return JDBC_BUNDLE.getString("stat_password");
	}
	
	//stat_gaia库
	public static String getRsyncJDBCURL(){
		return JDBC_BUNDLE.getString("rsync_jdbcUrl");
	}
	
	public static String getRsyncJDBCUserName(){
		return JDBC_BUNDLE.getString("rsync_username");
	}
	
	public static String getRsyncJDBCPassword(){
		return JDBC_BUNDLE.getString("rsync_password");
	}
	
	//back库
	public static String getBackJDBCURL(){
		return JDBC_BUNDLE.getString("back_jdbcUrl");
	}
	
	public static String getBackJDBCUserName(){
		return JDBC_BUNDLE.getString("back_username");
	}
	
	public static String getBackJDBCPassword(){
		return JDBC_BUNDLE.getString("back_password");
	}
	
	//his库
	public static String getHisDBCURL(){
		return JDBC_BUNDLE.getString("his_jdbcUrl");
	}
	
	public static String getHisJDBCUserName(){
		return JDBC_BUNDLE.getString("his_username");
	}
	
	public static String getHisJDBCPassword(){
		return JDBC_BUNDLE.getString("his_password");
	}
	
	//six_month库
	public static String getSixHisDBCURL(){
		return JDBC_BUNDLE.getString("hyhis_jdbcUrl");
	}
	
	public static String getSixHisJDBCUserName(){
		return JDBC_BUNDLE.getString("hyhis_username");
	}
	
	public static String getSixHisJDBCPassword(){
		return JDBC_BUNDLE.getString("hyhis_password");
	}
	
	/**
	 * @author GS
	 * 业务系统url
	 * @return
	 */
	public static String gefhmUrl() {
		return URL_BUNDLE.getString("fhm.url");
	}
	
	/**
	 * @author GS
	 * 业务系统MenuUrl
	 * @return
	 */
	public static String gefhmMenuUrl() {
		return URL_BUNDLE.getString("fhmenu.url");
	}

	public static String getFhmJDBCURL(){
		return JDBC_BUNDLE.getString("fhm_jdbcUrl");
	}

	public static String getFhmJDBCUserName(){
		return JDBC_BUNDLE.getString("fhm_username");
	}

	public static String getFhmJDBCPassword(){
		return JDBC_BUNDLE.getString("fhm_password");
	}

	public static String getJeesiteJDBCURL(){
		return JDBC_BUNDLE.getString("jeesite_jdbcUrl");
	}

	public static String getJeesiteUserName(){
		return JDBC_BUNDLE.getString("jeesite_username");
	}

	public static String getJeesitePassword(){
		return JDBC_BUNDLE.getString("jeesite_password");
	}

	public static String getXxUrl(){
		return URL_BUNDLE.getString("addr.addCusmob");
	}

}