package cn.haliaeetus.sendmessage.controller.util;

import cn.haliaeetus.sendmessage.utils.EncryptionUtil;
import org.springframework.util.StringUtils;

import java.util.Arrays;
import java.util.Map;


/**
 * <p>API工具类</p>
 * 
 * @author sqj
 * @since 1.0
 * @version 1.0
 */
public class APIUtil {
	// ------当当------
	/**
	 * 判断请求token是否合法（当当）
	 * @param requestTime 请求时间戳
	 * @param token 请求时间戳 + 快递公司ID + 由当当分配的Key，进行MD5加密
	 */
	public static boolean isValidTokenOfDangdang(String requestTime, String storehouseCode, String token) {
		return generateTokenOfDangdang(requestTime, storehouseCode).equalsIgnoreCase(token);
	}
	
	/**
	 * 生成请求token（当当）
	 * @param requestTime 请求时间戳
	 * @param storehouseCode 快递公司ID，由当当分配
	 */
	public static String generateTokenOfDangdang(String requestTime, String storehouseCode) {
		return EncryptionUtil.MD5(requestTime + storehouseCode + APIConfig.getDangdangAPIKey());
	}
	
	// ------易讯------
	/**
	 * 生成请求token（易讯）
	 * @param params 请求参数
	 */
	public static String generateTokenOfYixun(Map<String, String> params) {
		if (params == null || params.size() == 0) {
			return null;
		}
		
		Object[] keys = params.keySet().toArray();
		Arrays.sort(keys);
		
		StringBuilder buffer = new StringBuilder();
		for (Object key : keys) {
			if (StringUtils.hasText(params.get(key))) {
				buffer.append(key).append(params.get(key));
			}
		}
		buffer.append(APIConfig.getYixunSecretCode());
		
		return EncryptionUtil.MD5(buffer.toString());
	}
}