package cn.haliaeetus.sendmessage.controller.web.QueryCondition;


import cn.haliaeetus.sendmessage.bean.delivery.Delivery;
import org.apache.commons.lang3.StringUtils;

import java.util.Date;
import java.util.List;


/**
 * delivery表操作工具，用来辅助mybatis生成CRUD的sql
 * 
 * 说明：
 * 1、createTime和statusTime需要提供起止时间。
 * 2、status可以有多个值
 * 3、支持order by 
 * 4、支持分页
 * 5、必须设定storeId，用来底层分表
 * @author liutianyuan
 *
 */
public class DeliveryQueryCondition extends BaseQueryCondition{
	
	public DeliveryQueryCondition(int storeId) {
		super(storeId);
	}


	/**
	 * update 使用
	 */
	private Delivery entity;
	
	/**
	 * 切面 使用
	 */
	private Delivery oldEntity;
	
	/**
	 * 常用
	 */
	private String expcode; //单号
	private int expId; //快递ID
	private String deliveryUid;//操作员ID
	
	
	/**
	 * 特殊
	 */
	private String statusStr;//订单状态
	
    private QueryDate createTime;

    private QueryDate statusTime;
    
    private String deliveryIds;
    
	
    /**
     * 其他
     */
    private String shelfCode;

    private int shelfId;

    private String userName;

    private String userPhone;

    private String userpcas;

    private String userAddress;

    private String address;
    
    private int ischarge;

    private int chargeMoney;

    private int money;

    private int weight;

    private int payType;

    private String deliveryUname;

    private String odeliveryType;

    private String remark;

    private String oldOrderCode;
    
    private int problemType;

    private String problemCode;

    private int iswhite;
    
    private String revuserPhone;

    private String revexpCode;

    private String revshelfCode;

    private int fillType;

    private String signPhotoUrl;
	
    private int smsStatus;//短信状态

	private Date beginTime;
	private Date endTime;
	private String signStatus;
	private String exp_code;
	private String signFlag;
	private String exp_Id;
	//2018.12.17新添通知类型
	private int smsType;
	private List<String> list;//面单号集合
	private String recordStatus; //短信状态

	private int returnSignStatus;//簽收狀態

	public int getReturnSignStatus() {
		return returnSignStatus;
	}

	public void setReturnSignStatus(int returnSignStatus) {
		this.returnSignStatus = returnSignStatus;
	}

	public String getRecordStatus() {
		return recordStatus;
	}

	public void setRecordStatus(List<Integer>  smsStatus) {
		this.recordStatus = StringUtils.join(smsStatus, ",");
	}

	public List<String> getList() {
		return list;
	}

	public void setList(List<String> list) {
		this.list = list;
	}

	/**
	 * get set
	 */
    
    public String getStatusStr() {
		return statusStr;
	}

	public QueryDate getCreateTime() {
		return createTime;
	}

	public void setCreateTime(String beginTime, String endTime) {
		QueryDate createTime = new QueryDate(beginTime, endTime);
		this.createTime = createTime;
	}

	public QueryDate getStatusTime() {
		return statusTime;
	}

	public void setStatusTime(String beginTime, String endTime) {
		QueryDate statusTime = new QueryDate(beginTime, endTime);
		this.statusTime = statusTime;
	}


	public void setStatusStr(List<Integer>  status) {
		
		//将整形数组转为122,124这种格式，便于数据库进行in查询
		this.statusStr = StringUtils.join(status, ",");
	}


	public String getExpcode() {
		return expcode;
	}

	public void setExpcode(String expcode) {
		this.expcode = expcode;
	}

	public int getExpId() {
		return expId;
	}

	public void setExpId(int expId) {
		this.expId = expId;
	}

	public String getDeliveryUid() {
		return deliveryUid;
	}

	public void setDeliveryUid(String deliveryUid) {
		this.deliveryUid = deliveryUid;
	}

	public Delivery getEntity() {
		return entity;
	}

	public void setEntity(Delivery entity) {
		this.entity = entity;
	}


	public int getSmsType() {
		return smsType;
	}

	public void setSmsType(int smsType) {
		this.smsType = smsType;
	}

	public String getShelfCode() {
		return shelfCode;
	}

	public void setShelfCode(String shelfCode) {
		this.shelfCode = shelfCode;
	}

	public int getShelfId() {
		return shelfId;
	}

	public void setShelfId(int shelfId) {
		this.shelfId = shelfId;
	}

	public String getUserName() {
		return userName;
	}

	public void setUserName(String userName) {
		this.userName = userName;
	}

	public String getUserPhone() {
		return userPhone;
	}

	public void setUserPhone(String userPhone) {
		this.userPhone = userPhone;
	}

	public String getUserpcas() {
		return userpcas;
	}

	public void setUserpcas(String userpcas) {
		this.userpcas = userpcas;
	}

	public String getUserAddress() {
		return userAddress;
	}

	public void setUserAddress(String userAddress) {
		this.userAddress = userAddress;
	}

	public int getIscharge() {
		return ischarge;
	}

	public void setIscharge(int ischarge) {
		this.ischarge = ischarge;
	}

	public int getChargeMoney() {
		return chargeMoney;
	}

	public void setChargeMoney(int chargeMoney) {
		this.chargeMoney = chargeMoney;
	}

	public int getMoney() {
		return money;
	}

	public void setMoney(int money) {
		this.money = money;
	}

	public int getWeight() {
		return weight;
	}

	public void setWeight(int weight) {
		this.weight = weight;
	}

	public int getPayType() {
		return payType;
	}

	public void setPayType(int payType) {
		this.payType = payType;
	}

	public String getDeliveryUname() {
		return deliveryUname;
	}

	public void setDeliveryUname(String deliveryUname) {
		this.deliveryUname = deliveryUname;
	}

	public String getOdeliveryType() {
		return odeliveryType;
	}

	public void setOdeliveryType(String odeliveryType) {
		this.odeliveryType = odeliveryType;
	}

	public String getRemark() {
		return remark;
	}

	public void setRemark(String remark) {
		this.remark = remark;
	}
	public String getOldOrderCode() {
		return oldOrderCode;
	}

	public void setOldOrderCode(String oldOrderCode) {
		this.oldOrderCode = oldOrderCode;
	}

	public int getProblemType() {
		return problemType;
	}

	public void setProblemType(int problemType) {
		this.problemType = problemType;
	}

	public String getProblemCode() {
		return problemCode;
	}

	public void setProblemCode(String problemCode) {
		this.problemCode = problemCode;
	}

	public int getIswhite() {
		return iswhite;
	}

	public void setIswhite(int iswhite) {
		this.iswhite = iswhite;
	}
	
	public String getRevuserPhone() {
		return revuserPhone;
	}

	public void setRevuserPhone(String revuserPhone) {
		this.revuserPhone = revuserPhone;
	}

	public String getRevexpCode() {
		return revexpCode;
	}

	public void setRevexpCode(String revexpCode) {
		this.revexpCode = revexpCode;
	}

	public String getRevshelfCode() {
		return revshelfCode;
	}

	public void setRevshelfCode(String revshelfCode) {
		this.revshelfCode = revshelfCode;
	}

	public int getFillType() {
		return fillType;
	}

	public void setFillType(int fillType) {
		this.fillType = fillType;
	}

	public int getSmsStatus() {
		return smsStatus;
	}

	public void setSmsStatus(int smsStatus) {
		this.smsStatus = smsStatus;
	}






	public String getAddress() {
		return address;
	}

	public void setAddress(String address) {
		this.address = address;
	}






	public String getDeliveryIds() {
		return deliveryIds;
	}

	public void setDeliveryIds(String deliveryIds) {
		this.deliveryIds = deliveryIds;
	}






	public Delivery getOldEntity() {
		return oldEntity;
	}

	public void setOldEntity(Delivery oldEntity) {
		this.oldEntity = oldEntity;
	}






	class QueryDate{
		private String beginTime; 
		private String endTime;  
		
		public QueryDate(String beginTime, String endTime){
			this.beginTime = beginTime;
			this.endTime = endTime;
		}
		public String getBeginTime() {
			return beginTime;
		}

		public void setBeginTime(String beginTime) {
			this.beginTime = beginTime;
		}

		public String getEndTime() {
			return endTime;
		}

		public void setEndTime(String endTime) {
			this.endTime = endTime;
		}
	}

	public Date getBeginTime() {
		return beginTime;
	}

	public void setBeginTime(Date beginTime) {
		this.beginTime = beginTime;
	}

	public Date getEndTime() {
		return endTime;
	}

	public void setEndTime(Date endTime) {
		this.endTime = endTime;
	}

	public String getSignStatus() {
		return signStatus;
	}

	public void setSignStatus(String signStatus) {
		this.signStatus = signStatus;
	}

	public String getExp_code() {
		return exp_code;
	}

	public void setExp_code(String exp_code) {
		this.exp_code = exp_code;
	}

	public String getSignFlag() {
		return signFlag;
	}

	public void setSignFlag(String signFlag) {
		this.signFlag = signFlag;
	}


	public String getExp_Id() {
		return exp_Id;
	}

	public void setExp_Id(String exp_Id) {
		this.exp_Id = exp_Id;
	}

	public String getSignPhotoUrl() {
		return signPhotoUrl;
	}

	public void setSignPhotoUrl(String signPhotoUrl) {
		this.signPhotoUrl = signPhotoUrl;
	}
}
