package cn.haliaeetus.sendmessage.controller.web.QueryCondition;

import org.apache.commons.lang3.StringUtils;

import java.util.List;


/**
 * delivery_status表操作工具，用来辅助mybatis生成CRUD的sql
 * 
 * 说明：
 * 1、支持order by 
 * 2、支持分页
 * 3、必须设定storeId，用来底层分表
 * 4、deliveryId可以为多个
 * @author liutianyuan
 *
 */
public class DeliveryStatusQueryCondition extends BaseQueryCondition{
	
	public DeliveryStatusQueryCondition(int storeId) {
		super(storeId);
	}

	/**
	 * 形如
	 */
	private String deliveryIds;

	
	
	
	public String getDeliveryIds() {
		return deliveryIds;
	}

	public void setDeliveryIds(List<Integer> deliveryIds) {
		
		//将整形数组转为xxxxxxxx,yyyyyyyyyy这种格式，便于数据库进行in查询
		this.deliveryIds = StringUtils.join(deliveryIds, ",");
	}
	
}
