package cn.haliaeetus.sendmessage.dao;

import cn.haliaeetus.sendmessage.bean.BusinessOperateRecord;
import cn.haliaeetus.sendmessage.framework.mybatis.persistence.BaseMybatisDAO;
import org.springframework.stereotype.Repository;

import java.util.HashMap;
import java.util.Map;

/**
 * 业务操作信息DAO
 */

@Repository
public class BusinessOperateRecordDao extends BaseMybatisDAO {
	private static final String MAPPER_NAMESPACE = "cn.haliaeetus.sendmessage.dao.mapper.BusinessOperateRecordMapper";
	
	public void save(BusinessOperateRecord businessOperateRecord) {
		save(MAPPER_NAMESPACE + ".insertSelective", businessOperateRecord);
	}
	
	public BusinessOperateRecord getById(int id) {
		return findOne(MAPPER_NAMESPACE + ".selectByPrimaryKey", id);
	}
	
	public void updateById(BusinessOperateRecord businessOperateRecord) {
		update(MAPPER_NAMESPACE + ".updateByPrimaryKeySelective", businessOperateRecord);
	}
	
	public BusinessOperateRecord getBusinessOperateRecordOfStore(int storeId, String businessCode) {
		Map<String, Object> params = new HashMap<>();
		params.put("storeId", storeId);
		params.put("businessCode", businessCode);
		return findOne(MAPPER_NAMESPACE + ".selectBusinessOperateRecordOfStore", params);
	}
}