package cn.haliaeetus.sendmessage.dao;

import cn.haliaeetus.sendmessage.bean.ConsumeRecord;
import cn.haliaeetus.sendmessage.bean.dto.ConsumeListDto;
import cn.haliaeetus.sendmessage.framework.mybatis.persistence.BaseMybatisDAO;
import org.springframework.stereotype.Repository;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 短信发送记录DAO
 */
@Repository
public class ConsumeRecordDao extends BaseMybatisDAO {
	private static final String MAPPER_NAMESPACE = "cn.haliaeetus.sendmessage.dao.mapper.ConsumeRecordMapper";

	/**
	 * 插入
	 * @param consumeRecord
	 * @return
	 */

	public int insert(final ConsumeRecord consumeRecord){
		return save(MAPPER_NAMESPACE+".insert", consumeRecord);
	}


	public List<ConsumeListDto> getAllConsumeList(String beginTime, String endTime, String storageId){
		Map<String, Object> params = new HashMap<>();
		params.put("beginTime", beginTime);
		params.put("endTime", endTime);
		params.put("storeId", storageId);
		return findAll(MAPPER_NAMESPACE+".getAllConsumeList", params);
	}

	public List<ConsumeListDto> getConsumeList(String consumeFlag,String beginTime, String endTime,String storageId){
		Map<String, Object> params = new HashMap<>();
		params.put("consumeFlag", consumeFlag);
		params.put("beginTime", beginTime);
		params.put("endTime", endTime);
		params.put("storeId", storageId);
		return findAll(MAPPER_NAMESPACE+".getConsumeList", params);
	}

	public List<ConsumeListDto> getAllConsumeList4app(String beginTime, String endTime,String storageId){
		Map<String, Object> params = new HashMap<>();
		params.put("beginTime", beginTime);
		params.put("endTime", endTime);
		params.put("storeId", storageId);
		return findAll(MAPPER_NAMESPACE+".getAllConsumeList4app", params);
	}

	public List<ConsumeListDto> getConsumeList4app(String consumeFlag,String beginTime, String endTime,String storageId){
		Map<String, Object> params = new HashMap<>();
		params.put("consumeFlag", consumeFlag);
		params.put("beginTime", beginTime);
		params.put("endTime", endTime);
		params.put("storeId", storageId);
		return findAll(MAPPER_NAMESPACE+".getAllConsumeList4app", params);
	}
}