package cn.haliaeetus.sendmessage.dao;

import cn.haliaeetus.sendmessage.bean.delivery.Delivery;
import cn.haliaeetus.sendmessage.controller.web.QueryCondition.DeliveryQueryCondition;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.Date;

/**
 * 
 * @author liutianyuan
 *
 */

@Mapper
public interface DeliveryDao{

	/**
	 * 更新delivery
	 * qc中必须设置entity，表示需要更新的实体。其他字段生成where条件。
	 * @param qc
	 * @return
	 * @throws Exception
	 */
	public int update(DeliveryQueryCondition qc);

	/**
	 * 通过expcode获取订单id
	 * @param qc
	 * @return
	 */
	public Integer getDeliveryIdByExpCode(DeliveryQueryCondition qc);

    /**
     * 将短信发送状态改为发送中
     * @param qc
     * @return
     */
    public int updateDeliverySmsStatus(DeliveryQueryCondition qc);

    /**
     * 通过id查询订单
     * @param qc
     * @return
     */
    public Delivery getById(DeliveryQueryCondition qc);

    Integer updateExpSignBackStatus(String expcode, String storeId,String reason);

	void addExpressRecode(@Param("storeId") Integer storeId, @Param("expCode") String expCode, @Param("status") int status, @Param("createTime") Date date);
}