package cn.haliaeetus.sendmessage.dao;

import cn.haliaeetus.sendmessage.bean.delivery.DeliveryMsgTemplateConfig;
import cn.haliaeetus.sendmessage.framework.mybatis.persistence.BaseMybatisDAO;
import org.springframework.stereotype.Repository;

import java.util.HashMap;
import java.util.Map;

/**
 * <p>门店派件信息模板配置DAO</p>
 * 
 * @author sqj
 * @since 1.0
 * @version 1.0
 */
@Repository
public class DeliveryMsgTemplateConfigDao extends BaseMybatisDAO {
	private static final String MAPPER_NAMESPACE = "cn.haliaeetus.sendmessage.dao.mapper.DeliveryMsgTemplateConfigMapper";
	
	public void save(DeliveryMsgTemplateConfig msgTemplateConfig) {
		save(MAPPER_NAMESPACE + ".insertSelective", msgTemplateConfig);
	}
	
	public DeliveryMsgTemplateConfig getById(int id) {
		return findOne(MAPPER_NAMESPACE + ".selectByPrimaryKey", id);
	}
	
	public void updateById(DeliveryMsgTemplateConfig msgTemplateConfig) {
		update(MAPPER_NAMESPACE + ".updateByPrimaryKeySelective", msgTemplateConfig);
	}
	
	public void updateByStoreIdClientType(DeliveryMsgTemplateConfig msgTemplateConfig) {
		 update(MAPPER_NAMESPACE + ".updateByStoreIdClientType", msgTemplateConfig);
	}
	
	
	public DeliveryMsgTemplateConfig getMsgTemplateConfig(int storeId, int clientType, int type) {
		Map<String, Object> params = new HashMap<String, Object>();
		params.put("storeId", storeId);
		params.put("clientType", clientType);
		params.put("type", type);
		
		return findOne(MAPPER_NAMESPACE + ".selectMsgTemplateConfig", params);
	}
}