package cn.haliaeetus.sendmessage.dao;

import cn.haliaeetus.sendmessage.bean.delivery.DeliveryMsgTemplate;
import cn.haliaeetus.sendmessage.bean.delivery.DeliveryMsgTemplateConfig;
import cn.haliaeetus.sendmessage.framework.mybatis.persistence.BaseMybatisDAO;
import org.springframework.stereotype.Repository;

import java.util.HashMap;
import java.util.Map;

/**
 * <p>门店派件信息模板DAO</p>
 * 
 * @author sqj
 * @since 1.0
 * @version 1.0
 */
@Repository
public class DeliveryMsgTemplateDao extends BaseMybatisDAO {
	private static final String MAPPER_NAMESPACE = "cn.haliaeetus.sendmessage.dao.mapper.DeliveryMsgTemplateMapper";
	
	public void save(DeliveryMsgTemplate msgTemplate) {
		save(MAPPER_NAMESPACE + ".insertSelective", msgTemplate);
	}
	
	public DeliveryMsgTemplate getById(int id) {
		return findOne(MAPPER_NAMESPACE + ".selectByPrimaryKey", id);
	}
	
	public void updateById(DeliveryMsgTemplate msgTemplate) {
		update(MAPPER_NAMESPACE + ".updateByPrimaryKeySelective", msgTemplate);
	}
	
	public DeliveryMsgTemplate getMsgTemplate(DeliveryMsgTemplateConfig msgTemplateConfig, String bussCode) {
		Map<String, Object> params = new HashMap<String, Object>();
		params.put("clientType", msgTemplateConfig.getClientType());
		params.put("type", msgTemplateConfig.getType());
		params.put("bussCode", bussCode);
		params.put("containsTakeCode", msgTemplateConfig.getContainsTakeCode());
		params.put("containsShelf", msgTemplateConfig.getContainsShelf());
		
		return findOne(MAPPER_NAMESPACE + ".selectMsgTemplate", params);
	}

	public DeliveryMsgTemplate getDefaultMsgTemplate(int type, String bussCode) {
		Map<String, Object> params = new HashMap<String, Object>();
		params.put("type", type);
		params.put("bussCode", bussCode);
		params.put("clientType", -1);

		return findOne(MAPPER_NAMESPACE + ".selectDefaultMsgTemplate", params);
	}

    public DeliveryMsgTemplate getStoreMsgTemplate(String storeId) {
		return findOne(MAPPER_NAMESPACE + ".getStoreMsgTemplate", storeId);
    }
}