package cn.haliaeetus.sendmessage.dao;

import cn.haliaeetus.sendmessage.bean.delivery.DeliverySpecialMsgTemplate;
import cn.haliaeetus.sendmessage.framework.mybatis.persistence.BaseMybatisDAO;
import org.springframework.stereotype.Repository;

import java.util.HashMap;
import java.util.Map;

/**
 * <p>门店派件特殊信息模板DAO</p>
 * 
 * @author sqj
 * @since 1.0
 * @version 1.0
 */
@Repository
public class DeliverySpecialMsgTemplateDao extends BaseMybatisDAO {
	private static final String MAPPER_NAMESPACE = "cn.haliaeetus.sendmessage.dao.mapper.DeliverySpecialMsgTemplateMapper";
	
	public void save(DeliverySpecialMsgTemplate msgTemplate) {
		save(MAPPER_NAMESPACE + ".insertSelective", msgTemplate);
	}
	
	public DeliverySpecialMsgTemplate getById(int id) {
		return findOne(MAPPER_NAMESPACE + ".selectByPrimaryKey", id);
	}
	
	public void updateById(DeliverySpecialMsgTemplate msgTemplate) {
		update(MAPPER_NAMESPACE + ".updateByPrimaryKeySelective", msgTemplate);
	}
	
	public DeliverySpecialMsgTemplate getMsgTemplate(int storeId, int clientType, int type, String bussCode) {
		Map<String, Object> params = new HashMap<String, Object>();
		params.put("storeId", storeId);
		params.put("clientType", clientType);
		params.put("type", type);
		params.put("bussCode", bussCode);

		return findOne(MAPPER_NAMESPACE + ".selectMsgTemplate", params);
	}
}