package cn.haliaeetus.sendmessage.dao;

import cn.haliaeetus.sendmessage.bean.dto.ConsumeRecordDto;
import cn.haliaeetus.sendmessage.bean.sms.SmsSendStatistics;
import cn.haliaeetus.sendmessage.controller.web.QueryCondition.TransactionQueryCondition;
import cn.haliaeetus.sendmessage.framework.mybatis.persistence.BaseMybatisDAO;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * 发送短信统计Dao
 */
@Repository
public class SmsSendStatisticsDao extends BaseMybatisDAO {
	
	private static final String MAPPER_NAMESPACE = "cn.haliaeetus.sendmessage.dao.mapper.SmsSendStatisticsMapper";

	public int insert(SmsSendStatistics smsSendStatistics) {
		return save(MAPPER_NAMESPACE + ".insert", smsSendStatistics);
	}
	
	public Long count(TransactionQueryCondition qc) {
		return count(MAPPER_NAMESPACE + ".count", qc);
	}
	
	public List<ConsumeRecordDto> select(TransactionQueryCondition qc) {
		return findAll(MAPPER_NAMESPACE + ".select", qc);
	}
}
