package cn.haliaeetus.sendmessage.dao;

import cn.haliaeetus.sendmessage.bean.basedata.StoreStaff;
import cn.haliaeetus.sendmessage.framework.mybatis.persistence.BaseMybatisDAO;
import org.springframework.stereotype.Repository;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 快递人员接口
 * @author zhang-shuai
 *
 */
@Repository
public class StoreStaffDao extends BaseMybatisDAO {
	private static final String MAPPER_NAMESPACE = "cn.haliaeetus.sendmessage.dao.mapper.StoreStaffMapper.";
	
/* ****************************插入*************************** 	*/	
	/**
	 * 选择性添加，不需要更新字段设空null
	 * @param entity
	 * @return
	 */
	public int insert(final StoreStaff entity){
		save(MAPPER_NAMESPACE+"insertSelective", entity);
		return entity.getId();
	}
	
/* ****************************更新*************************** 	*/	
	/**
	 * 根据主键，更新所有数据
	 * @param entity
	 * @return
	 */
	public int update(final StoreStaff entity){
		return update(MAPPER_NAMESPACE+"updateByPrimaryKey", entity);
	}
	
	/**
	 * 根据主键，可选数据更新,不需要更新字段设空null
	 * @param entity
	 * @return
	 */
	public int updateSelective(final StoreStaff entity){
		return update(MAPPER_NAMESPACE+"updateByPrimaryKeySelective", entity);
	}
	
	
/* ****************************查询*************************** 	*/		
	/**
	 * 根据主键查询
	 * @param id
	 * @return
	 */
	public StoreStaff getById(final String id){
		return findOne(MAPPER_NAMESPACE+"selectByPrimaryKey", id);
	}
	/**
	 * 查询所有所有数据
	 * @return
	 */
	public List<StoreStaff> getAll(){
		return findAll(MAPPER_NAMESPACE+"selectAll");
	}
	
	/**
	 * 查询storeId关联所有数据
	 * @return
	 */
	public List<StoreStaff> getByStoreId(int storeId) {
		return findAll(MAPPER_NAMESPACE + "selectByStoreId", storeId);
	}
	
/* ****************************删除*************************** 	*/	
	/**
	 * 根据主键删除，软删除
	 * @param id
	 * @return
	 */
	public int delete(final int id){
		return delete(MAPPER_NAMESPACE+"delete", id);
	}

    public int deleteIn(String ids) {
    	Map<String, Object> params = new HashMap<String, Object>();
		params.put("id", ids);
        return delete(MAPPER_NAMESPACE+"deleteIn", params);
    }
}
