package cn.haliaeetus.sendmessage.enums;

import org.apache.logging.log4j.util.Strings;

import java.util.HashMap;
import java.util.Map;

/**
 * 缓存类型
 */
public enum RedisTypeEnum {

    /**
     * 代表所有缓存
     */
    ALL(0, "all","所有"),
    /**
     * 快递
     */
    EXPRESS(1, "express","快递"),
    /**
     * 菜单
     */
    MENU(2, "menu","菜单"),
    /**
     * 手机号码
     */
    PHONE(3, "phone","手机号码"),
    /**
     * 用户信息
     */
    USER(4, "user","用户"),
    /**
     * 货架
     */
    STORESHELFTOOL(5, "storeShelf","货架SS"),
    /**
     *
     */
    CONFIGURATION(6, "configuration","O"),
    SHELFTOOL(7, "shelfTool","货架ST"),

    /**
     * 门店信息
     */
    STORE(8, "store","门店"),
    /**
     * 类型
     */
    TYPELIBRARYTOOL(9,"typeLibraryTool","类型");

    private int code;
    private String enName;
    private String cnName;

    private RedisTypeEnum(int code, String enName,String cnName){
        this.code=code;
        this.enName=enName;
        this.cnName = cnName;
    }

    public int getCode() {
        return code;
    }

    public void setCode(int code) {
        this.code = code;
    }

    public String getEnName() {
        return enName;
    }

    public void setEnName(String enName) {
        this.enName = enName;
    }

    public String getCnName() {
        return cnName;
    }

    public void setCnName(String cnName) {
        this.cnName = cnName;
    }

    public static String of(int code) {
        for (RedisTypeEnum returnCode : RedisTypeEnum.values()) {
            if (returnCode.getCode()==code) {
                return returnCode.getEnName();
            }
        }
        return "没有对接回传接口";
    }

    /**
     * 返回所有enName和cnName
     * @return
     */
    public static Map<String,String> getValues(){
        Map<String,String> values = new HashMap<>();
        for (RedisTypeEnum returnCode : RedisTypeEnum.values()) {
            values.put(returnCode.getEnName(),returnCode.cnName);
        }
        return values;
    }

    public static RedisTypeEnum getRedisType(String enName) {
        if(Strings.isEmpty(enName)){
            return  RedisTypeEnum.ALL;
        }
        switch (enName) {
            case "all":
                return RedisTypeEnum.ALL;
            case "express":
                return RedisTypeEnum.EXPRESS;
            case "menu":
                return RedisTypeEnum.MENU;
            case "phone":
                return RedisTypeEnum.PHONE;
            case "user":
                return RedisTypeEnum.USER;
            case "storeShelf":
                return RedisTypeEnum.STORESHELFTOOL;
            case "configuration":
                return RedisTypeEnum.CONFIGURATION;
            case "shelfTool":
                return RedisTypeEnum.SHELFTOOL;
            case "store":
                return RedisTypeEnum.STORE;
            case "typeLibraryTool":
                return RedisTypeEnum.TYPELIBRARYTOOL;
            default:
                return RedisTypeEnum.ALL;
        }
    }

}
