/**
 * @FileName: BaseEntity.java
 * @Package main.java.cn.haliaeetus.framework.base.entity
 * 
 * @author warship
 * @created 2013年11月9日 下午7:49:28
 * 
 * Copyright 2013-2050 佰颂物联 版权所有
 */
package cn.haliaeetus.sendmessage.framework.entity.baseEntity;

import cn.haliaeetus.sendmessage.bean.MqBean;

import java.io.Serializable;
import java.lang.reflect.Field;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

/**
 * <p>实体基类</p>
 * 
 * @author warship
 * @since 1.0
 * @version 1.0
 */
public abstract class BaseEntity extends MqBean implements Serializable , Cloneable{

	private static final long serialVersionUID = -6001916081185698608L;
	
	protected Integer id;
	
	public Integer getId() {
		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	/**
	 * 
	 * toString方法，返回属性名称及值
	 *
	 * @author warship
	 * @created 2013年11月9日 下午7:50:44
	 *
	 * @return	属性名称及值，格式：[name]张三 [sex]男
	 */
	@Override
	public String toString() {
		try {
			return trim(this.getClass());
		} catch (SecurityException e) {
			e.printStackTrace();
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			e.printStackTrace();
		}
		return "";
	}

	private String trim(Class<? extends Object> clazz) throws NoSuchMethodException, InvocationTargetException, IllegalAccessException {
		if (Object.class.equals(clazz.getSuperclass())) {
			return "";
		}

		StringBuffer result = new StringBuffer();
		result.append(trim(clazz.getSuperclass()));

		Field [] fields = clazz.getDeclaredFields();
		for (Field field : fields) {
			String fieldName = field.getName();
			if ("serialVersionUID".equals(fieldName)) {
				continue;
			}
			String methodName = "get" + fieldName.substring(0,1).toUpperCase() + fieldName.substring(1, fieldName.length());
			Method method;
			Object resultObj;
			method = clazz.getMethod(methodName);
			resultObj = method.invoke(this);
			if (resultObj != null && !"".equals(resultObj)) {
				result.append("[").append(fieldName).append("]").append(resultObj).append(" ");
			}
		}
		return result.toString();
	}
}