package cn.haliaeetus.sendmessage.framework.factory.express.realize;

import cn.haliaeetus.sendmessage.bean.basedata.SignBackSwitchBean;
import cn.haliaeetus.sendmessage.bean.basedata.Store;
import cn.haliaeetus.sendmessage.bean.basedata.UpdateBestLogisticsBean;
import cn.haliaeetus.sendmessage.bean.delivery.Delivery;
import cn.haliaeetus.sendmessage.bean.dto.SignBackDto;
import cn.haliaeetus.sendmessage.bean.express.BestLogisticsBean;
import cn.haliaeetus.sendmessage.controller.web.QueryCondition.DeliveryQueryCondition;
import cn.haliaeetus.sendmessage.framework.factory.express.BaseExpress;
import cn.haliaeetus.sendmessage.framework.util.OkHttpUtil;
import cn.haliaeetus.sendmessage.service.BasicInfoService;
import cn.haliaeetus.sendmessage.service.DeliveryService;
import cn.haliaeetus.sendmessage.service.ExpressHandleService;
import cn.haliaeetus.sendmessage.service.delivery.DeliveryMsgTemplateConfigService;
import com.alibaba.fastjson.JSON;
import com.google.common.base.Strings;
import com.jfinal.weixin.sdk.utils.JsonUtils;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.text.SimpleDateFormat;
import java.util.*;

/**
 * @ClassName BastExpress
 * @Description 百世
 * @Author Administrator
 * @Date 2019/8/28 0028 下午 16:55
 * @Version 1.0
 **/
@Slf4j
@Component("223")
public class BastExpress implements BaseExpress {

    @Autowired
    private DeliveryMsgTemplateConfigService deliveryMsgTemplateConfigService;

    @Autowired
    private BasicInfoService basicInfoService;

    @Autowired
    private DeliveryService deliveryService;

    @Autowired
    private ExpressHandleService expressHandleService;

    @Override
    public void expressSignBack(SignBackDto signBackDto) {
        int returnSignFlag = 0;
        if("in".equals(signBackDto.getActionType())){
            returnSignFlag = 3;
        }else{
            returnSignFlag = 1;
        }
        this.signBackBest(signBackDto.getExpCode(), signBackDto.getTelPhone(), signBackDto.getShelfCode(), signBackDto.getStore(), returnSignFlag);
    }

    private String signBackBest(String expCode, String telPhone, String shelfCode, Store store, int returnSignFlag){
        SignBackSwitchBean signBackSwitchBean = expressHandleService.getSignBackSwitch(223 , store.getId());
        if(!signBackSwitchBean.getIs_syStore() || !signBackSwitchBean.getIs_syUpStore()){
            syBest(store);
        }
        String url=basicInfoService.getConfigurationByCode("baishiSignBackUrl").getOValue1();
//                    Store store=basicInfoService.getStoreById(user.getStoreId());
        UpdateBestLogisticsBean bestPram = new UpdateBestLogisticsBean();
        bestPram.setBillCode(expCode);
        bestPram.setOperator("BESTEXP");
        bestPram.setTransactionCode(UUID.randomUUID().toString());//交易号，标记各状态消息所属的投递流程，全局唯一，建议使用UUID或（服务商编码＋本地唯一串）
        //1、同一单号在一次入库（S01）、出库(S02)、异常状态(S03\04)的推送时，交易号唯一相同；
        //2、同一单号二次入库时，交易号可以进行变更
        bestPram.setServiceProviderCode("fengzhan");//百世提供
        bestPram.setServiceSiteCode(store.getId().toString());//客户自定义
        bestPram.setStatus(returnSignFlag==3?"S01":"S02");
        bestPram.setRemark("");
        // 取件码 在业务操作S01状态时，推送取件码信息。
        if(returnSignFlag==3){
            bestPram.setPassword(shelfCode);
        }
        SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        Date date=new Date();
        bestPram.setRequestTime(df.format(date));
        try{
            log.info("param................."+ JsonUtils.toJson(bestPram));
            String res= OkHttpUtil.postJson(url,bestPram);
            log.info("res..............................."+res);
            if(res.indexOf("处理成功")>0){
                DeliveryQueryCondition qc1 = new DeliveryQueryCondition(store.getId());
                Delivery delivery=new Delivery();
                delivery.setRemark("success");
                qc1.setEntity(delivery);
                log.info("sssssssssssss");
                qc1.setSignFlag(returnSignFlag+"");
                qc1.setReturnSignStatus(returnSignFlag);
                qc1.setUserPhone(telPhone.trim());
                qc1.setExp_code(expCode);
                boolean result = deliveryService.update(qc1);
                log.info("sssssssssssss"+result);
            }else{
                DeliveryQueryCondition qc1 = new DeliveryQueryCondition(store.getId());
                Delivery delivery=new Delivery();
                delivery.setRemark(res.substring(res.length()-20,res.length()-2));
                qc1.setEntity(delivery);
                log.info("sssssssssssss");
                qc1.setSignFlag((returnSignFlag+1)+"");
                qc1.setReturnSignStatus(returnSignFlag+1);
                qc1.setUserPhone(telPhone.trim());
                qc1.setExp_code(expCode);
                boolean result = deliveryService.update(qc1);
                log.info("sssssssssssss"+result);
            }
            // 在业务操作S01状态时，调用百世C网服务点抽检数据提交接口
            if (returnSignFlag == 3) {
                inspectionSubmit(expCode, telPhone, null);
            }

        }catch (Exception e){
            log.error(e.getMessage());
            DeliveryQueryCondition qc1 = new DeliveryQueryCondition(store.getId());
            Delivery delivery=new Delivery();
            delivery.setRemark(e.getMessage()==null?"NULL":e.getMessage().substring(0,30));
            qc1.setEntity(delivery);
            qc1.setSignFlag((returnSignFlag+1)+"");
            qc1.setReturnSignStatus(returnSignFlag+1);
            qc1.setUserPhone(telPhone.trim());
            qc1.setExp_code(expCode);
            boolean result = deliveryService.update(qc1);
            log.info("sssssssssssss"+result);
        }
        return "223";
    }
    public String syBest(Store store){
        String url=basicInfoService.getConfigurationByCode("bestSyStoreUrl").getOValue1();//百世同步门店数据
        BestLogisticsBean bestStorePram = new BestLogisticsBean();
        bestStorePram.setCabinetCode(store.getId().toString());//门店编码
        bestStorePram.setServiceSiteName(basicInfoService.getSystem("fengzhan")?"蜂站":store.getShortName());//门店名称
        bestStorePram.setPhone(store.getTakeExpressPhone());
        bestStorePram.setProvince(store.getProvinceName());
        bestStorePram.setCity(store.getCityName());
        bestStorePram.setCounty(store.getAreaName());
        bestStorePram.setAddress("-"+store.getShortAddress());//短地址1
        bestStorePram.setCabinetSpId("");//服务提供商ID
        bestStorePram.setCabinetSpCode("fengzhan");//服务提供商编码
        bestStorePram.setCabinetSpName("百世快递");//服务提供商名称
        bestStorePram.setLongitude(store.getLongitude());//经度
        bestStorePram.setLatitude(store.getLatitude());//纬度
        bestStorePram.setState(store.getStatus()==0?"false":"true");
        bestStorePram.setTown(store.getTownship());
        String res = "";
        try{
            List<BestLogisticsBean> bestStorePramList = new ArrayList<BestLogisticsBean>();
            bestStorePramList.add(bestStorePram);
            log.info("param................."+JsonUtils.toJson(bestStorePramList));
            res=OkHttpUtil.postJson(url,bestStorePramList);
            log.info("res..............................."+res);
            if(res.indexOf("success")>0){
                SignBackSwitchBean signBackSwitchBean = expressHandleService.getSignBackSwitch(223 , store.getId());
                expressHandleService.updateSignBackSwitch(signBackSwitchBean);
                return "1";
            }
        }catch (Exception e){
            log.error(e.getMessage());
            log.info("sssssssssssss"+res);
            return "-1";
        }
        return "-1";
    }

    /**
     * C网服务点抽检数据提交接口
     */
    private void inspectionSubmit(String mailNo, String acceptManPhone, String acceptManName) {
        Map<String, String> parameter = new HashMap<>();
        parameter.put("mailNo", mailNo);
        if (!Strings.isNullOrEmpty(acceptManName)) {
            parameter.put("acceptManName", acceptManName);
        }
        parameter.put("acceptManPhone", acceptManPhone);

        try {
            log.info("百世-调用C网服务点抽检数据提交接口 入参：" + JSON.toJSONString(parameter));
            String url = basicInfoService.getConfigurationByCode("bestInspectionUrl").getOValue1();
            String res = OkHttpUtil.postJson(url, parameter);
            log.info("百世-调用C网服务点抽检数据提交接口 返回结果：" + res);
        } catch (Exception e) {
            log.info("百世-调用C网服务点抽检数据提交接口异常，Exception:" + e);
        }

    }
}
