package cn.haliaeetus.sendmessage.framework.factory.express.realize;

import cn.haliaeetus.sendmessage.bean.basedata.SignBackSwitchBean;
import cn.haliaeetus.sendmessage.bean.basedata.Store;
import cn.haliaeetus.sendmessage.bean.dto.SignBackDto;
import cn.haliaeetus.sendmessage.bean.express.*;
import cn.haliaeetus.sendmessage.bean.express.yuantong.YTOCabinetInfo;
import cn.haliaeetus.sendmessage.bean.express.yuantong.YTOOperData;
import cn.haliaeetus.sendmessage.bean.express.yuantong.YTOResponse;
import cn.haliaeetus.sendmessage.framework.factory.express.BaseExpress;
import cn.haliaeetus.sendmessage.framework.util.OkHttpUtil;
import cn.haliaeetus.sendmessage.service.BasicInfoService;
import cn.haliaeetus.sendmessage.service.DeliveryService;
import cn.haliaeetus.sendmessage.service.ExpressHandleService;
import cn.haliaeetus.sendmessage.service.delivery.DeliveryMsgTemplateConfigService;
import cn.haliaeetus.sendmessage.utils.DateUtil;
import cn.haliaeetus.sendmessage.utils.XMLUtil4jdom;
import com.alibaba.fastjson.JSON;
import com.jfinal.weixin.sdk.utils.JsonUtils;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Component;

import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.Map;
import java.util.Optional;

/**
 * @ClassName YuanTongExpress
 * @Description TODO
 * @Author Administrator
 * @Date 2019/8/28 0028 下午 16:56
 * @Version 1.0
 **/
@Slf4j
@Component("202")
public class YuanTongExpress implements BaseExpress {

    @Autowired
    private DeliveryMsgTemplateConfigService deliveryMsgTemplateConfigService;

    @Autowired
    private BasicInfoService basicInfoService;

    @Autowired
    private DeliveryService deliveryService;

    @Autowired
    private ExpressHandleService expressHandleService;

    private final String logistics_api_test = null; // "http://127.0.0.1:8089";

    @Override
    public void expressSignBack(SignBackDto signBackDto) {
        int returnSignFlag = 0;
        if ("in".equals(signBackDto.getActionType())) {
            returnSignFlag = 3;
        } else {
            returnSignFlag = 1;
        }
        this.signBackYuantong1(signBackDto.getExpCode(), signBackDto.getTelPhone(), signBackDto.getStore(), signBackDto.getShelfId(), signBackDto.getShelfCode(), returnSignFlag);
    }

    private String signBackYuantong1(String expCode, String telPhone, Store store, String shelfId, String shelfCode, int returnSignFlag) {
        SignBackSwitchBean signBackSwitchBean = expressHandleService.getSignBackSwitch(202, store.getId());
        if (!signBackSwitchBean.getIs_syStore()) {
            // syYuantongStore(store);
            // 终端第三方信息登记接口
            modifyCabinetInfo(store, signBackSwitchBean, false);
        }
        signBackSwitchBean = expressHandleService.getSignBackSwitch(202, store.getId());
//        if (!signBackSwitchBean.getIs_syAcperson()) {
//            syYuantongAcPerson(store, signBackSwitchBean.getYuantongStoreCode());
//        }
        if (!signBackSwitchBean.getIs_syUpStore()) {
            // syUpYuantongStore(store, signBackSwitchBean.getYuantongStoreCode());
            // 终端第三方信息修改接口
            modifyCabinetInfo(store, signBackSwitchBean, true);
        }
        // 操作信息同步
        synOperData(expCode, signBackSwitchBean.getYuantongStoreCode(), returnSignFlag == 3 ? "STA_INBOUND" : "STA_SIGN", shelfCode, telPhone, store.getShortAddress());
//        String url = basicInfoService.getConfigurationByCode("yuantongSignbackUrl1").getOValue1();//签收
//        YuantongBean yuantongBean = null;
//        if (returnSignFlag == 3) {
//            YuantongInboundBean yuantongInboundBean = new YuantongInboundBean();
//            yuantongInboundBean.setWaybillNo(expCode);
//            yuantongInboundBean.setOpCode("1730");
//            yuantongInboundBean.setOpTime(DateUtil.getTime());
//            yuantongInboundBean.setOpUserId(store.getBackupPhone());
//            yuantongInboundBean.setPreviousOrgCode("999999");
//            yuantongInboundBean.setEmpCode("00753572");
//            yuantongInboundBean.setTakeCode(shelfCode);
//            yuantongInboundBean.setOrgCode("999999");
//            yuantongInboundBean.setLogisticsCode("BLC00001");
//            yuantongInboundBean.setStationCode(signBackSwitchBean.getYuantongStoreCode());
//            yuantongInboundBean.setCustomerCode(basicInfoService.getConfigurationByCode("yuantongSignbackPartnerID").getOValue1());//?客户渠道编码
//            yuantongBean = new YuantongBean();
//            yuantongBean.setLogistics_interface(JsonUtils.toJson(yuantongInboundBean));
//            yuantongBean.setKey(basicInfoService.getConfigurationByCode("yuantongSignbackKey").getOValue1());
//            yuantongBean.setCustomer_code(basicInfoService.getConfigurationByCode("yuantongSignbackPartnerID").getOValue1());
//            yuantongBean.setStation_type("5501");
//            yuantongBean.setOrg_code("999999");
//            yuantongBean.setOp_code("1730");
//
//        } else {
//            YuantongOutboundBean yuantongOutboundBean = new YuantongOutboundBean();
//            yuantongOutboundBean.setWaybillNo(expCode);
//            yuantongOutboundBean.setOpCode("1745");
//            yuantongOutboundBean.setOpTime(DateUtil.getTime());
//            yuantongOutboundBean.setOpUserId(store.getBackupPhone());
//            yuantongOutboundBean.setOrgCode("999999");
//            yuantongOutboundBean.setLogisticsCode("BLC00001");
//            yuantongOutboundBean.setRecieverSigNoff("凭取件码");
//            yuantongOutboundBean.setRecieverPhone(telPhone);
//            yuantongOutboundBean.setStationCode(signBackSwitchBean.getYuantongStoreCode());
//            yuantongOutboundBean.setCustomerCode(basicInfoService.getConfigurationByCode("yuantongSignbackPartnerID").getOValue1());//?客户渠道编码
//            yuantongBean = new YuantongBean();
//            yuantongBean.setLogistics_interface(JsonUtils.toJson(yuantongOutboundBean));
//            yuantongBean.setKey(basicInfoService.getConfigurationByCode("yuantongSignbackKey").getOValue1());
//            yuantongBean.setCustomer_code(basicInfoService.getConfigurationByCode("yuantongSignbackPartnerID").getOValue1());
//            yuantongBean.setStation_type("5501");
//            yuantongBean.setOrg_code("999999");
//            yuantongBean.setOp_code("1745");
//        }
//
//        String res = "";
//        try {
//            log.info("param................." + yuantongBean.getLogistics_interface());
//            res = OkHttpUtil.postJson(url, yuantongBean);
//            Map<String, String> resMap = XMLUtil4jdom.doXMLParse(res);
//            log.info("res..............................." + res);
//            if (res.indexOf("success") > 0) {
//                DeliveryQueryCondition qc2 = new DeliveryQueryCondition(store.getId());
//                Delivery delivery1 = new Delivery();
//                delivery1.setRemark("success");
//                qc2.setEntity(delivery1);
//                log.info("sssssssssssss");
//                qc2.setSignFlag(returnSignFlag + "");
//                qc2.setReturnSignStatus(returnSignFlag);
//                qc2.setUserPhone(telPhone);
//                qc2.setExp_code(expCode);
//                boolean result = deliveryService.update(qc2);
//                log.info("sssssssssssss" + result);
//            } else {
//                DeliveryQueryCondition qc2 = new DeliveryQueryCondition(store.getId());
//                Delivery delivery1 = new Delivery();
//                delivery1.setRemark(resMap.get("errorCode"));
//                qc2.setEntity(delivery1);
//                log.info("sssssssssssss");
//                qc2.setSignFlag((returnSignFlag + 1) + "");
//                qc2.setReturnSignStatus(returnSignFlag + 1);
//                qc2.setUserPhone(telPhone);
//                qc2.setExp_code(expCode);
//                boolean result = deliveryService.update(qc2);
//                log.info("sssssssssssss" + result);
//            }
//        } catch (Exception e) {
//            log.error(e.getMessage());
//            DeliveryQueryCondition qc3 = new DeliveryQueryCondition(store.getId());
//            Delivery delivery2 = new Delivery();
//            delivery2.setRemark(e.getMessage() == null ? "NULL" : e.getMessage().substring(0, 30));
//            qc3.setEntity(delivery2);
//            qc3.setSignFlag((returnSignFlag + 1) + "");///代签失败
//            qc3.setReturnSignStatus(returnSignFlag + 1);//代签失败
//            qc3.setUserPhone(telPhone);
//            qc3.setExp_code(expCode);
//            boolean result = deliveryService.update(qc3);
//            log.info("sssssssssssss" + result);
//        }
//        if (returnSignFlag == 3) {
//            shelvesYuantong(expCode, telPhone, store, shelfId, shelfCode, signBackSwitchBean.getYuantongStoreCode(), url);//上架操作
//            //kael于2019-07-05添加逻辑：上架之后调用圆通通知回执接口
//            this.yuanTongNoticeReturn(expCode, signBackSwitchBean.getYuantongStoreCode(), url);
//        }
        return "202";
    }

    private void synOperData(String waybillNo, String stationCode, String action, String takeCode, String recipientPhone, String storeAddress) {
        YTOOperData operData = new YTOOperData();
        // 单号
        operData.setWaybillNo(waybillNo);
        // 圆通终端编码
        operData.setStationCode(stationCode);
        // 是终端品牌编码(提供)
        // operData.setCustomerCode("gir9r7tu");
        // 操作时间 格式：yyyy-MM-dd HH:mm:ss
        operData.setOpTime(LocalDateTime.now().format(DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss")));
        // 操作类型 入库入柜/STA_INBOUND 用户签收/STA_SIGN 异常出库出柜/STA_MAILMAN_PICKUP
        operData.setAction(action);
        // 取货码 入库入柜操作时必填
        operData.setTakeCode(takeCode);
        // 收件人手机
        operData.setRecipientPhone(recipientPhone);
        // 通知方式 微信/WX  短信/DX 语音/YY
        operData.setNoticeType("DX");
        // 通知内容 入库入柜操作时必填
        operData.setNoticeContent("您的圆通" + waybillNo + "已到" + storeAddress + "，取货码" + takeCode + "，请前来领取");
        // 异常原因编码(参考1.4.2）
        // operData.setFailCode();
        // 异常原因(参考1.4.2）
        // operData.setFailReason();
        // 备注
        // operData.setDesc();

        try {
            String url = Optional.ofNullable(logistics_api_test).orElse(basicInfoService.getConfigurationByCode("LOGISTICS_API").getOValue1()) + "/yto/synOperData";
            String res = OkHttpUtil.postJson(url, operData);
            System.out.println(res);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void modifyCabinetInfo(Store store, SignBackSwitchBean signBackSwitchBean, boolean isUpdate) {
        YTOCabinetInfo info = new YTOCabinetInfo();
        // 终端编号
        info.setCabinetCode(String.valueOf(store.getId()));
        // 终端名称
        info.setCabinetName(store.getShortName());
        // 终端所属省份
        info.setCabinetBelongProv(store.getProvinceName());
        // 终端所属城市
        info.setCabinetBelongCity(store.getCityName());
        // 终端所属区县
        info.setCabinetBelongCounty(store.getAreaName());
        // 终端所属乡镇/街道
        info.setCabinetBelongTowns(store.getTownship());
        // 终端详细地址
        info.setCabinetAddress(store.getShortAddress());
        // 负责人
        info.setEmployee(store.getOwner());
        // 负责人电话
        info.setEmpPhone(store.getPhone());
        // 客服电话
        info.setCustomerPhone(store.getTakeExpressPhone());
        // 终端规格
        // info.setCabinetSpec();
        // 终端类型(YZ/ZTG)
        info.setDeviceType("YZ");
        // 终端第三方合作商
        // info.setDevicePartner();

        if (isUpdate) {
            // 更新门店数据
            info.setStationCode(signBackSwitchBean.getYuantongStoreCode());
            try {
                String url = Optional.ofNullable(logistics_api_test).orElse(basicInfoService.getConfigurationByCode("LOGISTICS_API").getOValue1()) + "/yto/updateCabinetInfo";
                String res = OkHttpUtil.postJson(url, info);
                YTOResponse ytoResponse = JSON.parseObject(res, YTOResponse.class);
            } catch (Exception e) {
                e.printStackTrace();
            }
        } else {
            // 注册门店
            try {
                String url = Optional.ofNullable(logistics_api_test).orElse(basicInfoService.getConfigurationByCode("LOGISTICS_API").getOValue1()) + "/yto/saveCabinetInfo";
                String res = OkHttpUtil.postJson(url, info);
                YTOResponse ytoResponse = JSON.parseObject(res, YTOResponse.class);
                if (ytoResponse != null && "success".equals(ytoResponse.getAccept())) {
                    SignBackSwitchBean signBackSwitch = expressHandleService.getSignBackSwitch(202, store.getId());
                    signBackSwitch.setYuantongStoreCode(ytoResponse.getStationCode());
                    expressHandleService.updateSignBackSwitch(signBackSwitch);
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

    /**
     * 圆通通知回执接口，kael于2019-07-05添加
     *
     * @return
     */
    public String yuanTongNoticeReturn(String expCode, String stationCode, String url) {
        YuantongReturnBean yuantongReturnBean = new YuantongReturnBean();
        yuantongReturnBean.setWaybillNo(expCode);
        yuantongReturnBean.setStationCode(stationCode);
        yuantongReturnBean.setCustomerCode(basicInfoService.getConfigurationByCode("yuantongSignbackPartnerID").getOValue1());//?客户渠道编码
//		yuantongReturnBean.setPreviousOrgCode("999999");//上一个网点编号
//		yuantongReturnBean.setOrgCode("999999");
//		yuantongReturnBean.setLogisticsCode("BLC00001");
//		yuantongReturnBean.setReceiptType();
//		yuantongReturnBean.setReceiptResult();
//		yuantongReturnBean.setReceiptFailReason();
        yuantongReturnBean.setOpTime(DateUtil.getTime());
        yuantongReturnBean.setReceiptTime(DateUtil.getTime());
        YuantongBean yuantongBean = new YuantongBean();
        yuantongBean.setLogistics_interface(JsonUtils.toJson(yuantongReturnBean));
        yuantongBean.setKey(basicInfoService.getConfigurationByCode("yuantongSignbackKey").getOValue1());
        yuantongBean.setCustomer_code(basicInfoService.getConfigurationByCode("yuantongSignbackPartnerID").getOValue1());
        yuantongBean.setStation_type("5501");
        yuantongBean.setOrg_code("999999");
        yuantongBean.setOp_code("2000");
        String res = "";
        try {
            log.info("param................." + yuantongBean.getLogistics_interface());
            res = OkHttpUtil.postJson(url, yuantongBean);
            Map<String, String> resMap = XMLUtil4jdom.doXMLParse(res);
            log.info("通知回执操作::::" + res);
        } catch (Exception e) {
            log.error("上架操作::::" + e.getMessage());
        }
        return "202";
    }

    public String syUpYuantongStore(Store store, String storeCode) {
        // 圆通同步门店数据
        String url = Optional.ofNullable(logistics_api_test).orElse(basicInfoService.getConfigurationByCode("yuantongSignbackUrl1").getOValue1());
        YuantongSyUpStoreBean yuantongStorePram = new YuantongSyUpStoreBean();
        yuantongStorePram.setStationBelongProv(String.valueOf(store.getProvinceId()).length() == 2 ? "0" + String.valueOf(store.getProvinceId()) : String.valueOf(store.getProvinceId()));
        yuantongStorePram.setStationBelongCity(String.valueOf(store.getCityId()));
        yuantongStorePram.setStationBelongCounty(String.valueOf(store.getAreaId()));
        yuantongStorePram.setStationBelongTowns(String.valueOf(Optional.ofNullable(store.getTownshipId()).orElse(0)));
        yuantongStorePram.setStationAddress(store.getShortAddress() + "-" + basicInfoService.getConfigurationByCode("signBackName").getOValue1());
        yuantongStorePram.setOrgCode("999999");
        yuantongStorePram.setCustomerCode(basicInfoService.getConfigurationByCode("yuantongSignbackPartnerID").getOValue1());//?客户渠道编码
        yuantongStorePram.setStationCode(storeCode);
        yuantongStorePram.setSmsMobile(store.getTakeExpressPhone());
        yuantongStorePram.setOpCode("0002");
        YuantongBean yuantongBean = new YuantongBean();
        yuantongBean.setLogistics_interface(JsonUtils.toJson(yuantongStorePram));
        yuantongBean.setKey(basicInfoService.getConfigurationByCode("yuantongSignbackKey").getOValue1());
        yuantongBean.setCustomer_code(basicInfoService.getConfigurationByCode("yuantongSignbackPartnerID").getOValue1());
        yuantongBean.setStation_type("5501");
        yuantongBean.setOrg_code("999999");
        yuantongBean.setOp_code("0002");
        String res = "";
        try {
            log.info("param................." + JsonUtils.toJson(yuantongStorePram));
            res = OkHttpUtil.postJson(url, yuantongBean);
            log.info("res..............................." + res);
            if (res.indexOf("success") > 0) {
                SignBackSwitchBean signBackSwitchBean = expressHandleService.getSignBackSwitch(202, store.getId());
                expressHandleService.updateSignBackSwitch(signBackSwitchBean);
                return "1";
            }
        } catch (Exception e) {
            log.error(e.getMessage());
            log.info("sssssssssssss" + res);
            return "-1";
        }
        return "-1";
    }

    @Async
    public String shelvesYuantong(String expCode, String telPhone, Store store, String shelfId, String shelfCode, String yuantongStoreCode, String url) {
        YuantongBean yuantongBean = null;
        YuantongShelvesBean yuantongShelvesBean = new YuantongShelvesBean();
        yuantongShelvesBean.setWaybillNo(expCode);
        yuantongShelvesBean.setOpCode("1735");
        yuantongShelvesBean.setOpTime(DateUtil.getTime());
        yuantongShelvesBean.setOpUserId(store.getBackupPhone());
        yuantongShelvesBean.setOrgCode("999999");
        yuantongShelvesBean.setLogisticsCode("BLC00001");
        yuantongShelvesBean.setStationCode(yuantongStoreCode);
        yuantongShelvesBean.setCustomerCode(basicInfoService.getConfigurationByCode("yuantongSignbackPartnerID").getOValue1());//?客户渠道编码
        yuantongShelvesBean.setRackNo(shelfId);
        yuantongShelvesBean.setTakeCode(shelfCode);
        yuantongShelvesBean.setDestPhone(telPhone);
        yuantongShelvesBean.setNoticeType("DX");
        yuantongShelvesBean.setNoticeContent("您的圆通" + expCode + "已到" + store.getShortAddress() + "，取货码" + shelfCode + "，请前来领取。寄件到蜂站");
        yuantongBean = new YuantongBean();
        yuantongBean.setLogistics_interface(JsonUtils.toJson(yuantongShelvesBean));
        yuantongBean.setKey(basicInfoService.getConfigurationByCode("yuantongSignbackKey").getOValue1());
        yuantongBean.setCustomer_code(basicInfoService.getConfigurationByCode("yuantongSignbackPartnerID").getOValue1());
        yuantongBean.setStation_type("5501");
        yuantongBean.setOrg_code("999999");
        yuantongBean.setOp_code("1735");
        String res = "";
        try {
            log.info("param................." + yuantongBean.getLogistics_interface());
            res = OkHttpUtil.postJson(url, yuantongBean);
            Map<String, String> resMap = XMLUtil4jdom.doXMLParse(res);
            log.info("res..............................." + res);
            if (res.indexOf("success") > 0) {
                log.info("上架操作::::" + res);
            } else {
                log.info("上架操作::::" + res);
            }
        } catch (Exception e) {
            log.error("上架操作::::" + e.getMessage());
        }
        return "202";
    }

    public String syYuantongStore(Store store) {
        // 圆通同步门店数据
        String url = Optional.ofNullable(logistics_api_test).orElse(basicInfoService.getConfigurationByCode("yuantongSignbackUrl1").getOValue1());
        YuantongSyStoreBean yuantongStorePram = new YuantongSyStoreBean();
//		yuantongStorePram.setBusinessTime(DateUtil.getTime());
        yuantongStorePram.setGloryNo(store.getId().toString());
        yuantongStorePram.setStationName(store.getShortAddress());
        yuantongStorePram.setStationBelongProv(String.valueOf(store.getProvinceId()).length() == 2 ? "0" + String.valueOf(store.getProvinceId()) : String.valueOf(store.getProvinceId()));
        yuantongStorePram.setStationBelongCity(String.valueOf(store.getCityId()));
        yuantongStorePram.setStationBelongCounty(String.valueOf(store.getAreaId()));
        yuantongStorePram.setStationBelongTowns(String.valueOf(Optional.ofNullable(store.getTownshipId()).orElse(0)));
        yuantongStorePram.setStationAddress(store.getShortAddress() + "-" + basicInfoService.getConfigurationByCode("signBackName").getOValue1());
        yuantongStorePram.setEmpCode("00753572");
        yuantongStorePram.setEmpMngCode(store.getBackupPhone());
        yuantongStorePram.setOrgCode("999999");
        yuantongStorePram.setPositionCode("01");
        yuantongStorePram.setOperateCode("22");
        yuantongStorePram.setStationMobile(store.getBackupPhone());
        yuantongStorePram.setStationType("5501");
        yuantongStorePram.setLogisticsCode("BLC00001");
        yuantongStorePram.setCustomerCode(basicInfoService.getConfigurationByCode("yuantongSignbackPartnerID").getOValue1());//?客户渠道编码
        YuantongBean yuantongBean = new YuantongBean();
        yuantongBean.setLogistics_interface(JsonUtils.toJson(yuantongStorePram));
        yuantongBean.setKey(basicInfoService.getConfigurationByCode("yuantongSignbackKey").getOValue1());
        yuantongBean.setCustomer_code(basicInfoService.getConfigurationByCode("yuantongSignbackPartnerID").getOValue1());
        yuantongBean.setStation_type("5501");
        yuantongBean.setOrg_code("999999");
        yuantongBean.setOp_code("0000");
        String res = "";
        try {
            log.info("param................." + JsonUtils.toJson(yuantongStorePram));
            res = OkHttpUtil.postJson(url, yuantongBean);
            log.info("res..............................." + res);
            Map<String, String> resMap = XMLUtil4jdom.doXMLParse(res);
            if (res.indexOf("success") > 0) {
                expressHandleService.OpenStore(store.getId(), 202);
                SignBackSwitchBean signBackSwitchBean = expressHandleService.getSignBackSwitch(202, store.getId());
                signBackSwitchBean.setYuantongStoreCode(resMap.get("stationCode"));
                expressHandleService.updateSignBackSwitch(signBackSwitchBean);
                return "1";
            } else {
                SignBackSwitchBean signBackSwitchBean = expressHandleService.getSignBackSwitch(202, store.getId());
                signBackSwitchBean.setYuantongStoreCode(resMap.get("errorCode"));
                expressHandleService.updateSignBackSwitch(signBackSwitchBean);
            }
        } catch (Exception e) {
            log.error(e.getMessage());
            log.info("sssssssssssss" + res);
            return "-1";
        }
        return "-1";
    }

    public String syYuantongAcPerson(Store store, String storeCode) {
        String url = Optional.ofNullable(logistics_api_test).orElse(basicInfoService.getConfigurationByCode("yuantongSignbackUrl1").getOValue1());
        YuantongSyAcPersonBean yuantongSyAcPersonBean = new YuantongSyAcPersonBean();
        yuantongSyAcPersonBean.setOpUserId(store.getBackupPhone());
        yuantongSyAcPersonBean.setOpUserName(store.getShortName());
        yuantongSyAcPersonBean.setOpUserMobile(store.getBackupPhone());
        yuantongSyAcPersonBean.setOpUserPwd("123456");
        yuantongSyAcPersonBean.setStatus("VALID");
        yuantongSyAcPersonBean.setEmpType("employee");
        yuantongSyAcPersonBean.setUsdTml("false");
        yuantongSyAcPersonBean.setStationCode(storeCode);
        yuantongSyAcPersonBean.setLogisticsCode("BLC00001");
        yuantongSyAcPersonBean.setCustomerCode(basicInfoService.getConfigurationByCode("yuantongSignbackPartnerID").getOValue1());
        yuantongSyAcPersonBean.setOrgCode("999999");
        YuantongBean yuantongBean = new YuantongBean();
        yuantongBean.setLogistics_interface(JsonUtils.toJson(yuantongSyAcPersonBean));
        yuantongBean.setKey(basicInfoService.getConfigurationByCode("yuantongSignbackKey").getOValue1());
        yuantongBean.setCustomer_code(basicInfoService.getConfigurationByCode("yuantongSignbackPartnerID").getOValue1());
        yuantongBean.setStation_type("5501");
        yuantongBean.setOrg_code("999999");
        yuantongBean.setOp_code("0001");
        String res = "";
        try {
            log.info("param................." + JsonUtils.toJson(yuantongSyAcPersonBean));
            res = OkHttpUtil.postJson(url, yuantongBean);
            log.info("res..............................." + res);
            if (res.indexOf("success") > 0) {
                SignBackSwitchBean signBackSwitchBean = expressHandleService.getSignBackSwitch(202, store.getId());
                expressHandleService.updateSignBackSwitch(signBackSwitchBean);
                return "1";
            }
        } catch (Exception e) {
            log.error(e.getMessage());
            log.info("sssssssssssss" + res);
            return "-1";
        }
        return "-1";
    }
}
