package cn.haliaeetus.sendmessage.framework.factory.express.realize;

import cn.haliaeetus.sendmessage.bean.basedata.SignBackSwitchBean;
import cn.haliaeetus.sendmessage.bean.basedata.Store;
import cn.haliaeetus.sendmessage.bean.config.PlatformConfig;
import cn.haliaeetus.sendmessage.bean.delivery.Delivery;
import cn.haliaeetus.sendmessage.bean.dto.SignBackDto;
import cn.haliaeetus.sendmessage.bean.express.*;
import cn.haliaeetus.sendmessage.controller.web.QueryCondition.DeliveryQueryCondition;
import cn.haliaeetus.sendmessage.framework.factory.express.BaseExpress;
import cn.haliaeetus.sendmessage.framework.util.FirstCharUtil;
import cn.haliaeetus.sendmessage.framework.util.OkHttpUtil;
import cn.haliaeetus.sendmessage.service.BasicInfoService;
import cn.haliaeetus.sendmessage.service.DeliveryService;
import cn.haliaeetus.sendmessage.service.ExpressHandleService;
import cn.haliaeetus.sendmessage.service.PlatformConfigService;
import cn.haliaeetus.sendmessage.service.delivery.DeliveryMsgTemplateConfigService;
import cn.haliaeetus.sendmessage.utils.DateUtil;
import cn.haliaeetus.sendmessage.utils.XMLUtil4jdom;
import com.alibaba.fastjson.JSON;
import com.google.common.base.Strings;
import com.jfinal.weixin.sdk.utils.JsonUtils;
import lombok.extern.slf4j.Slf4j;
import org.jdom2.JDOMException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.io.IOException;
import java.util.Map;

/**
 * @ClassName YunDaExpress
 * @Description TODO
 * @Author Administrator
 * @Date 2019/8/28 0028 下午 16:56
 * @Version 1.0
 **/
@Slf4j
@Component("17")
public class YunDaExpress implements BaseExpress {

    @Autowired
    private DeliveryMsgTemplateConfigService deliveryMsgTemplateConfigService;

    @Autowired
    private BasicInfoService basicInfoService;

    @Autowired
    private DeliveryService deliveryService;

    @Autowired
    private ExpressHandleService expressHandleService;

    @Autowired
    private PlatformConfigService platformConfigService;

    private final static String PLATFROM = "YD";

    @Override
    public void expressSignBack(SignBackDto signBackDto) {
        int returnSignFlag = 0;
        if("in".equals(signBackDto.getActionType())){
            returnSignFlag = 3;
        }else{
            returnSignFlag = 1;
        }
        signBackYunDa(signBackDto.getExpCode(), signBackDto.getTelPhone(), signBackDto.getStore(), signBackDto.getShelfId(), signBackDto.getShelfCode(), returnSignFlag);
    }

    private String signBackYunDa(String expCode, String telPhone, Store store, String shelfId, String shelfCode, int returnSignFlag) {
        SignBackSwitchBean signBackSwitchBean = expressHandleService.getSignBackSwitch(17 , store.getId());
        String signBackName=basicInfoService.getConfigurationByCode("signBackName").getOValue1();
        if(!signBackSwitchBean.getIs_syStore() || !signBackSwitchBean.getIs_syUpStore()){
            register(signBackName, store, !signBackSwitchBean.getIs_syStore() ? "external.station.info.register" : "external.station.info.update");
        }
        String url=basicInfoService.getConfigurationByCode("yundaSignbackUrl").getOValue1();//签收
        if(Strings.isNullOrEmpty(url)){
            log.error("yundaSignbackUrl未配置");
            return "17";
        }
        YunDaSyStoreBean yunDaSyStoreBean = new YunDaSyStoreBean();
        yunDaSyStoreBean.setMailno(expCode);
        yunDaSyStoreBean.setAction(returnSignFlag==3?"STA_INBOUND":"STA_SIGN");
        yunDaSyStoreBean.setTime(DateUtil.getTime());
        yunDaSyStoreBean.setDesc(this.getStoreAddress(store));
        yunDaSyStoreBean.setCity(basicInfoService.getStoreAddressByStoreIdAndExpId(store.getId(),17)[1]);
        yunDaSyStoreBean.setStationName("【"+signBackName+"】-"+store.getShortAddress());
        yunDaSyStoreBean.setStationContact(store.getBackupPhone());
        // 	物业/代收点类型 必填，1000其它，1001快递柜，1002合作驿站/代收点，1003物业，1004门卫，1005前台
		yunDaSyStoreBean.setProperType("1002");
        yunDaSyStoreBean.setProperCode(basicInfoService.getConfigurationByCode("yundaSignbackProperCode").getOValue1());
        yunDaSyStoreBean.setStationCode(getFirst(signBackName) + store.getId().toString());
        // 取件码, 必填，取件码长度是1位到15位的汉字字母数字横线下划线的组合 不能有其他字符
        yunDaSyStoreBean.setPickCode(shelfCode);
        YunDaBean yunDaBean = new YunDaBean();
        yunDaBean.setPartnerid(basicInfoService.getConfigurationByCode("yundaSignbackPartnerid").getOValue1());
        yunDaBean.setPassword(basicInfoService.getConfigurationByCode("yundaSignbackPassword").getOValue1());
        yunDaBean.setXmldata(JsonUtils.toJson(yunDaSyStoreBean));
        String res = "";
        try{
            log.info("param................."+yunDaBean.getXmldata());
            res= OkHttpUtil.postJson(url,yunDaBean);
            Map<String,String> resMap = XMLUtil4jdom.doXMLParse(res);
            log.info("res..............................."+res);
            resMap = XMLUtil4jdom.doXMLParse(resMap.get("orders"));
            // s19 重复推送，认定为已经推送成功
            if(Boolean.parseBoolean(resMap.get("result")) || "s19".equals(resMap.get("remark"))){
                DeliveryQueryCondition qc2 = new DeliveryQueryCondition(store.getId());
                Delivery delivery1=new Delivery();
                delivery1.setRemark(Boolean.parseBoolean(resMap.get("result")) ? "success" : resMap.get("remark"));
                qc2.setEntity(delivery1);
                qc2.setSignFlag(returnSignFlag+"");
                qc2.setReturnSignStatus(returnSignFlag);
                qc2.setUserPhone(telPhone);
                qc2.setExp_code(expCode);
                boolean result = deliveryService.update(qc2);
                log.info("sssssssssssss"+result);
            }else{
                DeliveryQueryCondition qc2 = new DeliveryQueryCondition(store.getId());
                Delivery delivery1=new Delivery();
                delivery1.setRemark(resMap.get("remark"));
                qc2.setEntity(delivery1);
                qc2.setSignFlag((returnSignFlag+1)+"");
                qc2.setReturnSignStatus(returnSignFlag+1);
                qc2.setUserPhone(telPhone);
                qc2.setExp_code(expCode);
                boolean result = deliveryService.update(qc2);
                log.info("sssssssssssss"+result);
            }
        }catch (Exception e){
            log.error(e.getMessage());
            DeliveryQueryCondition qc3 = new DeliveryQueryCondition(store.getId());
            Delivery delivery2=new Delivery();
            delivery2.setRemark(e.getMessage()==null?"NULL":(e.getMessage().length()<30?e.getMessage():e.getMessage().substring(0,30)));
            qc3.setEntity(delivery2);
            qc3.setSignFlag((returnSignFlag+1)+"");
            qc3.setReturnSignStatus(returnSignFlag+1);
            qc3.setUserPhone(telPhone);
            qc3.setExp_code(expCode);
            boolean result = deliveryService.update(qc3);
            log.info("sssssssssssss"+result);
        }
        return "17";
    }

    private boolean register(String signBackName, Store store, String method) {
        PlatformConfig platformConfig = platformConfigService.getByPlatform(PLATFROM);
        if (platformConfig == null) {
            log.info("配置表中没有{}的配置", PLATFROM);
            return false;
        }
        try {
            String res = OkHttpUtil.postJson(platformConfig.getLogisticsUrl() + "/yunda/yundaRegister", YunDaRegisterSysBean.builder()
                    .appkey(platformConfig.getAppkey())
                    .method(method)
                    .sign(platformConfig.getAppSecret())
                    .url(platformConfig.getUrl() + "/openapi/router")
                    .requestParam(JSON.toJSONString(YunDaRegisterBean.builder()
                            .stationCode(getFirst(signBackName) + store.getId().toString())
                            .stationType("1002")
                            .provinceName(store.getProvinceName())
                            .cityName(store.getCityName())
                            .areaName(store.getAreaName())
                            .stationName(store.getName())
                            .detailsAddress(store.getShortAddress())
                            .stationContacter(store.getOwner())
                            .stationPhone(store.getBackupPhone())
                            .businessHours(store.getStartTime() + "-" + store.getEndTime())
                            .latitude("0000.0000")
                            .longitude("0000.0000")
                            .town(store.getTownship())
                            .build()))
                    .format("json")
                    .build());
            YunDaRegisterRespBean yunDaRegisterRespBean = JSON.parseObject(res, YunDaRegisterRespBean.class);
            if (yunDaRegisterRespBean != null && yunDaRegisterRespBean.getData() != null && "success".equals(yunDaRegisterRespBean.getData().get("result"))) {
                expressHandleService.updateSignBackSwitch(expressHandleService.getSignBackSwitch(17, store.getId()));
                return true;
            } else {
                return false;
            }
        } catch (Exception e) {
            e.printStackTrace();
            return false;
        }
    }

    private String getFirst(String signBackName) {
        if(Strings.isNullOrEmpty(signBackName) || signBackName.length() < 2){
            return "GP";
        }
        StringBuffer sb = new StringBuffer();
        for (int i = 0; i < signBackName.length(); i++) {
            sb.append(FirstCharUtil.first(signBackName.substring(i,i+1)));
        }
        return sb.toString();
    }

    private String getStoreAddress(Store store) {
        return store.getProvinceName()+store.getCityName()+store.getAreaName()+store.getShortAddress();
    }

    public static void main(String[] args) throws JDOMException, IOException {
        String res = "<response><result>true</result><orders><order><mailno>3103564104149</mailno><result>true</result></order></orders></response>";
        Map<String,String> resMap = XMLUtil4jdom.doXMLParse(res);
        log.info("res..............................."+res);
        resMap = XMLUtil4jdom.doXMLParse(resMap.get("orders"));
        System.out.println(resMap);
    }
}
