package cn.haliaeetus.sendmessage.framework.factory.express.realize;

import cn.haliaeetus.sendmessage.bean.basedata.SignBackSwitchBean;
import cn.haliaeetus.sendmessage.bean.basedata.Store;
import cn.haliaeetus.sendmessage.bean.delivery.Delivery;
import cn.haliaeetus.sendmessage.bean.dto.SignBackDto;
import cn.haliaeetus.sendmessage.controller.web.QueryCondition.DeliveryQueryCondition;
import cn.haliaeetus.sendmessage.framework.factory.express.BaseExpress;
import cn.haliaeetus.sendmessage.framework.util.OkHttpUtil;
import cn.haliaeetus.sendmessage.service.BasicInfoService;
import cn.haliaeetus.sendmessage.service.DeliveryService;
import cn.haliaeetus.sendmessage.service.ExpressHandleService;
import cn.haliaeetus.sendmessage.service.delivery.DeliveryMsgTemplateConfigService;
import cn.haliaeetus.sendmessage.service.impl.ExpressHandleServiceImpl;
import cn.haliaeetus.sendmessage.utils.Zhongtong.*;
import com.google.common.base.Strings;
import com.google.gson.Gson;
import com.jfinal.weixin.sdk.utils.JsonUtils;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.stereotype.Repository;
import org.springframework.stereotype.Service;

import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * @ClassName ZhongTong
 * @Description TODO
 * @Author Administrator
 * @Date 2019/8/28 0028 下午 16:57
 * @Version 1.0
 **/
@Slf4j
@Component("187")
public class ZhongTongExpress implements BaseExpress {
    @Autowired
    private DeliveryMsgTemplateConfigService deliveryMsgTemplateConfigService;

    @Autowired
    private BasicInfoService basicInfoService;

    @Autowired
    private DeliveryService deliveryService;

    @Autowired
    private ExpressHandleService expressHandleService;

    SimpleDateFormat sDateFormat=new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

    @Override
    public void expressSignBack(SignBackDto signBackDto) {
        int returnSignFlag = 0;
        if("in".equals(signBackDto.getActionType())){
            returnSignFlag = 3;
        }else if("return".equals(signBackDto.getActionType())){
            returnSignFlag = 5;
        }else{
            returnSignFlag = 1;
        }
        GetZhongTongSysParam getZhongTongSysParam = new GetZhongTongSysParam().invoke(basicInfoService);
        if (getZhongTongSysParam.is()) {
            return ;
        }
        this.signbackZhongTong(signBackDto.getExpCode(), signBackDto.getTelPhone(), signBackDto.getStore(), signBackDto.getShelfId(), signBackDto.getShelfCode(), returnSignFlag,getZhongTongSysParam);
        //短信回传接口
        this.ztSmsReturn(signBackDto, returnSignFlag, getZhongTongSysParam);
    }

    /**
     * 中通短信回传
     * @param signBackDto
     * @param returnSignFlag
     * @param getZhongTongSysParam
     */
    private void ztSmsReturn(SignBackDto signBackDto, int returnSignFlag, GetZhongTongSysParam getZhongTongSysParam) {
        if(returnSignFlag == 3){
            String zhongtongCode = basicInfoService.getConfigurationByCode("zhongtongCode").getOValue1();
            String signBackName = basicInfoService.getConfigurationByCode("signBackName").getOValue1();

            SmsReturnRequest request = SmsReturnRequest.builder()
                    .companyCode(zhongtongCode)
                    .hallCode(signBackDto.getStore().getId().toString())
                    .billCode(signBackDto.getExpCode())
                    .receiveMobile(signBackDto.getTelPhone())
                    .content("您的中通"+signBackDto.getExpCode()+"已到"+signBackDto.getStore().getShortAddress()+"，取货码"+signBackDto.getShelfCode()+"，请前来领取。寄件到"+signBackName)
                    .sendTime(sDateFormat.format(new Date()))
                    .build();
            request.setApiName(getZhongTongSysParam.getZhongtongUrl()+"/createSmsMsg");
            request.setCompanyId(getZhongTongSysParam.getCompanyId());
            request.setKey(getZhongTongSysParam.getKey());
            try {
                log.info("kael---->中通短信回传接口调用传入参数："+ JsonUtils.toJson(request));
                String res= OkHttpUtil.postJson(getZhongTongSysParam.getUrl()+"/smsReturn",request);
                log.info("kael---->中通短信回传接口返回："+res);
            }catch (Exception e){
                log.error(e.getMessage());
            }

        }
    }


    /**
     * 中通入库和签收
     * @param expCode
     * @param telPhone
     * @param store
     * @param shelfId
     * @param shelfCode
     * @param returnSignFlag
     * @return
     */
    private String signbackZhongTong(String expCode, String telPhone, Store store, String shelfId, String shelfCode, int returnSignFlag,GetZhongTongSysParam getZhongTongSysParam) {
        SignBackSwitchBean signBackSwitchBean = expressHandleService.getSignBackSwitch(187 , store.getId());
        if(!signBackSwitchBean.getIs_syStore()){
            this.syZhongTongStore(store,getZhongTongSysParam);
        }
        if(!signBackSwitchBean.getIs_syUpStore()){
            this.syUpZhongTongStore(store,getZhongTongSysParam);
        }
        String zhongtongCode = basicInfoService.getConfigurationByCode("zhongtongCode").getOValue1();
        String zhongtongName = basicInfoService.getConfigurationByCode("zhongtongName").getOValue1();
        ZhongTongBackRequest request = ZhongTongBackRequest.builder()
                .billCode(expCode)
                .status(returnSignFlag==3?"ARRIVAL":(returnSignFlag==1?"SIGNED":"DEPARTURE"))
                .staDate(new Date())
                .comCode(zhongtongCode)
                .comName(zhongtongName)
                .hallCode(store.getId().toString())
                .hallName(store.getName())
                .manOph(store.getBackupPhone())
                .hallProv(store.getProvinceName())
                .hallCity(store.getCityName())
                .hallCounty(store.getAreaName())
                .hallAddress(store.getShortAddress())
                .deliverName(store.getOwner())
                .deliverPhone(store.getBackupPhone())
                .resMobile(telPhone)
                .pickCode(shelfCode)
                .build();
        request.setApiName(getZhongTongSysParam.getZhongtongUrl()+"/OrderStateChange");
        request.setCompanyId(getZhongTongSysParam.getCompanyId());
        request.setKey(getZhongTongSysParam.getKey());
        if(returnSignFlag==5){
            request.setExcType("2");
            request.setRemark("客户拒收");
        }
        String res = "";
        try{
            log.info("kael---->中通"+(returnSignFlag==3?"入库":"签收")+"接口传参："+new Gson().toJson(request));
            res= OkHttpUtil.postJson(getZhongTongSysParam.getUrl()+"/ztSignback",request);
            ZhongTongStoreSynResponse response = new Gson().fromJson(res,ZhongTongStoreSynResponse.class);
            log.info("kael---->中通"+(returnSignFlag==3?"入库":"签收")+"接口回参："+res);
            DeliveryQueryCondition qc2 = new DeliveryQueryCondition(store.getId());
            Delivery delivery1=new Delivery();
            if(response.isStatus()){
                delivery1.setRemark("success");
                qc2.setEntity(delivery1);
                qc2.setSignFlag(returnSignFlag+"");
                qc2.setReturnSignStatus(returnSignFlag);
                qc2.setUserPhone(telPhone);
                qc2.setExp_code(expCode);
                boolean result = deliveryService.update(qc2);
            }else{
                delivery1.setRemark(response.getStatusCode()+":"+response.getMessage());
                qc2.setEntity(delivery1);
                qc2.setSignFlag((returnSignFlag+1)+"");
                qc2.setReturnSignStatus(returnSignFlag+1);
                qc2.setUserPhone(telPhone);
                qc2.setExp_code(expCode);
                boolean result = deliveryService.update(qc2);
            }
        } catch (Exception e){
            log.error(e.getMessage());
            DeliveryQueryCondition qc3 = new DeliveryQueryCondition(store.getId());
            Delivery delivery2=new Delivery();
            delivery2.setRemark(e.getMessage()==null?"NULL":e.getMessage().substring(0,30));
            qc3.setEntity(delivery2);
            qc3.setSignFlag((returnSignFlag+1)+"");///代签失败
            qc3.setReturnSignStatus(returnSignFlag+1);//代签失败
            qc3.setUserPhone(telPhone);
            qc3.setExp_code(expCode);
            boolean result = deliveryService.update(qc3);
        }
        return "187";
    }

    /**
     * 中通新增门店
     * @param store
     */
    private void syZhongTongStore(Store store,GetZhongTongSysParam getZhongTongSysParam) {
        this.zhongTongStoreAuth(store,0,getZhongTongSysParam);
    }

    /**
     * 中通更新门店
     * @param store
     */
    private void syUpZhongTongStore(Store store,GetZhongTongSysParam getZhongTongSysParam) {
        this.zhongTongStoreAuth(store,1,getZhongTongSysParam);
    }

    /**
     * 中通门店认证
     * @param store
     * @param type ，0：新增，1：修改
     */
    private void zhongTongStoreAuth(Store store,int type,GetZhongTongSysParam getZhongTongSysParam) {
        String zhongtongCode = basicInfoService.getConfigurationByCode("zhongtongCode").getOValue1();
        String zhongtongName = basicInfoService.getConfigurationByCode("zhongtongName").getOValue1();
        String res = "";
        try{
            ZhongTongStoreSynRequest request = ZhongTongStoreSynRequest.builder()
                    .companyCode(zhongtongCode)
                    .companyName(zhongtongName)
                    .hallCode(store.getId().toString())
                    .hallName(store.getName())
                    .hallProvince(store.getProvinceName())
                    .hallCity(store.getCityName())
                    .hallDistrict(store.getAreaName())
                    .hallAddress(store.getShortAddress())
                    .hallManager(store.getOwner())
                    .manPhone(store.getTakeExpressPhone())
                    .manOph(store.getTakeExpressPhone())
                    .electFlag(false)
                    .hallTown(store.getTownship())
                    .hallTownId(store.getTownshipId())
                    .build();
            request.setApiName(getZhongTongSysParam.getZhongtongUrl()+(type==0?"/agentCreate":"/agentUpdate"));
            request.setCompanyId(getZhongTongSysParam.getCompanyId());
            request.setKey(getZhongTongSysParam.getKey());
            log.info("kael---->中通门店认证接口调用传入参数："+ JsonUtils.toJson(request));
            res=OkHttpUtil.postJson(getZhongTongSysParam.getUrl()+"/ztStoreAuth",request);
            log.info("kael---->中通门店认证接口返回："+res);
            ZhongTongStoreSynResponse response = new Gson().fromJson(res, ZhongTongStoreSynResponse.class);
            if(response.isStatus()){
                if(type==0){
                    expressHandleService.OpenStore(store.getId(), 187);
                }
                SignBackSwitchBean signBackSwitchBean = expressHandleService.getSignBackSwitch(187 , store.getId());
                signBackSwitchBean.setYuantongStoreCode(response.getStatusCode());
                expressHandleService.updateSignBackSwitch(signBackSwitchBean);
            }
        }catch (Exception e){
            log.error("kael---->中通门店认证接口失败，失败原因："+e.getMessage());
        }
    }

}
