package cn.haliaeetus.sendmessage.framework.sms.entity.yunxin;

import cn.haliaeetus.sendmessage.utils._;

/**
 * 云信短信错误编码
 * 
 * @author Guolinzhao
 *
 */
public enum YXErrorCodeEnum {
	
	ERROR_CODE_1("-1", "提交接口失败", "云信短信提交失败"),
	ERROR_CODE_3("-3", "用户名或密码错误", "云信短信提交失败"),
	ERROR_CODE_4("-4", "短信内容和备案的模板不一样", "云信短信模板错误"),
	ERROR_CODE_5("-5", "签名不正确", "云信短信签名错误"),
	ERROR_CODE_7("-7", "余额不足", "云信短信提交失败"),
	ERROR_CODE_8("-8", "通道错误", "云信短信提交失败"),
	ERROR_CODE_9("-9", "无效号码", "无效号码"),
	ERROR_CODE_10("-10", "签名内容不符合长度", "云信短信签名错误"),
	ERROR_CODE_11("-11", "用户有效期过期", "云信短信提交失败"),
	ERROR_CODE_12("-12", "黑名单", "黑名单"),
	ERROR_CODE_17("-17", "非法IP", "云信短信提交失败");
	
	private String code;
	private String description;
	private String msg;
	
	private YXErrorCodeEnum(String code, String description, String msg) {
		this.code = code;
		this.description = description;
		this.msg = msg;
	}
	
	public String getCode() {
		return code;
	}
	
	public void setCode(String code) {
		this.code = code;
	}
	
	public String getMsg() {
		return msg;
	}

	public void setMsg(String msg) {
		this.msg = msg;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public static YXErrorCodeEnum of(String content) {
		if (_.isNotEmpty(content)) {
			for (YXErrorCodeEnum yxErrorCode : YXErrorCodeEnum.values()) {
				if (content.equals(yxErrorCode.getCode()) || content.contains(yxErrorCode.getCode() + ":")) {
					if ("-17".equals(yxErrorCode.getCode())) {
						yxErrorCode.setDescription(content);
					}
					return yxErrorCode;
				}
			}
		}
		return null;
	}
}
