package cn.haliaeetus.sendmessage.interceptor;

import cn.haliaeetus.sendmessage.framework.log.Logger;
import org.springframework.web.servlet.HandlerInterceptor;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * @ClassName ApiInterceptor
 * @Description 拦截器，拦截接口安全验证
 * (如果使用spring cloud gateway 网关服务，可以将此类删掉，交由网关服务统一管理)
 * @Author kael
 * @Date 2019/6/24 0024 下午 15:54
 * @Version 1.0
 **/
public class ApiInterceptor  implements HandlerInterceptor {
    private static final Logger LOG = Logger.getInstance(ApiInterceptor.class);
    /**
     * 请求之前
     * @param httpServletRequest
     * @param httpServletResponse
     * @param o
     * @return
     * @throws Exception
     */
    @Override
    public boolean preHandle(HttpServletRequest httpServletRequest, HttpServletResponse httpServletResponse, Object o) throws Exception {
        LOG.info("进入拦截器");
        return true;
    }

    /**
     * 请求时
     * @param httpServletRequest
     * @param httpServletResponse
     * @param o
     * @param modelAndView
     * @throws Exception
     */
    @Override
    public void postHandle(HttpServletRequest httpServletRequest, HttpServletResponse httpServletResponse, Object o, ModelAndView modelAndView) throws Exception {
        LOG.info("方法执行中");
    }

    /**
     * 请求后
     * @param httpServletRequest
     * @param httpServletResponse
     * @param o
     * @param e
     * @throws Exception
     */
    @Override
    public void afterCompletion(HttpServletRequest httpServletRequest, HttpServletResponse httpServletResponse, Object o, Exception e) throws Exception {
        LOG.info("方法执行完后");
    }
}
