package cn.haliaeetus.sendmessage.service;

import cn.haliaeetus.sendmessage.bean.WhiteList;

import java.util.List;

/**
 * 白名单设置相关接口
 * @author zhangyun
 *
 */
public interface WhiteListService {
	
	/**
	 * 白名单列表查询
	 * @return
	 */
	public List<WhiteList> getByStoreId(int storeId);
		
	/**
	 * 白名单单个查询
	 * @return
	 */
	public List<WhiteList> getByPhoneStoreId(String phone, int storeId);

	/**
	 * 白名单添加
	 * @return
	 */
	public int saveWhiteList(WhiteList whilteList);

	/**
	 * 白名单更新
	 * @return
	 */
	public int updateWhiteList(WhiteList whiteList);

	/**
	 * 白名单删除
	 * @return
	 */
	public int deleteWhiteList(int storeId, String mobilePhone);

	/**
	 * 是否白名单用户
	 * @return
	 */
	public boolean isWhiteUser(String phone, int storeId);
			
}