package cn.haliaeetus.sendmessage.service.delivery.impl;

import cn.haliaeetus.sendmessage.bean.delivery.DeliveryMsgTemplate;
import cn.haliaeetus.sendmessage.bean.delivery.DeliveryMsgTemplateConfig;
import cn.haliaeetus.sendmessage.dao.DeliveryMsgTemplateDao;
import cn.haliaeetus.sendmessage.framework.util.StringUtil;
import cn.haliaeetus.sendmessage.service.delivery.DeliveryMsgTemplateService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * <p>门店派件信息模板Service</p>
 * 
 * @author sqj
 * @since 1.0
 * @version 1.0
 */
@Service
public class DeliveryMsgTemplateServiceImpl implements DeliveryMsgTemplateService {
	@Autowired
	private DeliveryMsgTemplateDao msgTemplateDAO;
	
	public void save(DeliveryMsgTemplate msgTemplate) {
		msgTemplateDAO.save(msgTemplate);
	}
	
	public DeliveryMsgTemplate getById(int id) {
		return msgTemplateDAO.getById(id);
	}
	
	public void updateById(DeliveryMsgTemplate msgTemplate) {
		msgTemplateDAO.updateById(msgTemplate);
	}
	
	public DeliveryMsgTemplate getMsgTemplate(DeliveryMsgTemplateConfig msgTemplateConfig, String bussCode) {
		if (msgTemplateConfig == null || StringUtil.isEmpty(bussCode)) {
			return null;
		}

		return msgTemplateDAO.getMsgTemplate(msgTemplateConfig, bussCode);
	}

	/**
	 * 不分客户端类型的默认信息模板
	 * @param type 信息类型
	 * @param bussCode 业务代码
	 */
	public DeliveryMsgTemplate getDefaultMsgTemplate(int type, String bussCode) {
		if (StringUtil.isEmpty(bussCode)) {
			return null;
		}

		return msgTemplateDAO.getDefaultMsgTemplate(type, bussCode);
	}

	@Override
	public DeliveryMsgTemplate getStoreMsgTemplate(String storeId) {
		if (StringUtil.isEmpty(storeId)) {
			return null;
		}
		return msgTemplateDAO.getStoreMsgTemplate(storeId);
	}
}