package cn.haliaeetus.sendmessage.service.delivery.impl;

import cn.haliaeetus.sendmessage.bean.delivery.DeliverySpecialMsgTemplate;
import cn.haliaeetus.sendmessage.dao.DeliverySpecialMsgTemplateDao;
import cn.haliaeetus.sendmessage.service.delivery.DeliverySpecialMsgTemplateService;
import cn.haliaeetus.sendmessage.utils.DeliveryUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;

import static cn.haliaeetus.sendmessage.utils._.isEmpty;

/**
 * <p>门店派件特殊信息模板Service</p>
 * 
 * @author sqj
 * @since 1.0
 * @version 1.0
 */
@Service
public class DeliverySpecialMsgTemplateServiceImpl implements DeliverySpecialMsgTemplateService {
	@Autowired
	private DeliverySpecialMsgTemplateDao msgTemplateDAO;
	
	public void save(DeliverySpecialMsgTemplate msgTemplate) {
		msgTemplateDAO.save(msgTemplate);
	}
	
	public DeliverySpecialMsgTemplate getById(int id) {
		return msgTemplateDAO.getById(id);
	}
	
	public void updateById(DeliverySpecialMsgTemplate msgTemplate) {
		if (msgTemplate != null) {
			msgTemplate.setUpdateTime(new Date());
		}
		msgTemplateDAO.updateById(msgTemplate);
	}
	
	public DeliverySpecialMsgTemplate getMsgTemplate(int storeId, int clientType, int type, String bussCode) {
		if (storeId <= 0 || !DeliveryUtil.isValidSource(clientType) || isEmpty(bussCode)) {
			return null;
		}
		return msgTemplateDAO.getMsgTemplate(storeId, clientType, type, bussCode);
	}

	public DeliverySpecialMsgTemplate getDefaultMsgTemplateOfStore(int clientType, int type, String bussCode) {
		if (!DeliveryUtil.isValidSource(clientType) || isEmpty(bussCode)) {
			return null;
		}
		return msgTemplateDAO.getMsgTemplate(0, clientType, type, bussCode);
	}
}