package cn.haliaeetus.sendmessage.service.delivery.impl;

import cn.haliaeetus.sendmessage.bean.CompletePic;
import cn.haliaeetus.sendmessage.bean.delivery.DeliveryStatus;
import cn.haliaeetus.sendmessage.bean.dto.DeliveryDto;
import cn.haliaeetus.sendmessage.controller.web.QueryCondition.DeliveryQueryCondition;
import cn.haliaeetus.sendmessage.controller.web.QueryCondition.DeliveryStatusQueryCondition;
import cn.haliaeetus.sendmessage.dao.DeliveryStatusDao;
import cn.haliaeetus.sendmessage.dao.IHistoryDeliveryStatusDao;
import cn.haliaeetus.sendmessage.dao.IHyhistoryDeliveryStatusDao;
import cn.haliaeetus.sendmessage.framework.toolkit.PagedList;
import cn.haliaeetus.sendmessage.service.delivery.DeliveryStatusService;
import cn.haliaeetus.sendmessage.utils._;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Service
public class DeliveryStatusServiceImpl implements DeliveryStatusService {
    @Autowired
    private DeliveryStatusDao deliveryStatusDao;
    
    @Autowired
    private IHistoryDeliveryStatusDao historyDeliveryDao;
    
    @Autowired
    private IHyhistoryDeliveryStatusDao hyhisdeliveryStatusDao;

    public List<DeliveryStatus> getDeliveryStatus(DeliveryStatusQueryCondition qc) {
        return deliveryStatusDao.select(qc);
    }
    
    public List<DeliveryStatus> getHisDeliveryStatus(DeliveryStatusQueryCondition qc) {
        return historyDeliveryDao.select(qc);
    }
    
    public List<DeliveryStatus> getHyhisDeliveryStatus(DeliveryStatusQueryCondition qc) {
        return hyhisdeliveryStatusDao.select(qc);
    }

    @Override
    public List<DeliveryStatus> getStatusListByDeliveryIds(int storeId, String deliveryIds) {
        DeliveryStatusQueryCondition qc = new DeliveryStatusQueryCondition(storeId);
        String[] ids = deliveryIds.split(",");
        ArrayList idList = new ArrayList();
        for (String id : ids){
            idList.add(_.toInt(id));
        }
        qc.setDeliveryIds(idList);
        return getDeliveryStatus(qc);
    }

    @Override
    public int insert(int storeId, DeliveryStatus deliveryStatus) {
    	deliveryStatus.setStoreId(storeId);
        return deliveryStatusDao.insert(deliveryStatus);
	}

	@Override
	public DeliveryStatus getEarliestStatusOfDelivery(int storeId, int deliveryId, int status) {
		return deliveryStatusDao.getEarliestStatusOfDelivery(storeId, deliveryId, status);
	}

	@Override
	public PagedList<DeliveryDto> get4Page(DeliveryQueryCondition params) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public List<DeliveryStatus> getStatusListByDeliveryId(int storeId,
			int deliveryId) {
		// TODO Auto-generated method stub
		return deliveryStatusDao.getStatusListByDeliveryId(storeId,deliveryId);
	}

	@Override
	public void saveCompletePic(CompletePic pic) {
		// TODO Auto-generated method stub
		deliveryStatusDao.saveCompletePic(pic);
	}
	
	@Override
	public CompletePic getCompletePic(CompletePic pic) {
		// TODO Auto-generated method stub
		return deliveryStatusDao.getCompletePic(pic);
	}
}
