package cn.haliaeetus.sendmessage.service.impl;

import cn.haliaeetus.sendmessage.bean.ResultBean;
import cn.haliaeetus.sendmessage.bean.basedata.SignBackSwitchBean;
import cn.haliaeetus.sendmessage.bean.basedata.Store;
import cn.haliaeetus.sendmessage.bean.basedata.StoreShelf;
import cn.haliaeetus.sendmessage.bean.dto.SignBackDto;
import cn.haliaeetus.sendmessage.bean.jhy.JhyPhone;
import cn.haliaeetus.sendmessage.bean.jhy.JhyPhonePushRequest;
import cn.haliaeetus.sendmessage.bean.jhy.JhyPhoneStateRequest;
import cn.haliaeetus.sendmessage.bean.jhy.filter.JhyPhoneFilter;
import cn.haliaeetus.sendmessage.enums.HDExpressNameEnum;
import cn.haliaeetus.sendmessage.framework.factory.express.ExpressFactory;
import cn.haliaeetus.sendmessage.framework.factory.platform.PlatformFactory;
import cn.haliaeetus.sendmessage.framework.util.OkHttpUtil;
import cn.haliaeetus.sendmessage.jobs.DBUtil;
import cn.haliaeetus.sendmessage.service.*;
import cn.haliaeetus.sendmessage.service.delivery.DeliveryMsgTemplateConfigService;
import cn.haliaeetus.sendmessage.service.jhy.JhyPhoneService;
import cn.haliaeetus.sendmessage.utils.MD5Util;
import com.google.common.base.Strings;
import com.google.gson.Gson;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @ClassName ExpressHandleServiceImpl
 * @Description TODO
 * @Author kael
 * @Date 2019/8/6 0006 下午 16:40
 * @Version 1.0
 **/
@Service
public class ExpressHandleServiceImpl implements ExpressHandleService {

    protected final Logger log = LoggerFactory.getLogger(this.getClass());

    @Autowired
    private BasicInfoService basicInfoService;

    @Autowired
    private DeliveryService deliveryService;

    @Autowired
    private DeliveryMsgTemplateConfigService deliveryMsgTemplateConfigService;

    @Autowired
    private JhyPhoneService jhyPhoneService;

    @Autowired
    private ExStoreService exStoreService;

    @Autowired
    private UserService userService;

    @Autowired
    private PlatformFactory platformFactory;

    @Autowired
    private ExpressFactory expressFactory;

    @Autowired
    private StoreShelfService shelfService;

    @Autowired
    private PlatformConfigService platformConfigService;

    @Override
    public SignBackSwitchBean getSignBackSwitch(int expId, int storeId) {
        try{
            Connection connection = null;
            PreparedStatement pstm = null;
            try{
                Class.forName("com.mysql.jdbc.Driver");
                connection = DBUtil.getJeesiteConnection();
                connection.setAutoCommit(false);
                String sql = "select a.storeId,a.expId,a.is_valid,a.is_syStore,a.is_syAcPerson,a.is_syUpStore,a.yuantongStoreCode FROM sign_back_switch a where a.storeId = "+storeId+" and a.expId = " + expId;
                pstm = connection.prepareStatement(sql);
                ResultSet rs=pstm.executeQuery();
                SignBackSwitchBean signBackSwitchBean = null;
                while(rs.next()){
                    signBackSwitchBean = new SignBackSwitchBean();
                    signBackSwitchBean.setStoreId(rs.getString(1));
                    signBackSwitchBean.setExpId(rs.getString(2));
                    signBackSwitchBean.setIs_valid(rs.getBoolean(3));
                    signBackSwitchBean.setIs_syStore(rs.getBoolean(4));
                    signBackSwitchBean.setIs_syAcperson(rs.getBoolean(5));
                    signBackSwitchBean.setIs_syUpStore(rs.getBoolean(6));
                    signBackSwitchBean.setYuantongStoreCode(rs.getString(7));
                }
                return signBackSwitchBean;
            }catch (Exception e){
                e.printStackTrace();
                throw new RuntimeException(e);
            }finally {
                if (pstm != null) {
                    try {
                        pstm.close();
                    } catch (SQLException e) {
                        e.printStackTrace();
                        throw new RuntimeException(e);
                    }
                }
                if (connection != null) {
                    try {
                        connection.close();
                    } catch (SQLException e) {
                        e.printStackTrace();
                        throw new RuntimeException(e);
                    }
                }
            }
        }catch (Exception e){
            e.getStackTrace();
        }
        return null;
    }

    @Override
    public String signBack(SignBackDto signBackDto){
        /*try{
            // 处理取件码
            String shelfId = signBackDto.getShelfId();
            StoreShelf storeShelf;
            if(!Strings.isNullOrEmpty(shelfId) && null != (storeShelf = shelfService.getById(Integer.parseInt(shelfId)))){
                signBackDto.setShelfCode(storeShelf.getShelfName() + "-" + signBackDto.getShelfCode());
            }
        }catch (NumberFormatException e){
            log.warn("取件码处理异常：" + e.getMessage());
        }*/

        int status = 0;
        if (signBackDto.getActionType().equals("in")){
            status = 122;
        }else if (signBackDto.getActionType().equals("out")){
            status = 126;
        }else {
            status = 246;
        }
        deliveryService.addExpressRecode(signBackDto.getStore().getId(), signBackDto.getExpCode(), status);

        // 快递公司处理
        if(signBackDto.getExpressSignBean() != null && signBackDto.getExpressSignBean().getIs_valid()){
            expressFactory.getExpress(signBackDto.getExpId().toString()).expressSignBack(signBackDto);
        }
        //菜鸟接口处理
        // this.caiNiaoPush(signBackDto);
        //拼多多接口处理
        // this.pddPush(signBackDto);
        return null;
    }

    /**
     * 菜鸟接口处理
     * @param signBackDto
     */
    private void caiNiaoPush(SignBackDto signBackDto) {
//        if (isCallCaiNiao(signBackDto)){return;}
        SignBackSwitchBean signBackSwitchBean = getSignBackSwitch(9997 , signBackDto.getStore().getId());
        // 控制是否开启平台入库签收
        if(signBackSwitchBean != null && signBackSwitchBean.getIs_valid()) {
            //控制是否需要新增认证
            if(signBackSwitchBean != null && !signBackSwitchBean.getIs_syStore()){
                platformFactory.getPlatform(signBackDto.getPlatform()).platformAuthStore(signBackDto.getStore(),1);
            }
            //控制是否需要更新认证
            if(signBackSwitchBean != null && !signBackSwitchBean.getIs_syUpStore()){
                platformFactory.getPlatform(signBackDto.getPlatform()).platformAuthStore(signBackDto.getStore(),2);
            }

            if("in".equals(signBackDto.getActionType())){
                platformFactory.getPlatform(signBackDto.getPlatform()).platformBack(signBackDto);
            }else{
                platformFactory.getPlatform(signBackDto.getPlatform()).platformSign(signBackDto);
            }
        }
        if("in".equals(signBackDto.getActionType())){
            platformFactory.getPlatform(signBackDto.getPlatform()).platformBack(signBackDto);
        }else{
            platformFactory.getPlatform(signBackDto.getPlatform()).platformSign(signBackDto);
        }
    }

    /**
     * 如果缓存中不存在cainiao订单缓存并且短信生产者没有传CaiNiao那么就不调用cainiao接口
     * @param signBackDto
     * @return
     */
    private boolean isCallCaiNiao(SignBackDto signBackDto) {
        if(!"CaiNiao".equals(signBackDto.getPlatform())){
            return true;
        }
        return false;
    }

    /**
     * 拼多多接口处理
     * @param signBackDto
     */
    private void pddPush(SignBackDto signBackDto) {
        // if (isCallPdd(signBackDto)) {return;}
        SignBackSwitchBean signBackSwitchBean = getSignBackSwitch(9998 , signBackDto.getStore().getId());
        // 控制是否开启平台入库签收
        if(signBackSwitchBean != null && signBackSwitchBean.getIs_valid()) {
            //控制是否需要新增认证
            if(signBackSwitchBean != null && !signBackSwitchBean.getIs_syStore()){
                platformFactory.getPlatform(signBackDto.getPlatform()).platformAuthStore(signBackDto.getStore(),1);
            }
            //控制是否需要更新认证
            if(signBackSwitchBean != null && !signBackSwitchBean.getIs_syUpStore()){
                platformFactory.getPlatform(signBackDto.getPlatform()).platformAuthStore(signBackDto.getStore(),2);
            }

            if("in".equals(signBackDto.getActionType())){
                platformFactory.getPlatform(signBackDto.getPlatform()).platformBack(signBackDto);
            }else{
                platformFactory.getPlatform(signBackDto.getPlatform()).platformSign(signBackDto);
            }
        }
    }

    /**
     * 如果缓存中不存在pdd订单缓存并且短信生产者没有传PDD那么就不调用pdd接口
     * @param signBackDto
     * @return
     */
    private boolean isCallPdd(SignBackDto signBackDto) {
        String pdd = signBackDto.getPlatform();
        if(!"PDD".equalsIgnoreCase(signBackDto.getPlatform())){
            return true;
        }
        return false;
    }

    public void jhyDeliveryPush(String phone, Store store,Integer expId,String expCode,String shelfCode,String actionType) {
        if(Strings.isNullOrEmpty(phone) || store == null){
            return;
        }
        try {
            List<JhyPhone> jhyPhoneList = jhyPhoneService.selectByFilter(new JhyPhoneFilter.Builder(this.jhyMD5(phone)).build());
            if(jhyPhoneList == null || jhyPhoneList.isEmpty()){
                return;
            }
            String url=basicInfoService.getConfigurationByCode("jhyPushUrl").getOValue1();
            String res = "";
            if("in".equals(actionType)){
                url = url+"/jhy/phone/pushPhone";
                res=OkHttpUtil.postJson(url,new JhyPhonePushRequest.Builder()
                        .withPickup_code(shelfCode)
                        .withExpress_id(expId.toString())
                        .withExpress_name(HDExpressNameEnum.valueOf(expId).getCnName())
                        .withWaybill_num(expCode)
                        .withDelivery_phone(store.getBackupPhone())
                        .withFz_site_id(store.getId().toString())
                        .withFz_site_name(store.getName())
                        .withPickup_address(store.getShortAddress())
                        .withPickup_phone(phone)
                        .build());
            }else{
                url = url+"/jhy/phone/pushSign";
                res=OkHttpUtil.postJson(url,new JhyPhoneStateRequest.Builder()
                        .setWaybill_num(expCode)
                        .setPickup_phone(phone)
                        .setExpress_id(expId.toString())
                        .build());
            }
            log.info("调用居欢颜接口："+url+"，返回参数："+res);

            ResultBean<String> resultBean = new Gson().fromJson(res, ResultBean.class);

            if(resultBean == null ||resultBean.getData()==null){
                log.info("jhyDeliveryPush-->：调用居欢颜接口失败");
            }else if(resultBean.getData().indexOf("success") > 0 ){
                log.info("jhyDeliveryPush-->：调用居欢颜接口成功");
            }else{
                log.info("jhyDeliveryPush-->：调用居欢颜接口失败");
            }
        }catch (Exception e){
            log.info("jhyDeliveryPush-->：调用居欢颜接口失败");
            e.printStackTrace();
        }

    }

    private String jhyMD5(String phone) {
        return new String(MD5Util.MD5Encode(phone + "JUHUANYAN","UTF-8"));
    }

    @Override
    public void updateSignBackSwitch(SignBackSwitchBean signBackSwitchBean){
        try{
            Class.forName("com.mysql.jdbc.Driver");
            Connection con = DBUtil.getJeesiteConnection();
            StringBuilder sb = new StringBuilder();
            sb.append("update sign_back_switch set ");
            if(!signBackSwitchBean.getIs_syStore()){
                sb.append(" is_syStore = 1,");
            }
            if(!signBackSwitchBean.getIs_syAcperson()){
                sb.append(" is_syAcPerson = 1,");
            }
            if(!signBackSwitchBean.getIs_syUpStore()){
                sb.append(" is_syUpStore = 1,");
            }
            if(signBackSwitchBean.getYuantongStoreCode()!=null&&!"".equals(signBackSwitchBean.getYuantongStoreCode())){
                sb.append(" yuantongStoreCode = '"+signBackSwitchBean.getYuantongStoreCode()+"',");
            }
            sb.append(" is_valid  = 1");
            sb.append(" where storeId = "+signBackSwitchBean.getStoreId()+" AND expId = " + signBackSwitchBean.getExpId());
            PreparedStatement ps = con.prepareStatement(sb.toString());
            ps.executeUpdate();
            con.close();
        }catch (Exception e){
            log.error(e.getMessage());
        }

    }

    @Override
    public void OpenStore(int storeId, int expId){
        try{
            SignBackSwitchBean signBackSwitchBean = getSignBackSwitch(expId , storeId);
            if(signBackSwitchBean == null){
                Class.forName("com.mysql.jdbc.Driver");
                Connection con = DBUtil.getJeesiteConnection();
                String sql = "insert into sign_back_switch (storeId,expId,is_valid) values(?,?,?)";
                PreparedStatement ps = con.prepareStatement(sql);
                ps.setInt(1, storeId);
                ps.setInt(2, expId);
                ps.setInt(3, 1);
                ps.executeUpdate();
                con.close();
                if(expId == 223){
                    Map mapStore=new HashMap();
                    mapStore.put("id",storeId);
                    mapStore.put("isOpenSignBack",1);
                    this.exStoreService.updateStoreByIdForBest(mapStore);
                }
            }
        }catch (Exception e){
            log.error(e.getMessage());
        }

    }

}
