package cn.haliaeetus.sendmessage.service.impl;

import cn.haliaeetus.sendmessage.bean.basedata.FjUser;
import cn.haliaeetus.sendmessage.bean.basedata.Menu;
import cn.haliaeetus.sendmessage.bean.basedata.Store;
import cn.haliaeetus.sendmessage.bean.basedata.User;
import cn.haliaeetus.sendmessage.bean.config.PlatformConfig;
import cn.haliaeetus.sendmessage.bean.sms.SmsSendStatistics;
import cn.haliaeetus.sendmessage.constants.Constants;
import cn.haliaeetus.sendmessage.controller.web.QueryCondition.UserQueryCondition;
import cn.haliaeetus.sendmessage.dao.PlatformConfigDao;
import cn.haliaeetus.sendmessage.dao.SmsSendStatisticsDao;
import cn.haliaeetus.sendmessage.dao.UserDao;
import cn.haliaeetus.sendmessage.framework.base.digt.Md5Util;
import cn.haliaeetus.sendmessage.framework.log.Logger;
import cn.haliaeetus.sendmessage.framework.toolkit.CacheTool;
import cn.haliaeetus.sendmessage.service.BasicInfoService;
import cn.haliaeetus.sendmessage.service.FjUserService;
import cn.haliaeetus.sendmessage.service.PlatformConfigService;
import cn.haliaeetus.sendmessage.service.UserService;
import cn.haliaeetus.sendmessage.utils.*;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.*;

/**
 * @author kael
 */
@Service
@Slf4j
public class PlatformConfigServiceImpl implements PlatformConfigService {

	@Autowired
	private PlatformConfigDao platformConfigDao;

	/**
	 * 通过平台查询配置信息
	 * @param platform
	 * @return
	 */
	@Override
	public PlatformConfig getByPlatform(String platform){
		CacheTool cacheTool = CacheTool.initPlatformConfig();
		PlatformConfig platformConfig = (PlatformConfig) cacheTool.getBean(platform);
		if (platformConfig != null) {
			return platformConfig;
		} else {
			platformConfig = platformConfigDao.getByPlatform(platform);
			if (platformConfig != null) {
				cacheTool.saveBean(platform, platformConfig);
				return platformConfig;
			}
			return null;
		}
	}
}
