package cn.haliaeetus.sendmessage.service.impl;

import cn.haliaeetus.sendmessage.bean.WhiteList;
import cn.haliaeetus.sendmessage.dao.WhiteListDao;
import cn.haliaeetus.sendmessage.service.WhiteListService;
import cn.haliaeetus.sendmessage.utils._;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class WhiteListServiceImpl implements WhiteListService {
	@Autowired
	private WhiteListDao whiteListDao;

	public List<WhiteList> getByStoreId(int storeId) {
		List<WhiteList> list = whiteListDao.getByStoreId(storeId);	
		return list;
	}
	
	public List<WhiteList> getByPhoneStoreId(String phone,int storeId){
		List<WhiteList> list = whiteListDao.getByPhoneStoreId(phone, storeId);
		return list;
	}
	
	public int saveWhiteList(WhiteList whiteList){
		return whiteListDao.saveWhiteList(whiteList);
	}
		
	public int updateWhiteList(WhiteList whiteList){
		return whiteListDao.updateWhiteList(whiteList);
	}
	
	public int deleteWhiteList(int storeId, String mobilePhone){
		return whiteListDao.deleteWhiteList(storeId, mobilePhone);
	}

	@Override
	public boolean isWhiteUser(String phone, int storeId) {
		// TODO Auto-generated method stub
		boolean result = false;
		List<WhiteList> list = whiteListDao.getByPhoneStoreId(phone, storeId);
		if(_.isNotEmpty(list)){
			result=true;
		}
		return result;
	}
	
	
	
	
	
}
