package cn.haliaeetus.sendmessage.service.rsync.impl;

import cn.haliaeetus.sendmessage.bean.ConsumeRecord;
import cn.haliaeetus.sendmessage.bean.basedata.User;
import cn.haliaeetus.sendmessage.bean.dto.ConsumeListDto;
import cn.haliaeetus.sendmessage.bean.sms.SmsRecord;
import cn.haliaeetus.sendmessage.dao.ConsumeRecordDao;
import cn.haliaeetus.sendmessage.service.rsync.ConsumeRecordService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

/**
 * 短信发送记录Service
 */
@Service
public class ConsumeRecordServiceImpl implements ConsumeRecordService {
	@Autowired
	private ConsumeRecordDao consumeRecordDAO;
//	@Autowired
//	private IHistorySmsRecordDao historySmsRecordDao;

	public int save(ConsumeRecord consumeRecord) {
		return consumeRecordDAO.insert(consumeRecord);
	}

	public List<ConsumeListDto> getAllConsumeList(String beginTime, String endTime, String storageId){
		return consumeRecordDAO.getAllConsumeList( beginTime, endTime,storageId);
	}

	public List<ConsumeListDto> getConsumeList(String consumeFlag, String beginTime, String endTime,String storageId){
		return consumeRecordDAO.getConsumeList(consumeFlag, beginTime, endTime,storageId);
	}


	public List<ConsumeListDto> getAllConsumeList4app( String beginTime, String endTime,String storageId){
		return consumeRecordDAO.getAllConsumeList4app( beginTime, endTime,storageId);
	}

	public List<ConsumeListDto> getConsumeList4app(String consumeFlag, String beginTime, String endTime,String storageId){
		return consumeRecordDAO.getConsumeList4app(consumeFlag, beginTime, endTime,storageId);
	}

	@Override
	public Integer sendMsgUpConsume(SmsRecord smsRecord, User user,boolean isSuccess){
		ConsumeRecord consumeRecord=new ConsumeRecord();
		consumeRecord.setConsumeFlag("1");//0代表ocr,1代表短信
		consumeRecord.setSmsId(String.valueOf(smsRecord.getId()));
		consumeRecord.setStoreId(smsRecord.getStoreid());
		consumeRecord.setExpcode(smsRecord.getExpcode());
		consumeRecord.setExpId(smsRecord.getExpid());
		consumeRecord.setCreateTime(new Date());
		consumeRecord.setConsumeStatus("1");
		if(user!=null){
			consumeRecord.setOperatorId(BigDecimal.valueOf(Long.valueOf(user.getUserId())));
		}else{
			consumeRecord.setOperatorId(null);
		}
		consumeRecord.setDeliveryId(smsRecord.getDeliveryid());
		consumeRecord.setOcrId("");
		if(!isSuccess){
			consumeRecord.setConsumeStatus("2");
			consumeRecord.setPreBalance(user.getSmsBalance());
			consumeRecord.setAftBalance(user.getSmsBalance());
			consumeRecord.setNowAmount(BigDecimal.ZERO);
		}
		BigDecimal result=new BigDecimal(0);
		int smsCount=smsRecord.getSmsCount();
		BigDecimal smsCount1=BigDecimal.valueOf(smsCount);
		result=user.getSmsBalance().subtract(smsCount1.multiply(user.getSmsPrice()));
		BigDecimal preBalance=user.getSmsBalance();
		user.setSmsBalance(user.getSmsBalance().subtract(smsCount1.multiply(user.getSmsPrice())));
		System.out.println("+++++++++++++*****------------"+user.getSmsBalance());
		consumeRecord.setPreBalance(preBalance);
		consumeRecord.setAftBalance(result);
		consumeRecord.setNowAmount(smsCount1.multiply(user.getSmsPrice()));
		return this.save(consumeRecord);
	}
}