package cn.haliaeetus.sendmessage.service.sms;

import cn.haliaeetus.sendmessage.bean.MqBean;
import cn.haliaeetus.sendmessage.bean.api.ApiLog;
import cn.haliaeetus.sendmessage.bean.mengwang.MengWangSmsStatusBean;
import cn.haliaeetus.sendmessage.bean.sms.SmsPurchaseRecord;
import cn.haliaeetus.sendmessage.bean.sms.SmsRecord;
import cn.haliaeetus.sendmessage.bean.sms.UpSmsInfo;
import cn.haliaeetus.sendmessage.utils.pdd.PddSmsReceiptRequest;
import com.rabbitmq.client.Channel;
import org.springframework.messaging.handler.annotation.Headers;

import java.sql.Timestamp;
import java.util.List;
import java.util.Map;

/**
 * 短信发送记录Service
 */
public interface SmsRecordService {
	public int save(SmsRecord smsRecord);

	List<SmsRecord> getFailSmsRecordsOfStoreToday(int storeId);

	long countSmsRecordsOfStoreToday(int storeId, Integer status);

	public SmsRecord getSmsRecordByMsgid(String msgid);

	public void update(SmsRecord smsRecord);

	public SmsRecord getSmsRecord(SmsRecord smsRecord);
	
	public List<SmsRecord> getSendSmsList(String keyword, String type);
	
	public List<SmsRecord> getSendSmsListHis(String keyword, String type);

	public int savePurchaseRecord(SmsPurchaseRecord smsPurchaseRecord);

	public void updatePurchaseRecord(SmsPurchaseRecord SmsPurchaseRecord);

	public SmsPurchaseRecord getRecordByOutTradeNo(SmsPurchaseRecord SmsPurchaseRecord);

	public List<SmsRecord> getSmsCenterList(int storeId, Timestamp beginTime, Timestamp endTime, int status);

    void send(String msg, Long mqRetryTime, String queue);

    void installApiLog(ApiLog log);

	void installApiLogMq(String jsonObject, String queueName);

	<T extends MqBean> void msgErrorHandle(@Headers Map<String, Object> headers, Channel channel, T t, String queueName);

    void upSmsMsg(UpSmsInfo request) throws Exception;

	void addMengWangSmsStatusInfo(List<MengWangSmsStatusBean> mengWangSmsStatusBeanList);
}