package cn.haliaeetus.sendmessage.utils;

import cn.haliaeetus.sendmessage.constants.Constants;
import org.springframework.util.StringUtils;

/**
 * <p>门店派件工具类</p>
 * 
 * @author sqj
 * @since 1.0
 * @version 1.0
 */
public class DeliveryUtil {
	public static boolean isValidCode(Integer expressType, String code) {
		if (!StringUtils.hasText(code)) {
			return false;
		}
		
//		boolean isValid = code.matches("\\w+");
//		if (expressType == Constants.EXPRESS_TYPE_HTKY && (code.length() < 12 || code.length() > 14)) {
//			isValid = false;
//		}
		
		return true;
	}
	
	public static boolean isValidSource(Integer source) {
		if (source == null) {
			return false;
		}
		return ReflectionUtil.getFieldValuesByPrefix(Constants.class, "CLIENT_TYPE").contains(source);
	}
	
	/**
	 * 通过派件来源简拼获取来源
	 * @param shortName 派件来源简拼
	 * @return
	 */
	public static int getSourceByShortName(String shortName) {
		if (!StringUtils.hasText(shortName)) {
			return 0;
		}
		
		Integer source = (Integer) ReflectionUtil.getFieldValueByName(Constants.class, "CLIENT_TYPE_" + shortName.toUpperCase());
		if (source == null) {
			return 0;
		} else {
			return source;
		}
	}
	
	/**
	 * 通过派件完善类型简拼获取完善类型
	 * @param shortName 派件完善类型简拼
	 * @return
	 */
	public static int getFillTypeByShortName(String shortName) {
		if (!StringUtils.hasText(shortName)) {
			return 0;
		}
		
		Integer fillType = (Integer) ReflectionUtil.getFieldValueByName(Constants.class, "ORDER_FILL_TYPE_" + shortName.toUpperCase());
		if (fillType == null) {
			return 0;
		} else {
			return fillType;
		}
	}
	
	/**
	 * 通过未妥投原因简拼获取原因值
	 * @param shortName 原因简拼
	 * @return
	 */
	public static int getRejectReasonByShortName(String shortName) {
		Integer reason = (Integer) ReflectionUtil.getFieldValueByName(Constants.class, "REJECT_REASON_" + shortName);
		if (reason == null) {
			return 0;
		} else {
			return reason;
		}
	}
	
	/**
	 * 通过派件业务代码简拼获取派件业务代码
	 * @param shortName 业务代码简拼
	 * @return
	 */
	public static String getBussCodeByShortName(String shortName) {
		if (!StringUtils.hasText(shortName)) {
			return "";
		}
		
		Object bussCode = ReflectionUtil.getFieldValueByName(Constants.class, "BUSS_CODE_" + shortName);
		return bussCode == null ? "" : bussCode.toString();
	}
}