package cn.haliaeetus.sendmessage.utils.jiguang;
import cn.haliaeetus.sendmessage.bean.jiguang.ExtraBean;
import cn.haliaeetus.sendmessage.bean.jiguang.JiguangBean;
import cn.jpush.api.JPushClient;
import cn.jpush.api.push.PushResult;
import cn.jpush.api.push.model.Message;
import cn.jpush.api.push.model.Options;
import cn.jpush.api.push.model.Platform;
import cn.jpush.api.push.model.PushPayload;
import cn.jpush.api.push.model.audience.Audience;
import cn.jpush.api.push.model.notification.*;
import com.alibaba.fastjson.JSON;

import java.util.*;


public class JpushClientUtil {

    private final static String appKey = "22af32325a2be30bac993f5e";

    private final static String masterSecret = "b8cac24c90c00011f1badf1c";

    private static JPushClient jPushClient = new JPushClient(masterSecret,appKey);


    /**
     * 极光推送
     * @return 0推送失败，1推送成功
     */
    public static int jiguangSend(JiguangBean jiguangBean) {
        int result = 0;
        try {
            switch(jiguangBean.getPushRange()) {
                case "all":
                    result = sendToAllUsers(jiguangBean);
                    break;
                case "alias":
                    result = sendToAliasUsers(jiguangBean);
                    break;
                case "allIos":
                    result = sendToAllIos(jiguangBean);
                    break;
                case "allAndroid":
                    result = sendToAllAndroid(jiguangBean);
                    break;
                default:

            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return result;
    }


    /**
     * 发送给所有用户
     * @return 0推送失败，1推送成功
     */
    public static int sendToAllUsers(JiguangBean jiguangBean) {
        int result = 0;
        try {
            PushPayload pushPayload= null;
            switch(jiguangBean.getPushType()) {
                case "1":
                    pushPayload = JpushClientUtil.buildPushObject_android_and_ios_alias(jiguangBean.getNotification_title(),jiguangBean.getMsg_title(),
                            jiguangBean.getMsg_content(),jiguangBean.getExtraBean());
                    break;
                case "2":
                    pushPayload = JpushClientUtil.buildPushObject_android_and_ios_alias_appMsg(jiguangBean.getNotification_title(),jiguangBean.getMsg_title(),
                            jiguangBean.getMsg_content(),jiguangBean.getExtraBean());
                    break;
                default:

            }
            PushResult pushResult=jPushClient.sendPush(pushPayload);
            if(pushResult.getResponseCode()==200){
                result=1;
            }
        } catch (Exception e) {

            e.printStackTrace();
        }

        return result;
    }

    /**
     * 发送给指定标签用户
     * @return 0推送失败，1推送成功
     */
    public static int sendToAliasUsers(JiguangBean jiguangBean) {
        int result = 0;
        try {
            PushPayload pushPayload= null;
            switch(jiguangBean.getPushType()) {
                case "1":
                    pushPayload = JpushClientUtil.buildPushObject_android_and_ios_alias(jiguangBean.getNotification_title(),jiguangBean.getMsg_title(),
                            jiguangBean.getMsg_content(),jiguangBean.getAlias(),jiguangBean.getExtraBean());
                    break;
                case "2":
                    pushPayload = JpushClientUtil.buildPushObject_android_and_ios_alias_appMsg(jiguangBean.getNotification_title(),jiguangBean.getMsg_title(),
                            jiguangBean.getMsg_content(),jiguangBean.getAlias(),jiguangBean.getExtraBean());
                    break;
                default:

            }
            PushResult pushResult=jPushClient.sendPush(pushPayload);
            if(pushResult.getResponseCode()==200){
                result=1;
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return result;
    }

    /**
     * 发送给所有安卓用户
     * @param jiguangBean
     * @return
     */
    public static int sendToAllAndroid(JiguangBean jiguangBean) {
        int result = 0;
        try {
            PushPayload pushPayload= null;
            switch(jiguangBean.getPushType()) {
                case "1":
                    pushPayload = JpushClientUtil.buildPushObject_android_all_alertWithTitle(jiguangBean);
                    break;
                case "2":
                    pushPayload = JpushClientUtil.buildPushObject_android_all_alertWithTitle_appMsg(jiguangBean);
                    break;
                default:

            }
            PushResult pushResult=jPushClient.sendPush(pushPayload);
            if(pushResult.getResponseCode()==200){
                result=1;
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return result;
    }

    /**
     * 发送给所有ios用户
     * @param jiguangBean
     * @return
     */
    public static int sendToAllIos(JiguangBean jiguangBean) {
        int result = 0;
        try {
            PushPayload pushPayload= null;
            switch(jiguangBean.getPushType()) {
                case "1":
                    pushPayload = JpushClientUtil.buildPushObject_ios_all_alertWithTitle(jiguangBean);
                    break;
                case "2":
                    pushPayload = JpushClientUtil.buildPushObject_ios_all_alertWithTitle_appMsg(jiguangBean);
                    break;
                default:

            }
            PushResult pushResult=jPushClient.sendPush(pushPayload);
            if(pushResult.getResponseCode()==200){
                result=1;
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return result;
    }

    /**
     *
     * @param notification_title
     * @param msg_title
     * @param msg_content
     * @param alias
     * @param extraBean
     * @return
     */
    public static PushPayload buildPushObject_android_and_ios_alias(String notification_title, String msg_title, String msg_content, Collection<String> alias, ExtraBean extraBean) {
        return PushPayload.newBuilder()
                .setPlatform(Platform.android_ios())
                .setAudience(Audience.alias(alias))
                .setNotification(Notification.newBuilder()
                        .setAlert(IosAlert.newBuilder().setTitleAndBody(notification_title,msg_title,msg_content).build())
                        .addPlatformNotification(AndroidNotification.newBuilder()
                                .setAlert(msg_content)
                                .setTitle(notification_title)
                                //此字段为透传字段，不会显示在通知栏。用户可以通过此字段来做一些定制需求，如特定的key传要指定跳转的页面（value）
                                .addExtra("jgExtra",JSON.toJSONString(extraBean))
                                .build()
                        )
                        .addPlatformNotification(IosNotification.newBuilder()
                                //传一个IosAlert对象，指定apns title、title、subtitle等
                                .setAlert(IosAlert.newBuilder().setTitleAndBody(notification_title,"",msg_content).build())
                                //直接传alert
                                //此项是指定此推送的badge自动加1
                                .incrBadge(1)
                                //此字段的值default表示系统默认声音；传sound.caf表示此推送以项目里面打包的sound.caf声音来提醒，
                                // 如果系统没有此音频则以系统默认声音提醒；此字段如果传空字符串，iOS9及以上的系统是无声音提醒，以下的系统是默认声音
                                .setSound(extraBean.getSound())
                                //此字段为透传字段，不会显示在通知栏。用户可以通过此字段来做一些定制需求，如特定的key传要指定跳转的页面（value）
                                .addExtra("jgExtra",JSON.toJSONString(extraBean))
                                //此项说明此推送是一个background推送，想了解background看：http://docs.jpush.io/client/ios_tutorials/#ios-7-background-remote-notification
                                // .setContentAvailable(true)

                                .build()
                        )
                        .build()
                )
                .setOptions(Options.newBuilder()
                        //此字段的值是用来指定本推送要推送的apns环境，false表示开发，true表示生产；对android和自定义消息无意义
                        .setApnsProduction(true)
                        //此字段是给开发者自己给推送编号，方便推送者分辨推送记录
                        .setSendno(1)
                        //此字段的值是用来指定本推送的离线保存时长，如果不传此字段则默认保存一天，最多指定保留十天，单位为秒
                        .setTimeToLive(86400)
                        .build()
                )
                .build();
    }

    /**
     *
     * @param notification_title
     * @param msg_title
     * @param msg_content
     * @param extraBean
     * @return
     */
    public static PushPayload buildPushObject_android_and_ios_alias_appMsg(String notification_title, String msg_title, String msg_content, ExtraBean extraBean) {
        return PushPayload.newBuilder()
                .setPlatform(Platform.android_ios())
                .setAudience(Audience.all())
                //Platform指定了哪些平台就会像指定平台中符合推送条件的设备进行推送。 jpush的自定义消息，
                // sdk默认不做任何处理，不会有通知提示。建议看文档http://docs.jpush.io/guideline/faq/的
                // [通知与自定义消息有什么区别？]了解通知和自定义消息的区别
                .setMessage(Message.newBuilder()
                        .setTitle(notification_title)
                        .setMsgContent(msg_content)
                        .addExtra("jgExtra",JSON.toJSONString(extraBean))
                        .build())

                .setOptions(Options.newBuilder()
                        //此字段的值是用来指定本推送要推送的apns环境，false表示开发，true表示生产；对android和自定义消息无意义
                        .setApnsProduction(true)
                        //此字段是给开发者自己给推送编号，方便推送者分辨推送记录
                        .setSendno(1)
                        //此字段的值是用来指定本推送的离线保存时长，如果不传此字段则默认保存一天，最多指定保留十天，单位为秒
                        .setTimeToLive(86400)
                        .build()
                )
                .build();
    }

    /**
     *
     * @param notification_title
     * @param msg_title
     * @param msg_content
     * @param extraBean
     * @return
     */
    public static PushPayload buildPushObject_android_and_ios_alias(String notification_title, String msg_title, String msg_content, ExtraBean extraBean) {
        return PushPayload.newBuilder()
                .setPlatform(Platform.android_ios())
                .setAudience(Audience.all())
                .setNotification(Notification.newBuilder()
                        .setAlert(IosAlert.newBuilder().setTitleAndBody(notification_title,msg_title,msg_content).build())
                        .addPlatformNotification(AndroidNotification.newBuilder()
                                .setAlert(msg_content)
                                .setTitle(notification_title)
                                //此字段为透传字段，不会显示在通知栏。用户可以通过此字段来做一些定制需求，如特定的key传要指定跳转的页面（value）
                                .addExtra("jgExtra",JSON.toJSONString(extraBean))
                                .build()
                        )
                        .addPlatformNotification(IosNotification.newBuilder()
                                //传一个IosAlert对象，指定apns title、title、subtitle等
                                .setAlert(IosAlert.newBuilder().setTitleAndBody(notification_title,msg_title,msg_content).build())
                                //直接传alert
                                //此项是指定此推送的badge自动加1
                                .incrBadge(1)
                                //此字段的值default表示系统默认声音；传sound.caf表示此推送以项目里面打包的sound.caf声音来提醒，
                                // 如果系统没有此音频则以系统默认声音提醒；此字段如果传空字符串，iOS9及以上的系统是无声音提醒，以下的系统是默认声音
                                .setSound(extraBean.getSound())
                                //此字段为透传字段，不会显示在通知栏。用户可以通过此字段来做一些定制需求，如特定的key传要指定跳转的页面（value）
                                .addExtra("jgExtra",JSON.toJSONString(extraBean))
                                //此项说明此推送是一个background推送，想了解background看：http://docs.jpush.io/client/ios_tutorials/#ios-7-background-remote-notification
                                // .setContentAvailable(true)
                                .build()
                        )
                        .build()
                )
                .setOptions(Options.newBuilder()
                        //此字段的值是用来指定本推送要推送的apns环境，false表示开发，true表示生产；对android和自定义消息无意义
                        .setApnsProduction(true)
                        //此字段是给开发者自己给推送编号，方便推送者分辨推送记录
                        .setSendno(1)
                        //此字段的值是用来指定本推送的离线保存时长，如果不传此字段则默认保存一天，最多指定保留十天，单位为秒
                        .setTimeToLive(86400)
                        .build()
                )
                .build();
    }

    /**
     *
     * @param notification_title
     * @param msg_title
     * @param msg_content
     * @param alias
     * @param extraBean
     * @return
     */
    public static PushPayload buildPushObject_android_and_ios_alias_appMsg(String notification_title, String msg_title, String msg_content, Collection<String> alias, ExtraBean extraBean) {
        return PushPayload.newBuilder()
                .setPlatform(Platform.android_ios())
                .setAudience(Audience.alias(alias))
                //Platform指定了哪些平台就会像指定平台中符合推送条件的设备进行推送。 jpush的自定义消息，
                // sdk默认不做任何处理，不会有通知提示。建议看文档http://docs.jpush.io/guideline/faq/的
                // [通知与自定义消息有什么区别？]了解通知和自定义消息的区别
                .setMessage(Message.newBuilder()
                        .setTitle(notification_title)
                        .setMsgContent(msg_content)
                        .addExtra("jgExtra",JSON.toJSONString(extraBean))
                        .build())

                .setOptions(Options.newBuilder()
                        //此字段的值是用来指定本推送要推送的apns环境，false表示开发，true表示生产；对android和自定义消息无意义
                        .setApnsProduction(true)
                        //此字段是给开发者自己给推送编号，方便推送者分辨推送记录
                        .setSendno(1)
                        //此字段的值是用来指定本推送的离线保存时长，如果不传此字段则默认保存一天，最多指定保留十天，单位为秒
                        .setTimeToLive(86400)
                        .build()
                )
                .build();
    }


    /**
     * 发送给所有安卓用户(通知)
     * @param jiguangBean
     * @return
     */
    private static PushPayload buildPushObject_android_all_alertWithTitle(JiguangBean jiguangBean) {
        return PushPayload.newBuilder()
                //指定要推送的平台，all代表当前应用配置了的所有平台，也可以传android等具体平台
                .setPlatform(Platform.android())
                //指定推送的接收对象，all代表所有人，也可以指定已经设置成功的tag或alias或该应应用客户端调用接口获取到的registration id
                .setAudience(Audience.all())
                //jpush的通知，android的由jpush直接下发，iOS的由apns服务器下发，Winphone的由mpns下发
                .setNotification(Notification.newBuilder()
                        //指定当前推送的android通知
                        .addPlatformNotification(AndroidNotification.newBuilder()
                                .setAlert(jiguangBean.getMsg_content())
                                .setTitle(jiguangBean.getNotification_title())
                                //此字段为透传字段，不会显示在通知栏。用户可以通过此字段来做一些定制需求，如特定的key传要指定跳转的页面（value）
                                .addExtra("jgExtra",JSON.toJSONString(jiguangBean.getExtraBean()))
                                .build())
                        .build()
                )
                .setOptions(Options.newBuilder()
                        //此字段的值是用来指定本推送要推送的apns环境，false表示开发，true表示生产；对android和自定义消息无意义
                        .setApnsProduction(true)
                        //此字段是给开发者自己给推送编号，方便推送者分辨推送记录
                        .setSendno(1)
                        //此字段的值是用来指定本推送的离线保存时长，如果不传此字段则默认保存一天，最多指定保留十天，单位为秒
                        .setTimeToLive(86400)
                        .build()
                )
                .build();
    }

    /**
     * 发送给所有安卓用户(app内消息)
     * @param jiguangBean
     * @return
     */
    private static PushPayload buildPushObject_android_all_alertWithTitle_appMsg(JiguangBean jiguangBean) {
        return PushPayload.newBuilder()
                //指定要推送的平台，all代表当前应用配置了的所有平台，也可以传android等具体平台
                .setPlatform(Platform.android())
                //指定推送的接收对象，all代表所有人，也可以指定已经设置成功的tag或alias或该应应用客户端调用接口获取到的registration id
                .setAudience(Audience.all())
                //Platform指定了哪些平台就会像指定平台中符合推送条件的设备进行推送。 jpush的自定义消息，
                // sdk默认不做任何处理，不会有通知提示。建议看文档http://docs.jpush.io/guideline/faq/的
                // [通知与自定义消息有什么区别？]了解通知和自定义消息的区别
                .setMessage(Message.newBuilder()
                        .setMsgContent(jiguangBean.getMsg_content())
                        .setTitle(jiguangBean.getNotification_title())
                        .addExtra("jgExtra",JSON.toJSONString(jiguangBean.getExtraBean()))
                        .build())

                .setOptions(Options.newBuilder()
                        //此字段的值是用来指定本推送要推送的apns环境，false表示开发，true表示生产；对android和自定义消息无意义
                        .setApnsProduction(true)
                        //此字段是给开发者自己给推送编号，方便推送者分辨推送记录
                        .setSendno(1)
                        //此字段的值是用来指定本推送的离线保存时长，如果不传此字段则默认保存一天，最多指定保留十天，单位为秒
                        .setTimeToLive(86400)
                        .build())
                .build();
    }

    /**
     * 发送给所有ios用户(通知)
     * @param jiguangBean
     * @return
     */
    private static PushPayload buildPushObject_ios_all_alertWithTitle(JiguangBean jiguangBean) {
        return PushPayload.newBuilder()
                //指定要推送的平台，all代表当前应用配置了的所有平台，也可以传android等具体平台
                .setPlatform(Platform.ios())
                //指定推送的接收对象，all代表所有人，也可以指定已经设置成功的tag或alias或该应应用客户端调用接口获取到的registration id
                .setAudience(Audience.all())
                //jpush的通知，android的由jpush直接下发，iOS的由apns服务器下发，Winphone的由mpns下发
                .setNotification(Notification.newBuilder()
                        //指定当前推送的android通知
                        .addPlatformNotification(IosNotification.newBuilder()
                                //传一个IosAlert对象，指定apns title、title、subtitle等
                                .setAlert(IosAlert.newBuilder().setTitleAndBody(jiguangBean.getNotification_title(),"",jiguangBean.getMsg_content()).build())
                                //直接传alert
                                //此项是指定此推送的badge自动加1
                                .incrBadge(1)
                                //此字段的值default表示系统默认声音；传sound.caf表示此推送以项目里面打包的sound.caf声音来提醒，
                                // 如果系统没有此音频则以系统默认声音提醒；此字段如果传空字符串，iOS9及以上的系统是无声音提醒，以下的系统是默认声音
                                .setSound(jiguangBean.getExtraBean().getSound())
                                //此字段为透传字段，不会显示在通知栏。用户可以通过此字段来做一些定制需求，如特定的key传要指定跳转的页面（value）
                                .addExtra("jgExtra",JSON.toJSONString(jiguangBean.getExtraBean()))
                                //此项说明此推送是一个background推送，想了解background看：http://docs.jpush.io/client/ios_tutorials/#ios-7-background-remote-notification
                                // .setContentAvailable(true)

                                .build())
                        .build()
                )
                .setOptions(Options.newBuilder()
                        //此字段的值是用来指定本推送要推送的apns环境，false表示开发，true表示生产；对android和自定义消息无意义
                        .setApnsProduction(true)
                        //此字段是给开发者自己给推送编号，方便推送者分辨推送记录
                        .setSendno(1)
                        //此字段的值是用来指定本推送的离线保存时长，如果不传此字段则默认保存一天，最多指定保留十天，单位为秒
                        .setTimeToLive(86400)
                        .build()
                )
                .build();
    }

    /**
     * 发送给所有ios用户(app内msg)
     * @param jiguangBean
     * @return
     */
    private static PushPayload buildPushObject_ios_all_alertWithTitle_appMsg(JiguangBean jiguangBean) {
        return PushPayload.newBuilder()
                //指定要推送的平台，all代表当前应用配置了的所有平台，也可以传android等具体平台
                .setPlatform(Platform.ios())
                //指定推送的接收对象，all代表所有人，也可以指定已经设置成功的tag或alias或该应应用客户端调用接口获取到的registration id
                .setAudience(Audience.all())
                //Platform指定了哪些平台就会像指定平台中符合推送条件的设备进行推送。 jpush的自定义消息，
                // sdk默认不做任何处理，不会有通知提示。建议看文档http://docs.jpush.io/guideline/faq/的
                // [通知与自定义消息有什么区别？]了解通知和自定义消息的区别
                .setMessage(Message.newBuilder()
                        .setMsgContent(jiguangBean.getMsg_content())
                        .setTitle(jiguangBean.getNotification_title())
                        .addExtra("jgExtra",JSON.toJSONString(jiguangBean.getExtraBean()))
                        .build())

                .setOptions(Options.newBuilder()
                        //此字段的值是用来指定本推送要推送的apns环境，false表示开发，true表示生产；对android和自定义消息无意义
                        .setApnsProduction(true)
                        //此字段是给开发者自己给推送编号，方便推送者分辨推送记录
                        .setSendno(1)
                        //此字段的值是用来指定本推送的离线保存时长，如果不传此字段则默认保存一天，最多指定保留十天，单位为秒
                        .setTimeToLive(86400)
                        .build())
                .build();
    }

    public static void main(String[] args){
        JiguangBean jiguangBean = new JiguangBean();

        //all:全部 alias:根据别名推送 allIos:推送所有ios用户 allAndroid:推送所有安卓用户
        jiguangBean.setPushRange("all");
        //1.极光推送， 2.app内自定义推送
        jiguangBean.setPushType("1");
        jiguangBean.setNotification_title("测试");
        jiguangBean.setMsg_content("测试");

        ExtraBean extraBean = new ExtraBean();
        extraBean.setControllerIOS("ScanViewController");
        extraBean.setControllerAndroid("MessageCenterActivity");
        extraBean.setParams("asdfa,ioiooo,ooppp");
        extraBean.setSound("safdsfsd");
        extraBean.setType("2");
        extraBean.setUrl("https://fengzhan.oss-cn-shanghai.aliyuncs.com/oss.mp4");
        jiguangBean.setExtraBean(extraBean);
////        buildPushObject_ios_all_alertWithTitle(jiguangBean);
//        Collection<String> alias = new HashSet<>();
//        alias.add("17321439006");
//        alias.add("18702615903");
//        alias.add("18739959769");
//        jiguangBean.setAlias(alias);

        if(JpushClientUtil.jiguangSend(jiguangBean)==1){
            System.out.println("success");
        }
    }
}