package cn.haliaeetus.sendmessage.utils.pdd;

import cn.haliaeetus.sendmessage.framework.factory.platform.realize.PddPlatform;
import cn.haliaeetus.sendmessage.service.BasicInfoService;
import com.google.common.base.Strings;
import lombok.extern.slf4j.Slf4j;

/**
 * @ClassName GetSystemParam
 * @Description TODO
 * @Author Administrator
 * @Date 2019/9/5 0005 上午 9:21
 * @Version 1.0
 **/
@Slf4j
public class GetSystemParam {

    private boolean myResult;
    private String url;
    private String pddUrl;
    private String partnerId;
    private String secret;

    public boolean is() {
        return myResult;
    }

    public String getUrl() {
        return url;
    }

    public String getPddUrl() {
        return pddUrl;
    }

    public String getPartnerId() {
        return partnerId;
    }

    public String getSecret() {
        return secret;
    }

    public GetSystemParam invoke(BasicInfoService basicInfoService) {
        url = basicInfoService.getConfigurationByCode("signbackUrl").getOValue1();
        if(Strings.isNullOrEmpty(url)){
            log.info("url没有配置");
            myResult = true;
            return this;
        }
        pddUrl = basicInfoService.getConfigurationByCode("pddUrl").getOValue1();
        if(Strings.isNullOrEmpty(pddUrl)){
            log.info("pddUrl没有配置");
            myResult = true;
            return this;
        }
        partnerId = basicInfoService.getConfigurationByCode("pddPartnerId").getOValue1();
        if(Strings.isNullOrEmpty(partnerId)){
            log.info("pddPartnerId没有配置");
            myResult = true;
            return this;
        }
        secret = basicInfoService.getConfigurationByCode("pddSecret").getOValue1();
        if(Strings.isNullOrEmpty(secret)){
            log.info("pddSecret没有配置");
            myResult = true;
            return this;
        }
        myResult = false;
        return this;
    }
}
