package cn.haliaeetus.sendmessage.utils.weixin;

import cn.haliaeetus.sendmessage.framework.base.crawler.Crawler;
import cn.haliaeetus.sendmessage.framework.base.digt.EscapeUtil;
import cn.haliaeetus.sendmessage.framework.base.infrastructure.Config;
import cn.haliaeetus.sendmessage.framework.toolkit.MyExecutor;
import org.apache.commons.lang3.tuple.Pair;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class WxPushHelper {

	private static final Crawler crawler = Crawler.of("wx.push.crawler",3000,8000);

	private static final String pushUrl = Config.of("wx.push.url","http://weixin.haliaeetus.cn/templateMsg/send").get();

	private static final String custPushUrl = Config.of("wx.cust.push.url","http://weixin.haliaeetus.cn/customMsg/sendTextAndTemplateMsg").get();

	private static final String textPushUrl = Config.of("wx.text.push.url","http://weixin.haliaeetus.cn/customMsg/sendText").get();

	private static final Logger log = LoggerFactory.getLogger(WxPushHelper.class);

	private static final MyExecutor executor = MyExecutor.instance();

	public static void pushWx(final String template ){
		try {
			executor.submit("push.wx.task", new Runnable() {
				@Override
				public void run() {
					Pair<Integer, String> result = crawler.post(pushUrl, template, EscapeUtil.CHARSET_UTF8);
					log.info("pushWx,entity={},return.code={},return.msg={}", template, result.getLeft(), result.getRight());
				}
			});
		}catch (Exception e){
			log.error("putshWx.template:"+template,e);
//			e.printStackTrace();
		}
	}

	public static void pushTextWx(final String template){
		try {
			executor.submit("push.wx.task", new Runnable() {
				@Override
				public void run() {
					Pair<Integer, String> result = crawler.post(textPushUrl, template, EscapeUtil.CHARSET_UTF8);
					log.info("pushTextWx,entity={},return.code={},return.msg={}", template, result.getLeft(), result.getRight());
				}
			});
		}catch (Exception e){
			log.error("pushTextWx.template:"+template,e);
//			e.printStackTrace();
		}
	}
	
	
	public static void pushCustWx(final String template ){
		try {
			executor.submit("push.wx.task", new Runnable() {
				@Override
				public void run() {
					Pair<Integer, String> result = crawler.post(custPushUrl, template, EscapeUtil.CHARSET_UTF8);
					log.info("pushCustWx,entity={},return.code={},return.msg={}", template, result.getLeft(), result.getRight());
				}
			});
		}catch (Exception e){
			log.error("pushCustWx.template:"+template,e);
//			e.printStackTrace();
		}
	}

}
