package cn.haliaeetus.sendmessage.utils.weixin;

import cn.haliaeetus.sendmessage.bean.delivery.Delivery;
import cn.haliaeetus.sendmessage.controller.util.APIConfig;
import cn.haliaeetus.sendmessage.framework.util.StringUtil;
import cn.haliaeetus.sendmessage.service.BasicInfoService;
import cn.haliaeetus.sendmessage.service.impl.BasicInfoServiceImpl;
import com.fasterxml.jackson.databind.JsonNode;
import com.google.gson.JsonObject;

public class WxTool {
	
	private static final String wxTemplateId = APIConfig.getWxTemplateId();
	
	
	private static BasicInfoService basicInfoService = new BasicInfoServiceImpl();
	
	public static String generateDeliveryInfo(String url, String topRemark, String remarkStr, String openId, String expName, String expCode){
		JsonObject entity = new JsonObject();
		entity.addProperty("touser", openId);
		entity.addProperty("template_id",wxTemplateId);
		if (StringUtil.isNotEmpty(url))
			entity.addProperty("url",url);
		else
			entity.addProperty("url","");
		entity.addProperty("topcolor","#ffb64b");

		JsonObject data = new JsonObject();

		JsonObject first = new JsonObject();
		first.addProperty("value", topRemark + "\n");
		first.addProperty("color", StringUtil.isNotEmpty(remarkStr) ? "#999999" : "#ff9600" );
		data.add("first", first);

		JsonObject keyword1 = new JsonObject();
		keyword1.addProperty("value", expName);
		keyword1.addProperty("color","#999999");
		data.add("keyword1", keyword1);

		JsonObject keyword2 = new JsonObject();
		keyword2.addProperty("value", expCode);
		keyword2.addProperty("color","#999999");
		data.add("keyword2", keyword2);

		if( StringUtil.isNotEmpty(remarkStr) ){
			JsonObject remark = new JsonObject();
			remark.addProperty("value","\n" + remarkStr);
			remark.addProperty("color","#ff9600");
			data.add("remark",remark);
		}

		entity.add("data", data);
		return entity.toString();
	}

	public static String getOpenId(Delivery delivery){
		String openId = null;
		if(StringUtil.isNotEmpty(delivery.getUserPhone())){
			JsonNode jsonNode = basicInfoService.getUserByPhone(delivery.getUserPhone());
			if (jsonNode!=null){
	            openId = jsonNode.findValue("openId").asText();
			}
		}
		
		return openId;
	}
	
	public static String getUserId(Delivery delivery){
		String userId = null;
		if(StringUtil.isNotEmpty(delivery.getUserPhone())){
			JsonNode jsonNode = basicInfoService.getUserByPhone(delivery.getUserPhone());
			if (jsonNode!=null){
	            userId = jsonNode.findValue("id").asText();
			}
		}
		
		return userId;
	}
}
