package cn.haliaeetus.sendmessage.validate.constraints;

import javax.validation.Constraint;
import javax.validation.Payload;
import java.lang.annotation.*;

/**
 * @ClassName UserPhone
 * @Description
 * @Author SunJJ
 * @Date 2020/5/21 18:59
 * @Version V1.0
 **/
@Target({ElementType.METHOD, ElementType.FIELD, ElementType.ANNOTATION_TYPE})
@Retention(RetentionPolicy.RUNTIME)
@Constraint(validatedBy = UserPhoneValidator.class)
@Documented
public @interface UserPhonePattern {

    String message() default "手机号格式不合法";

    Class<?>[] groups() default {};

    Class<? extends Payload>[] payload() default {};

    String regexp() default "^0{0,1}1[3|4|5|6|7|8|9][0-9]{9}$";

    @Target({ElementType.METHOD, ElementType.FIELD, ElementType.ANNOTATION_TYPE, ElementType.CONSTRUCTOR, ElementType.PARAMETER})
    @Retention(RetentionPolicy.RUNTIME)
    @Documented
    @interface List {
        UserPhonePattern[] value();
    }

}
