package cn.haliaeetus.sendmessage.validate.constraints;

import cn.haliaeetus.sendmessage.constants.Constants;

import javax.validation.ConstraintValidator;
import javax.validation.ConstraintValidatorContext;

/**
 * @ClassName UserPhonePattern
 * @Description
 * @Author SunJJ
 * @Date 2020/5/21 19:00
 * @Version V1.0
 **/
public class UserPhoneValidator implements ConstraintValidator<UserPhonePattern, String> {

    private String pattern;
    private String message;

    @Override
    public void initialize(UserPhonePattern constraintAnnotation) {
        this.pattern = constraintAnnotation.regexp();
        this.message = constraintAnnotation.message();
    }

    @Override
    public boolean isValid(String s, ConstraintValidatorContext constraintValidatorContext) {
        if (null == s || s.trim().length() == 0) {
            return false;
        }
        boolean b = s.trim().matches(this.pattern) || s.equals(Constants.DEFAULT_MOBILE_KB);
        return b;
    }

}
